<?php
/* A Proximite - fichier de geocoding en masse des societe
 * Copyright (C) 2018       Inovea-conseil.com     <info@inovea-conseil.com>
 */
require_once DOL_DOCUMENT_ROOT.'/core/class/extrafields.class.php';
require_once DOL_DOCUMENT_ROOT . '/societe/class/societe.class.php';
require_once(DOL_DOCUMENT_ROOT."/core/lib/company.lib.php");
include_once __DIR__ . '/gmaps_all.php';
$adderrors = array();

//recherche des tiers ne disposant pas de coordonnées GPS
$sql="SELECT s.* FROM ".MAIN_DB_PREFIX."societe as s 
LEFT JOIN ".MAIN_DB_PREFIX."societe_extrafields as e ON s.rowid = e.fk_object
WHERE (e.lat_prox IS NULL OR e.long_prox IS NULL) AND s.entity = " .$conf->entity;

$resql=$db->query($sql);
if ($resql)
{
    
    $extrafields = new ExtraFields($db);
    $extralabels=$extrafields->fetch_name_optionals_label('societe', true);
    
    $num=$db->num_rows($resql);
    
    $i=0;
    $geoOK = 0;
    while ($i < $num) {
        
        $obj=$db->fetch_object($resql);
        
        //if (empty($obj->country_code)) $obj->country_code=$mysoc->country_code;

        $error='';

        $addresstosearch=dol_format_address($obj,1," ");
        
        // geocode l'adresse
        
        $societe = new Societe($db);
        $societe->fetch($obj->rowid);
        $societe->fetch_optionals($obj->rowid,$extralabels);
        
        //$extrafields->setOptionalsFromPost(array('lat_prox' => 1, 'long_prox' => 2),$societe);
        
        if (strlen(trim($addresstosearch)) > 2) {
            $geo = geocoding($addresstosearch);
            if (is_array($geo)) {
                $societe->array_options['options_lat_prox'] = $geo['lat'];
                $societe->array_options['options_long_prox'] = $geo['lng'];

                $societe->update($obj->rowid);

                $geoOK++;
            } elseif($geo == 'REQUEST_DENIED') {
                setEventMessages($langs->trans("ERRORGEOCODING") . ' : ' . $geo, null, 'errors');
                break;
            } elseif($geo == 'OVER_QUERY_LIMIT') {
                setEventMessages($langs->trans("ERRORGEOCODING") . ' : ' . $geo, null, 'errors');
                break;
            } else {
                $obj->error = $geo;
                $obj->error_code = $geo;
                $adderrors[] = $obj;
            }
        } else {
            $obj->error = 'incomplete address';
            $obj->error_code = 'incomplete_address';
            $adderrors[] = $obj;
        }
        $i++;
    }
    
    if ($num == $geoOK) {
        setEventMessages($langs->trans("GEOCODEOK"), null, 'mesgs');
    } else {
        setEventMessages($langs->trans("GEOCODEPARTIEL"), null, 'warnings');
    }
    
}