<?php
/* <one line to give the program's name and a brief idea of what it does.>
 * Copyright (C) 2015 ATM Consulting <support@atm-consulting.fr>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * 	\file		admin/cliacobal.php
 * 	\ingroup	cliacobal
 * 	\brief		This file is an example module setup page
 * 				Put some comments here
 */
// Dolibarr environment
$res = @include("../../main.inc.php"); // From htdocs directory
if (! $res) {
    $res = @include("../../../main.inc.php"); // From "custom" directory
}

// Libraries
require_once DOL_DOCUMENT_ROOT . "/core/lib/admin.lib.php";
require_once '../lib/cliacobal.lib.php';

// Translations
$langs->load("cliacobal@cliacobal");

// Access control
if (! $user->admin) {
    accessforbidden();
}

// Parameters
$action = GETPOST('action', 'alpha');

/*
 * Actions
 */
if (preg_match('/set_(.*)/',$action,$reg))
{
	$code=$reg[1];
	if ($code == 'ACOBAL_PREFILTER_WAREHOUSE')
	{
	    if (dolibarr_set_const($db, $code, serialize(GETPOST($code)), 'chaine', 0, '', $conf->entity) > 0)
	    {
	        header("Location: ".$_SERVER["PHP_SELF"]);
	        exit;
	    }
	}
	elseif ($code == 'ACOBAL_XPO_FTP_CONF')
	{
	    $res = dolibarr_set_const($db, "ACOBAL_XPO_FTP_HOST", GETPOST("ACOBAL_XPO_FTP_HOST"), 'chaine', 0, '', $conf->entity);
	    $res = dolibarr_set_const($db, "ACOBAL_XPO_FTP_PORT", GETPOST("ACOBAL_XPO_FTP_PORT"), 'chaine', 0, '', $conf->entity);
	    $res = dolibarr_set_const($db, "ACOBAL_XPO_FTP_USER", GETPOST("ACOBAL_XPO_FTP_USER"), 'chaine', 0, '', $conf->entity);
	    $res = dolibarr_set_const($db, "ACOBAL_XPO_FTP_PASS", GETPOST("ACOBAL_XPO_FTP_PASS"), 'chaine', 0, '', $conf->entity);
	    //$res = dolibarr_set_const($db, "ACOBAL_XPO_FTP_DIR", GETPOST("ACOBAL_XPO_FTP_DIR"), 'chaine', 0, '', $conf->entity);
	    
	    header("Location: ".$_SERVER["PHP_SELF"]);
	    exit;
	}
	elseif (dolibarr_set_const($db, $code, GETPOST($code), 'chaine', 0, '', $conf->entity) > 0)
	{
		header("Location: ".$_SERVER["PHP_SELF"]);
		exit;
	}
	else
	{
		dol_print_error($db);
	}
}
	
if (preg_match('/del_(.*)/',$action,$reg))
{
	$code=$reg[1];
	if (dolibarr_del_const($db, $code, 0) > 0)
	{
		Header("Location: ".$_SERVER["PHP_SELF"]);
		exit;
	}
	else
	{
		dol_print_error($db);
	}
}

/*
 * View
 */
$page_name = "CliAcobalSetup";
llxHeader('', $langs->trans($page_name));

// Subheader
$linkback = '<a href="' . DOL_URL_ROOT . '/admin/modules.php">'
    . $langs->trans("BackToModuleList") . '</a>';
print_fiche_titre($langs->trans($page_name), $linkback);

// Configuration header
$head = cliacobalAdminPrepareHead();
dol_fiche_head(
    $head,
    'settings',
    $langs->trans("Module104057Name"),
    0,
    "cliacobal@cliacobal"
);

if ($conf->use_javascript_ajax) {
    print ' <script type="text/javascript">';
    print 'window.fnDisplayFtpXPO=function() {$( "#FtpXPO" ).show();};' . "\n";
    print 'window.fnHideFtpXPO=function() {$( "#FtpXPO" ).hide();$( "#FtpXPOConf" ).hide()};' . "\n";
    print 'window.fnDisplayFtpXPOConf=function() {$( "#FtpXPOConf" ).show();};' . "\n";
    print 'window.fnHideFtpXPOConf=function() {$( "#FtpXPOConf" ).hide();};' . "\n";
    print ' </script>';
}

// Setup page goes here
$form=new Form($db);
$var=false;
print '<table class="noborder" width="100%">';
print '<tr class="liste_titre">';
print '<td>'.$langs->trans("Parameters").'</td>'."\n";
print '<td align="center" width="20">&nbsp;</td>';
print '<td align="center" >'.$langs->trans("Value").'</td>'."\n";
print '</tr>';

// Nb de jour de décalage event
$var=!$var;
print '<tr '.$bc[$var].'>';
print '<td>'.$langs->trans("ACOBAL_NB_DAY_EVENT").'</td>';
print '<td align="center" width="20">&nbsp;</td>';
print '<td align="right" >';
print '<form method="POST" action="'.$_SERVER['PHP_SELF'].'">';
print '<input type="hidden" name="token" value="'.$_SESSION['newtoken'].'">';
print '<input type="hidden" name="action" value="set_ACOBAL_NB_DAY_EVENT">';
$nb_day = empty($conf->global->ACOBAL_NB_DAY_EVENT) ? 7 : (int)$conf->global->ACOBAL_NB_DAY_EVENT;

print '<input type="number" name="ACOBAL_NB_DAY_EVENT" value="'.$nb_day.'">';
print '<input type="submit" class="button" value="'.$langs->trans("Modify").'">';
print '</form>';
print '</td></tr>';

// titre de l'event
$var=!$var;
print '<tr '.$bc[$var].'>';
print '<td>'.$langs->trans("ACOBAL_TITLE_EVENT").'</td>';
print '<td align="center" width="20">&nbsp;</td>';
print '<td align="right">';
print '<form method="POST" action="'.$_SERVER['PHP_SELF'].'">';
print '<input type="hidden" name="token" value="'.$_SESSION['newtoken'].'">';
print '<input type="hidden" name="action" value="set_ACOBAL_TITLE_EVENT">';
print '<input type="text" size="80" name="ACOBAL_TITLE_EVENT" value="'.$conf->global->ACOBAL_TITLE_EVENT.'">';
print '<input type="submit" class="button" value="'.$langs->trans("Modify").'">';
print '</form>';
print '</td></tr>';

// contenu de l'event
$var=!$var;
print '<tr '.$bc[$var].'>';
print '<td>'.$langs->trans("ACOBAL_CONTENT_EVENT").'</td>';
print '<td align="center" width="20">&nbsp;</td>';
print '<td align="right">';
print '<form method="POST" action="'.$_SERVER['PHP_SELF'].'">';
print '<input type="hidden" name="token" value="'.$_SESSION['newtoken'].'">';
print '<input type="hidden" name="action" value="set_ACOBAL_CONTENT_EVENT">';

dol_include_once('/core/class/doleditor.class.php');
$doleditor = new DolEditor('ACOBAL_CONTENT_EVENT',$conf->global->ACOBAL_CONTENT_EVENT);
$doleditor->cols=60;
print $doleditor->Create(1,'',0,$langs->trans("ACOBAL_CONTENT_EVENT"));
print '<div align="right"><input type="submit" class="button" value="'.$langs->trans("Modify").'"></div>';
print '</form>';
print '</td></tr>';

// selection des entrepots prédéfini pour le filtrage de replenish custom
$var=!$var;
print '<tr '.$bc[$var].'>';
print '<td>'.$langs->trans("ACOBAL_PREFILTER_WAREHOUSE").'</td>';
print '<td align="center" width="20">&nbsp;</td>';
print '<td align="right" >';
print '<form method="POST" action="'.$_SERVER['PHP_SELF'].'">';
print '<input type="hidden" name="token" value="'.$_SESSION['newtoken'].'">';
print '<input type="hidden" name="action" value="set_ACOBAL_PREFILTER_WAREHOUSE">';
print selectMultiWarehouses(unserialize($conf->global->ACOBAL_PREFILTER_WAREHOUSE), 'ACOBAL_PREFILTER_WAREHOUSE');
print '<input type="submit" class="button" value="'.$langs->trans("Modify").'">';
print '</form>';
print '</td></tr>';

// On/Off Workflow génération des BL à la cloture de expé
$var = ! $var;
print '<tr ' . $bc[$var] . '>';
print '<td>' . $langs->trans("set_ACOBAL_CREATE_DELIVERY_FROM_CLOSED_SHIPPING") . '</td>';
print '<td align="center" width="20">&nbsp;</td>';
print '<td align="right" width="300">';
print '<form method="POST" action="' . $_SERVER['PHP_SELF'] . '">';
print '<input type="hidden" name="token" value="' . $_SESSION['newtoken'] . '">';
print '<input type="hidden" name="action" value="ACOBAL_CREATE_DELIVERY_FROM_CLOSED_SHIPPING">';
echo ajax_constantonoff('ACOBAL_CREATE_DELIVERY_FROM_CLOSED_SHIPPING');
print '</form>';
print '</td></tr>';

// Poids d'une palette pour calcul des poids brut BL
$var=!$var;
print '<tr '.$bc[$var].'>';
print '<td>'.$langs->trans("ACOBAL_PAL_WEIGHT").'</td>';
print '<td align="center" width="20">&nbsp;</td>';
print '<td align="right" >';
print '<form method="POST" action="'.$_SERVER['PHP_SELF'].'">';
print '<input type="hidden" name="token" value="'.$_SESSION['newtoken'].'">';
print '<input type="hidden" name="action" value="set_ACOBAL_PAL_WEIGHT">';
$pal_weight = floatval($conf->global->ACOBAL_PAL_WEIGHT);

print '<input type="number" name="ACOBAL_PAL_WEIGHT" value="'.$pal_weight.'" min="0" step="0.1">';
print '<input type="submit" class="button" value="'.$langs->trans("Modify").'">';
print '</form>';
print '</td></tr>';

// Poids d'un colis pour calcul des poids brut BL
$var=!$var;
print '<tr '.$bc[$var].'>';
print '<td>'.$langs->trans("ACOBAL_COL_WEIGHT").'</td>';
print '<td align="center" width="20">&nbsp;</td>';
print '<td align="right" >';
print '<form method="POST" action="'.$_SERVER['PHP_SELF'].'">';
print '<input type="hidden" name="token" value="'.$_SESSION['newtoken'].'">';
print '<input type="hidden" name="action" value="set_ACOBAL_COL_WEIGHT">';
$col_weight = floatval($conf->global->ACOBAL_COL_WEIGHT);

print '<input type="number" name="ACOBAL_COL_WEIGHT" value="'.$col_weight.'" min="0" step="0.1">';
print '<input type="submit" class="button" value="'.$langs->trans("Modify").'">';
print '</form>';
print '</td></tr>';

// On/Off Workflow génération export XPO à la cloture d'une expé
$var = ! $var;
print '<tr ' . $bc[$var] . '>';
print '<td>' . $langs->trans("set_ACOBAL_XPO_EXPORT_FROM_CLOSED_SHIPPING") . '</td>';
print '<td align="center" width="20">&nbsp;</td>';
print '<td align="right" width="300">';
if ($conf->use_javascript_ajax) {
    $input_array = array (
        'alert' => array (
            'set' => array (
                'content' => $langs->trans('AcobalConfirmChangeState'),
                'title' => $langs->trans('AcobalConfirmChangeState'),
                'method' => 'fnDisplayFtpXPO',
                'yesButton' => $langs->trans('Yes'),
                'noButton' => $langs->trans('No')
            ),
            'del' => array (
                'content' => $langs->trans('AcobalConfirmChangeState'),
                'title' => $langs->trans('AcobalConfirmChangeState'),
                'method' => 'fnHideFtpXPO',
                'yesButton' => $langs->trans('Yes'),
                'noButton' => $langs->trans('No')
            )
        )
    );
    
    print ajax_constantonoff('ACOBAL_XPO_EXPORT_FROM_CLOSED_SHIPPING', $input_array);
} else {
    $arrval = array (
        '0' => $langs->trans("No"),
        '1' => $langs->trans("Yes")
    );
    print $form->selectarray("ACOBAL_XPO_EXPORT_FROM_CLOSED_SHIPPING", $arrval, $conf->global->ACOBAL_XPO_EXPORT_FROM_CLOSED_SHIPPING);
}
print '</td>';
print '</tr>';

print "<tr>";
print "<td>Domaine autorisé pour l'envoi ftp <br />- Si le domaine est différent de celui-ci, les fichiers ne seront pas envoyés<br />- Vous pouvez ajouter plusieurs domaines en les séparant par un point-virgule";
if (!in_array($_SERVER['HTTP_HOST'], explode(';', $conf->global->ACOBAL_HOST_SENDING_FTP))) print "<br /><strong>Le serveur actuel n'enverra pas les fichiers</strong>";
print "</td>";
print '<td align="center" width="20">&nbsp;</td>';
print '<td align="right" width="300">';

print '<form method="POST" action="'.$_SERVER['PHP_SELF'].'">';
print '<input type="hidden" name="token" value="'.$_SESSION['newtoken'].'">';
print '<input type="hidden" name="action" value="set_ACOBAL_HOST_SENDING_FTP">';

print '<input type="text" name="ACOBAL_HOST_SENDING_FTP" value="'.$conf->global->ACOBAL_HOST_SENDING_FTP.'" min="0" step="0.1">';
print '<input type="submit" class="button" value="'.$langs->trans("Modify").'">';
print '</form>';

print "</td>";
print "<tr>";

// On/Off Workflow génération envoie ftp à XPO du fichier généré au dessus
if ($conf->use_javascript_ajax) {
    
    print '<tr id ="FtpXPO" ' . $bc[$var] . '><td>' . $langs->trans("set_ACOBAL_XPO_FTP_FROM_CLOSED_SHIPPING") . '</td>';
    print '<td align="center" width="20">&nbsp;</td>';
    print '<td align="right" width="300">';
    
    $input_array = array (
        'alert' => array (
            'set' => array (
                'content' => $langs->trans('AcobalConfirmChangeState'),
                'title' => $langs->trans('AcobalConfirmChangeState'),
                'method' => 'fnDisplayFtpXPOConf',
                'yesButton' => $langs->trans('Yes'),
                'noButton' => $langs->trans('No')
            ),
            'del' => array (
                'content' => $langs->trans('AcobalConfirmChangeState'),
                'title' => $langs->trans('AcobalConfirmChangeState'),
                'method' => 'fnHideFtpXPOConf',
                'yesButton' => $langs->trans('Yes'),
                'noButton' => $langs->trans('No')
            )
        )
    );
    
    print ajax_constantonoff('ACOBAL_XPO_FTP_FROM_CLOSED_SHIPPING', $input_array);
    print '</td>';
    print '</tr>';
    
    if (! empty($conf->global->ACOBAL_XPO_EXPORT_FROM_CLOSED_SHIPPING)) {
        print ' <script type="text/javascript">';
        print '$( "#FtpXPO" ).show()';
        print ' </script>';
    } else {
        print ' <script type="text/javascript">';
        print '$( "#FtpXPO" ).hide()';
        print ' </script>';
    }
} else {
    if (! empty($conf->global->ACOBAL_XPO_EXPORT_FROM_CLOSED_SHIPPING)) {
        $var = ! $var;
        print '<tr id ="FtpXPO" ' . $bc[$var] . '>';
        print '<td>' . $langs->trans("set_ACOBAL_XPO_FTP_FROM_CLOSED_SHIPPING") . '</td>';
        print '<td align="center" width="20">&nbsp;</td>';
        print '<td align="right" width="300">';
        $arrval = array (
            '0' => $langs->trans("No"),
            '1' => $langs->trans("Yes")
        );
        print $form->selectarray("ACOBAL_XPO_FTP_FROM_CLOSED_SHIPPING", $arrval, $conf->global->ACOBAL_XPO_FTP_FROM_CLOSED_SHIPPING);
        print '</td></tr>';
    }
}

if ($conf->use_javascript_ajax) {
    
    print '<tr id ="FtpXPOConf" ' . $bc[$var] . '><td>' . $langs->trans("ACOBAL_XPO_FTP_CONF") . '</td>';
    print '<td align="center" width="20">&nbsp;</td>';
    print '<td align="right" width="300">';
    print '<form method="POST" action="'.$_SERVER['PHP_SELF'].'">';
    print '<input type="hidden" name="token" value="'.$_SESSION['newtoken'].'">';
    print '<input type="hidden" name="action" value="set_ACOBAL_XPO_FTP_CONF">';
    print $langs->trans("ACOBAL_XPO_FTP_HOST").' : <input type="text" size="30" name="ACOBAL_XPO_FTP_HOST" value="'.$conf->global->ACOBAL_XPO_FTP_HOST.'"><BR>';
    print $langs->trans("ACOBAL_XPO_FTP_PORT").' : <input type="text" size="30" name="ACOBAL_XPO_FTP_PORT" value="'.$conf->global->ACOBAL_XPO_FTP_PORT.'"><BR>';
    print $langs->trans("ACOBAL_XPO_FTP_USER").' : <input type="text" size="30" name="ACOBAL_XPO_FTP_USER" value="'.$conf->global->ACOBAL_XPO_FTP_USER.'"><BR>';
    print $langs->trans("ACOBAL_XPO_FTP_PASS").' : <input type="text" size="30" name="ACOBAL_XPO_FTP_PASS" value="'.$conf->global->ACOBAL_XPO_FTP_PASS.'"><BR>';
    //print $langs->trans("ACOBAL_XPO_FTP_DIR").' : <input type="text" size="30" name="ACOBAL_XPO_FTP_DIR" value="'.$conf->global->ACOBAL_XPO_FTP_DIR.'"><BR>';
    print '<BR><input type="submit" class="button" value="'.$langs->trans("Modify").'">';
    print '</form>';
    print '</td>';
    print '</tr>';
    
    if (! empty($conf->global->ACOBAL_XPO_FTP_FROM_CLOSED_SHIPPING)) {
        print ' <script type="text/javascript">';
        print '$( "#FtpXPOConf" ).show()';
        print ' </script>';
    } else {
        print ' <script type="text/javascript">';
        print '$( "#FtpXPOConf" ).hide()';
        print ' </script>';
    }
} else {
    if (! empty($conf->global->ACOBAL_XPO_FTP_FROM_CLOSED_SHIPPING)) {
        $var = ! $var;
        print '<tr id ="FtpXPOConf" ' . $bc[$var] . '>';
        print '<td>' . $langs->trans("set_ACOBAL_XPO_FTP_FROM_CLOSED_SHIPPING") . '</td>';
        print '<td align="center" width="20">&nbsp;</td>';
        print '<td align="right" width="300">';
        print '<form method="POST" action="'.$_SERVER['PHP_SELF'].'">';
        print '<input type="hidden" name="token" value="'.$_SESSION['newtoken'].'">';
        print '<input type="hidden" name="action" value="set_ACOBAL_XPO_FTP_CONF">';
        print $langs->trans("ACOBAL_XPO_FTP_HOST").' : <input type="text" size="30" name="ACOBAL_XPO_FTP_HOST" value="'.$conf->global->ACOBAL_XPO_FTP_HOST.'"><BR>';
        print $langs->trans("ACOBAL_XPO_FTP_PORT").' : <input type="text" size="30" name="ACOBAL_XPO_FTP_PORT" value="'.$conf->global->ACOBAL_XPO_FTP_PORT.'"><BR>';
        print $langs->trans("ACOBAL_XPO_FTP_USER").' : <input type="text" size="30" name="ACOBAL_XPO_FTP_USER" value="'.$conf->global->ACOBAL_XPO_FTP_USER.'"><BR>';
        print $langs->trans("ACOBAL_XPO_FTP_PASS").' : <input type="text" size="30" name="ACOBAL_XPO_FTP_PASS" value="'.$conf->global->ACOBAL_XPO_FTP_PASS.'"><BR>';
        print $langs->trans("ACOBAL_XPO_FTP_DIR").' : <input type="text" size="30" name="ACOBAL_XPO_FTP_DIR" value="'.$conf->global->ACOBAL_XPO_FTP_DIR.'"><BR>';
        print '<BR><input type="submit" class="button" value="'.$langs->trans("Modify").'">';
        print '</form>';
        print '</td></tr>';
    }
}
print '</table>';


llxFooter();

$db->close();

function selectMultiWarehouses($selected=array(), $htmlName='multiwarehouse')
{
    global $db, $form;
    
    dol_include_once('/product/class/html.formproduct.class.php');
    $f = new FormProduct($db);
    $ret = $f->loadWarehouses(0, '', '', true);
    
    $array = array();
    if($ret > 0)
    {
        foreach($f->cache_warehouses as $id => $arraytypes)
        {
            $array[$id] = $arraytypes['label'];
        }
    }
    
    return $form->multiselectarray($htmlName, $array, $selected, 0, 0, '', 0, "150px");
}