<?php
/* <one line to give the program's name and a brief idea of what it does.>
 * Copyright (C) 2015 ATM Consulting <support@atm-consulting.fr>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * \file    class/actions_cliacobal.class.php
 * \ingroup cliacobal
 * \brief   This file is an example hook overload class file
 *          Put some comments here
 */

/**
 * Class ActionsCliAcobal
 */
class ActionsCliAcobal
{
	/**
	 * @var array Hook results. Propagated to $hookmanager->resArray for later reuse
	 */
	public $results = array();

	/**
	 * @var string String displayed by executeHook() immediately after return
	 */
	public $resprints;

	/**
	 * @var array Errors
	 */
	public $errors = array();

	/**
	 * Constructor
	 */
	public function __construct()
	{
	}

	/**
	 * Overloading the doActions function : replacing the parent's function with the one below
	 *
	 * @param   array()         $parameters     Hook metadatas (context, etc...)
	 * @param   CommonObject    &$object        The object to process (an invoice if you are in invoice module, a propale in propale's module, etc...)
	 * @param   string          &$action        Current action (if set). Generally create or edit or null
	 * @param   HookManager     $hookmanager    Hook manager propagated to allow calling another hook
	 * @return  int                             < 0 on error, 0 on success, 1 to replace standard code
	 */
	function doActions($parameters, &$object, &$action, $hookmanager)
	{
	    global $db;

	    if (in_array('stockreplenishlist', explode(':', $parameters['context'])))
		{
		    header('location:'.dol_buildpath('/cliacobal/customreplenish.php', 1));
// 		    print dol_buildpath('/cliacobal/customreplenish.php', 1);
		    exit;
		}

		if (in_array('expeditioncard', explode(':', $parameters['context'])))
		{
		    if (empty($object->array_options['options_typo_expe']))
		    {
		        global $object;
		        $object->array_options['options_typo_expe'] = 1;
		        $object->update($user);
		    }
		}


	}

	function printFieldListWhere($parameters)
	{
	    if (in_array('shipmentlist', explode(':', $parameters['context'])))
	    {
	        global $sql, $search_array_options, $extrafields;

    	    foreach ($search_array_options as $key => $val)
    	    {
    	        $crit=$val;
    	        $tmpkey=preg_replace('/search_options_/','',$key);
    	        $typ=$extrafields->attribute_type[$tmpkey];
    	        if($typ == 'date' && !preg_match("/^[0-9]{4}-[0-9]{2}-[0-9]{2}$/", $search_array_options[$key]) && !empty($crit)) {
    	            $search_array_options[$key] = date('Y-m-d', $crit);
    	            $sql = preg_replace("/ef\.".$tmpkey." LIKE '%".$crit."%'/", "ef.".$tmpkey." = '".$search_array_options[$key]."'", $sql);
    	        }
    	    }
	    }

	}

	function formObjectOptions($parameters,$expe,$action)
	{
	   if (in_array('expeditioncard', explode(':', $parameters['context'])))
	   {
	       if ($action == 'create')
	       {
	            global $object;
                $object->array_options['options_typo_expe'] = 1;
	       }
	   }
	}

	function pdf_build_address($parameters, &$object, $action, &$hookmanager)
	{

	    foreach($parameters as $key => $value) {
	        $$key = $value;
	    }

	    if ($mode == 'source')
	    {
	        // Comme on refait appel à pdf_build_address ci-dessous, on empêche une boucle infinie d'appels de hooks
	        if(! empty($hookmanager->_sourceAddressRegenerated))
            {
                return 0;
            }

		    $hookmanager->_sourceAddressRegenerated = true;

	        // On récupère la chaîne générée par défaut pour la compléter, pour éviter de copier/coller du code
	        $stringaddress = pdf_build_address($outputlangs, $sourcecompany, $targetcompany, $targetcontact, $usecontact, $mode, $object);

	        if ($usecontact)
	        {
	            $stringaddress .= ($stringaddress ? "\n" : '' ).$outputlangs->convToOutputCharset('Contact : ').$outputlangs->convToOutputCharset($targetcontact->getFullName($outputlangs,1));

                // Phone
	            if (! empty($targetcontact->office_phone) || ! empty($targetcontact->user_mobile)) $stringaddress .= ($stringaddress ? "\n" : '' ).$outputlangs->transnoentities("Phone").": ";
	            if (! empty($targetcontact->office_phone)) $stringaddress .= $outputlangs->convToOutputCharset($targetcontact->office_phone);
	            if (! empty($targetcontact->office_phone) && ! empty($targetcontact->user_mobile)) $stringaddress .= " / ";
	            if (! empty($targetcontact->user_mobile)) $stringaddress .= $outputlangs->convToOutputCharset($targetcontact->user_mobile);
                // EMail
                if ($targetcontact->email) $stringaddress .= ($stringaddress ? "\n" : '' ).$outputlangs->transnoentities("Email").": ".$outputlangs->convToOutputCharset($targetcontact->email);
	        }

	        $this->resprints = $stringaddress;

	        return 1;
	    }

		// T1261 : En cas de sélection d'un "contact client envoi facturation" pour une facture client, faire en sorte que :
		//     - l'encart "adressé à" fasse apparaître les information du contact associé à ce type
		//     - ajouter dans la note publique l'adresse du "contact client facturation" si un contact est associé à ce type,
		//       si non on affiche l'adresse du tiers associé à la facture
		//
		// Ici, on réalise le premier point qui a été préparé dans le hook beforePDFCreation
        if($mode == 'target' && $object->element == 'facture' && empty($hookmanager->_generateAddressForPublicNote))
        {
	        $arrayidcontact = $object->getIdContact('external', 'BILLING_EXP');

	        // Si aucun contact de type BILLING_EXP, il n'y a rien à faire
	        if(empty($arrayidcontact))
	        {
		        return 0;
	        }

	        // Comme on refait appel à pdf_build_address ci-dessous, on empêche une boucle infinie d'appels de hooks
	        if (! empty($hookmanager->_invoiceTargetAddressRegenerated))
	        {
		        return 0;
	        }

	        $hookmanager->_invoiceTargetAddressRegenerated = true;

	        global $conf, $mysoc;

	        // Lors de la préparation dans le hook beforePDFCreation, on a overridé le tiers et la conf pour que le bon
            // nom de société s'affiche => on remet les données d'origine
            if(! empty($hookmanager->_MAIN_USE_COMPANY_NAME_OF_CONTACT_overriden))
            {
	            $conf->global->MAIN_USE_COMPANY_NAME_OF_CONTACT = 1;
	            $object->fetch_thirdparty(); // se base sur l'attribut socid, qui, lui, n'a pas été modifié
            }


            $usecontact = true;
		    $result = $object->fetch_contact($arrayidcontact[0]);

	        $this->resprints = pdf_build_address($outputlangs, $mysoc, $object->thirdparty, $object->contact, $usecontact, 'target', $object);

            return 1;
        }

	    return 0;
	}

	function pdf_writelinedesc($parameters, &$object, &$action, $hookmanager)
	{
	    global $conf, $db, $langs;

	    if ($conf->subtotal->enabled)
	    {
	        dol_include_once('/subtotal/class/subtotal.class.php');
	        if (TSubtotal::isModSubtotalLine($object->lines[$parameters['i']])) return 0;
	    }

	    if (in_array('pdfgeneration', explode(':', $parameters['context'])) && $object->element == 'propal')
	    {
	        foreach($parameters as $key => $value) {
	            $$key = $value;
	        }

	        $desc = pdf_getlinedesc($object, $i, $outputlangs, $hideref, $hidedesc, $issupplierline);
	        $prodser = new Product($db);
	        if (!empty($object->lines[$i]->fk_product)) $prodser->fetch($object->lines[$i]->fk_product);

	        if(! empty($prodser->multilangs['fr_FR']["description"]) && !empty($prodser->multilangs[$outputlangs->defaultlang]["description"]) && strpos($desc, $prodser->multilangs['fr_FR']["description"]) !== false)
	        {
	            $desc = str_replace($prodser->multilangs['fr_FR']["description"], $prodser->multilangs[$outputlangs->defaultlang]["description"], $desc);
	            $desc = str_replace(htmlentities('Nomenclature douanière / Code SH'), '('.$outputlangs->trans('CustomCode'), $desc);
	        }

			//PRAGMATECH ticket TS2105-0014
			$out = $this->_customCustomerRef($object, $i, $desc);			  
	        $pdf->writeHTMLCell($w, $h, $posx, $posy, $outputlangs->convToOutputCharset($out), 0, 1, false, true, 'J',true);

	        $this->resprints = $out;

			//PRAGMATECH ticket TS2105-0014					 
	        return 1;
	    }

	    if (in_array('pdfgeneration', explode(':', $parameters['context'])) && $object->element == 'commande')
	    {
	        $ret = $this->_addExtrafieldToPDFLineDesc($parameters, $object, 'date_de_livraison');
	        if ($ret) return $ret;
	        else {
	            foreach($parameters as $key => $value) {
	                $$key = $value;
	            }

	            $desc = pdf_getlinedesc($object, $i, $outputlangs, $hideref, $hidedesc, $issupplierline);
	            $out = $this->_customCustomerRef($object, $i, $desc);

	            $pdf->writeHTMLCell($w, $h, $posx, $posy, $outputlangs->convToOutputCharset($out), 0, 1, false, true, 'J',true);

	            $this->resprints = $out;

	            return 1;
	        }
	    }

	    if (in_array('pdfgeneration', explode(':', $parameters['context'])) && ($object->element == 'facture' || $object->element == 'delivery'))
	    {
	        foreach($parameters as $key => $value) {
	            $$key = $value;
	        }

	        $desc = pdf_getlinedesc($object, $i, $outputlangs, $hideref, $hidedesc, $issupplierline);
	        $out = $this->_customCustomerRef($object, $i, $desc);
	        if ($object->element == 'delivery') {
//	            $out = $this->_showCustomCode($object, $i, $out);
	            $out = $this->_showProductBatch($object, $i, $out);
	        }

	        $pdf->writeHTMLCell($w, $h, $posx, $posy, $outputlangs->convToOutputCharset($out), 0, 1, false, true, 'J',true);

	        $this->resprints = $out;

	        return 1;
	    }

	    if (in_array('pdfgeneration', explode(':', $parameters['context'])) && $object->element == 'order_supplier')
	    {
	        return $this->_addExtrafieldToPDFLineDesc($parameters, $object, 'date_livraison_souhaitee', 1);
	    }

	    if (in_array('pdfgeneration', explode(':', $parameters['context'])) && $object->element == 'facture')
	    {
	        foreach($parameters as $key => $value) {
	            $$key = $value;
	        }

	        $desc = pdf_getlinedesc($object, $i, $outputlangs, $hideref, $hidedesc, $issupplierline);
	        $out = $this->_customCustomerRef($object, $i, $desc);

	        $pdf->writeHTMLCell($w, $h, $posx, $posy, $outputlangs->convToOutputCharset($out), 0, 1, false, true, 'J',true);

	        $this->resprints = $out;

	        return 1;
	    }

	    return 0;
	}


	function beforePDFCreation($parameters, &$object, &$action, $hookmanager)
    {
        global $conf;

        // T1261 : En cas de sélection d'un "contact client envoi facturation" pour une facture client, faire en sorte que :
	    //     - l'encart "adressé à" fasse apparaître les information du contact associé à ce type
	    //     - ajouter dans la note publique l'adresse du "contact client facturation" si un contact est associé à ce type,
        //       si non on affiche l'adresse du tiers associé à la facture
        //
        // Ici, on réalise la seconde partie et on prépare la première (qui est réalisée dans le hook pdf_build_address)
        if($object->element == 'facture' && empty($conf->global->ACOBAL_DISABLE_CONTACT_ADRESS_COPY_IN_NOTE))
        {
	        $arrayidcontactbillingexp = $object->getIdContact('external','BILLING_EXP');

	        // Si aucun contact de type BILLING_EXP, il n'y a rien à faire
	        if(empty($arrayidcontactbillingexp))
	        {
		        return 0;
	        }

	        global $mysoc;
	        $outputlangs = $parameters['outputlangs'];

	        // Code générique de pdf_crabe
	        $usecontact=false;
	        $arrayidcontact=$object->getIdContact('external', 'BILLING');
	        if (count($arrayidcontact) > 0)
	        {
		        $usecontact=true;
		        $result=$object->fetch_contact($arrayidcontact[0]);
	        }

	        //Recipient name
	        // On peut utiliser le nom de la societe du contact
	        if ($usecontact && !empty($conf->global->MAIN_USE_COMPANY_NAME_OF_CONTACT)) {
		        $thirdparty = $object->contact;
	        } else {
		        $thirdparty = $object->thirdparty;
	        }

	        $carac_client_name= pdfBuildThirdpartyName($thirdparty, $outputlangs);

	        // H4cK$ 4n0nym0u$-style : quelques modifications le temps de l'appel à pdf_build_address
            //     - on empêche l'appel du hook pdf_build_address fait pour l'encart "Récepteur" de s'exécuter
            //     - on force l'apparition du pays en vidant temporairement le champ correspondant de $mysoc
            //     - si on est sur le modèle Neopost, le numéro de TVA est imprimé séparément : on force la conf qui le cache
	        $hookmanager->_generateAddressForPublicNote = true;

	        $mysocCountryCode = $mysoc->country_code;
	        $mysoc->country_code = '';

	        $rollbackVAT = false;

	        if(empty($conf->global->MAIN_TVAINTRA_NOT_IN_ADDRESS))
	        {
		        $modelpdf = $object->modelpdf;

		        if (! empty($_REQUEST['model']))
		        {
			        $modelpdf = GETPOST('model');
		        }

		        if ($modelpdf == 'neopost')
		        {
			        $rollbackVAT = true;
			        $conf->global->MAIN_TVAINTRA_NOT_IN_ADDRESS = 1;
		        }
	        }

	        $carac_client = pdf_build_address($outputlangs, $mysoc, $object->thirdparty, ($usecontact ? $object->contact : ''), $usecontact, 'target', $object);

	        // On remet les données d'origine. Nous sommes légion, tout ça, tout ça
	        $mysoc->country_code = $mysocCountryCode;
	        unset($hookmanager->_generateAddressForPublicNote);
	        if($rollbackVAT)
	        {
		        $conf->global->MAIN_TVAINTRA_NOT_IN_ADDRESS = 0;
	        }

	        // Ça y est, on peut enfin mettre tout ça dans la note publique \o/
	        $object->note_public = 'Tiers facturé / livré :<br /><b>' . $carac_client_name . '</b><br />' . nl2br($carac_client) . (! empty($object->note_public) ? '<br /><br />' . $object->note_public : '');


	        // H4cK 4n0nym0u$-style : comme le nom du tiers dans l'encadré "Adressé à" est géré indépendemment de
            // l'adresse et n'est pas hooké, pour le forcer, on doit overrider le tiers associé à la facture ET désactiver
            // la conf qui fait utiliser les informations du contact. On remet les données d'origine dans le hook
            // pdf_build_adress, qui est exécuté juste après que le nom du tiers à imprimer soit déterminé
	        if(! empty($conf->global->MAIN_USE_COMPANY_NAME_OF_CONTACT))
	        {
		        $object->fetch_contact($arrayidcontactbillingexp[0]);
		        $object->contact->fetch_thirdparty();

		        $object->thirdparty = $object->contact->thirdparty;

	            $hookmanager->_MAIN_USE_COMPANY_NAME_OF_CONTACT_overriden = true;
	            $conf->global->MAIN_USE_COMPANY_NAME_OF_CONTACT = 0;
            }
        }
    }


	function _addExtrafieldToPDFLineDesc($parameters, &$object, $extrafieldToAdd, $issupplierline = 0)
	{
	    global $db, $langs;

	    foreach($parameters as $key => $value) {
	        $$key = $value;
	    }

	    if(empty($object->lines[$i]->array_options) && method_exists($object->lines[$i], 'fetch_optionals')) {
	        $object->lines[$i]->fetch_optionals();
	    }
	    if (!is_array($extrafieldToAdd)){
    	    if(! empty($object->lines[$i]->array_options['options_'.$extrafieldToAdd])) {

    	        dol_include_once('/core/class/extrafields.class.php');

    	        $extrafields = new ExtraFields($db);
    	        $extralabels = $extrafields->fetch_name_optionals_label($object->lines[$i]->element);
    	        //var_dump($extrafields->attribute_langfile[$extrafieldToAdd]);
    	        if(!empty($extrafields->attribute_langfile[$extrafieldToAdd])) $outputlangs->load($extrafields->attribute_langfile[$extrafieldToAdd]);

    	        $out = pdf_getlinedesc($object, $i, $outputlangs, $hideref, $hidedesc, $issupplierline);
    	        $out = $this->_customCustomerRef($object, $i, $out);
    	        $out.= '<br><br><table><tr>';
    	        $out.= '<td><b>'.$outputlangs->transnoentitiesnoconv($extralabels[$extrafieldToAdd]).'</b></td>';
    	        $out.= '<td><b>'.$extrafields->showOutputField($extrafieldToAdd, $object->lines[$i]->array_options['options_'.$extrafieldToAdd]).'</b><br></td>';
    	        $out.= '</tr></table>';

    	        $pdf->writeHTMLCell($w, $h, $posx, $posy, $outputlangs->convToOutputCharset($out), 0, 1, false, true, 'J',true);

    	        $this->resprints = $out;

    	        return 1;
    	    }
	    } elseif (count($extrafieldToAdd)) {
	        dol_include_once('/core/class/extrafields.class.php');

	        $extrafields = new ExtraFields($db);
	        $extralabels = $extrafields->fetch_name_optionals_label($object->lines[$i]->element);

	        $addtxt = '';

	        foreach ($extrafieldToAdd as $ef)
	        {
// 	            var_dump($ef, $extrafields->attribute_langfile);
	            if(! empty($object->lines[$i]->array_options['options_'.$ef])) {

	                if (!empty($extrafields->attribute_langfile[$ef])) $outputlangs->load($extrafields->attribute_langfile[$ef]);
	                $addtxt .= '<tr>';
	                $addtxt .= '<td>'.$outputlangs->transnoentitiesnoconv($extralabels[$ef]).'</td>';
	                $addtxt .= '<td>'.$extrafields->showOutputField($ef, $object->lines[$i]->array_options['options_'.$ef]).'</td>';
	                $addtxt .= '</tr>';
	            }
	        }

	        $out = pdf_getlinedesc($object, $i, $outputlangs, $hideref, $hidedesc, $issupplierline);
	        $out = $this->_customCustomerRef($object, $i, $out);
	        if(!empty($addtxt))
	        {
	            $out.= '<br><br><table>';
	            $out.= $addtxt;
	            $out.= '</table>';
	        }

	        $pdf->writeHTMLCell($w, $h, $posx, $posy, $outputlangs->convToOutputCharset($out), 0, 1, false, true, 'J',true);

	        $this->resprints = $out;

	        return 1;
	    }

	    return 0;
	}

	function addMoreActionsButtons($parameters, $object, $action)
	{
	    if (in_array('ordersuppliercard', explode(':', $parameters['context'])))
	    {
		// C'est grave vilain, à l'avenir l'idéal serait de faire en sorte que les valeurs par défaut des extrafields fonctionnent correctement...
		global $db;
		$extrafields = new Extrafields($db);
		$extrafields->fetch_name_optionals_label('commande_fournisseurdet');
		$val = $extrafields->attribute_default['date_livraison_annoncee'];
		
		// modif PRAGMATECH changement explode '/' en '-' et changement ordre champ des dates d m y en y m d 
		if(!empty($val)) {
			$tmp = explode('-', $val);
			$y = $tmp[0];
			$m = $tmp[1];
			$d = $tmp[2];
		}
		if(!empty($d)) {
		        ?>
		        <script type="text/javascript">
					$(document).ready(function(){
						if($('#options_date_livraison_annoncee') !== 'undefined')
						{
							$('#options_date_livraison_annoncee').val('<?php echo $d.'/'.$m.'/'.$y; ?>')

							$('#options_date_livraison_annonceeday').val('<?php echo $d; ?>');
							$('#options_date_livraison_annonceemonth').val('<?php echo $m; ?>');
							$('#options_date_livraison_annonceeyear').val('<?php echo $y; ?>');
						}
					});
		        </script>
		        <?php
		}
	    }
	}
	function createDictionaryFieldlist($parameters, $object, $action) {
		if($parameters['tabname'] == MAIN_DB_PREFIX.'c_xpo_package_type'){
			?>
			<script type="text/javascript">
				$(document).ready(function(){
					$('.liste_titre td:contains("Laize")').html($('.liste_titre td:contains("Laize")').html().replace("Laize","Longueur (mm)"));
					$('.liste_titre td:contains("Soufflet")').html($('.liste_titre td:contains("Soufflet")').html().replace("Soufflet","Largeur (mm)"));
					$('.liste_titre td:contains("Poids à vide")').html($('.liste_titre td:contains("Poids à vide")').html().replace("Poids à vide","Poids à vide (g)"));
					$('.liste_titre th:contains("Laize")').html($('.liste_titre th:contains("Laize")').html().replace("Laize","Longueur (mm)"));
					$('.liste_titre th:contains("Soufflet")').html($('.liste_titre th:contains("Soufflet")').html().replace("Soufflet","Largeur (mm)"));
					$('.liste_titre th:contains("Poids à vide")').html($('.liste_titre th:contains("Poids à vide")').html().replace("Poids à vide","Poids à vide (g)"));
				});
			</script>
			<?php
		}
		if($parameters['tabname'] == MAIN_DB_PREFIX.'c_xpo_palet_type') {
			?>
			<script type="text/javascript">
                $(document).ready(function(){
                    $('.liste_titre td:contains("Laize")').html($('.liste_titre td:contains("Laize")').html().replace("Laize","Longueur (cm)"));
                    $('.liste_titre td:contains("Soufflet")').html($('.liste_titre td:contains("Soufflet")').html().replace("Soufflet","Largeur (cm)"));
                    $('.liste_titre td:contains("Poids à vide")').html($('.liste_titre td:contains("Poids à vide")').html().replace("Poids à vide","Poids à vide (kg)"));
                    $('.liste_titre th:contains("Laize")').html($('.liste_titre th:contains("Laize")').html().replace("Laize","Longueur (cm)"));
                    $('.liste_titre th:contains("Soufflet")').html($('.liste_titre th:contains("Soufflet")').html().replace("Soufflet","Largeur (cm)"));
                    $('.liste_titre th:contains("Poids à vide")').html($('.liste_titre th:contains("Poids à vide")').html().replace("Poids à vide","Poids à vide (kg)"));

                });
			</script>
			<?php
		}
	}
	function _customCustomerRef(&$object, $i, $desc)
	{
	    global $db;

	    $prodid = $object->lines[$i]->fk_product;
	    $socid = $object->thirdparty->id;

	    $prod = new Product($db);
	    $out = '';

	    if (!empty($prodid))
	    {
	        $sqlref = "SELECT ref FROM ".MAIN_DB_PREFIX."custom_product_ref WHERE fk_soc='".$socid."' AND fk_product='".$prodid."'";
	        $res = $db->query($sqlref);
	        if($res && $db->num_rows($res))
	        {
	            $obj = $db->fetch_object($res);

	            $prod->fetch($prodid);
// 	            var_dump($obj); exit;
	            $out = str_replace($prod->ref, $prod->ref.' ('.$obj->ref.')', $desc);
	        }


	    }

	    return (!empty($out)) ? $out : $desc;
	}

	function _showCustomCode($object, $i, $desc)
	{
	    global $db, $langs;

	    $langs->load('products');

	    $prodid = $object->lines[$i]->fk_product;

	    $prod = new Product($db);
	    $out = '';

	    if (!empty($prodid))
	    {
	        $prod->fetch($prodid);
	        if (!empty($prod->customcode))
	        {
	            $out .= $desc;
	            $out .= "<br><br>".$langs->trans('CustomCode') . " : " . $prod->customcode;
	        }
	    }

	    return (!empty($out)) ? $out : $desc;
	}

	function _showProductBatch($object, $i, $desc)
	{
	    global $db, $langs;

	    $langs->load('products');

	    $out = '';
	    $origin = $object->origin;

	    if ($origin == "shipping")
	    {
	        $expedition=new Expedition($db);
	        $result = $expedition->fetch($object->origin_id);
	        $TBatch = $expedition->lines[$i]->detail_batch;
		if($expedition->lines[$i]->entrepot_id != 8){
		        if (count($TBatch))
		        {
	        	    $out = $desc;
	            		foreach ($TBatch as $batch)
	            		{
	                		$out .= "<br>".$langs->trans('Batch'). ": " . $batch->batch . " " . $langs->trans('Qty') . ": " . $batch->dluo_qty . " DLUO: " . date('d/m/Y', $batch->eatby);
	            		}
	        	}
		}
// 	        var_dump($TBatch); exit;
	    }

	    return (!empty($out)) ? $out : $desc;
	}

}
