<?php

/* Copyright (C) 2014		 Oscim       <support@oscim.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 * or see http://www.gnu.org/
 */

global $langs, $conf, $html;


function make_ean13_ILN($nom_societe, $etablissement_interne = 1) {
    $md5 = str_replace(".", "", "" . hexdec(md5($nom_societe)));
    $digits = substr($md5, 0, 6) . str_pad($etablissement_interne, 6, "0", STR_PAD_LEFT);
    //first change digits to a string so that we can access individual numbers
    $digits = (string) $digits;
    // 1. Add the values of the digits in the even-numbered positions: 2, 4, 6, etc.
    $even_sum = $digits{1} + $digits{3} + $digits{5} + $digits{7} + $digits{9} + $digits{11};
    // 2. Multiply this result by 3.
    $even_sum_three = $even_sum * 3;
    // 3. Add the values of the digits in the odd-numbered positions: 1, 3, 5, etc.
    $odd_sum = $digits{0} + $digits{2} + $digits{4} + $digits{6} + $digits{8} + $digits{10};
    // 4. Sum the results of steps 2 and 3.
    $total_sum = $even_sum_three + $odd_sum;
    // 5. The check character is the smallest number which, when added to the result in step 4,  produces a multiple of 10.
    $next_ten = (ceil($total_sum / 10)) * 10;
    $check_digit = $next_ten - $total_sum;
    return $digits . $check_digit;
}



print '<br>';
print '<form method="post" action="">';
print '<input type="hidden" name="token" value="' . $_SESSION['newtoken'] . '">';
print '<input type="hidden" name="action" value="setvalue">';

clearstatcache();

print '<table class="noborder" width="100%">';
print '<caption>' . $langs->trans("EdiMySetup") . '</caption>';

print '<tr class="liste_titre">';
print '<td width="20%">' . $langs->trans("Name") . '</td>';
print '<td width="20%">' . $langs->trans("Reglage") . '</td>';
print '<td>' . $langs->trans("Description") . '</td>';
print "</tr>\n";


$var = !$var;
print '<tr ' . $bc[$var] . '>';
print '<td valign="top">' . $langs->trans("EdiUser") . '</td>';
print '<td>';
$html->select_users((GETPOST("edi_user") ? GETPOST("edi_user") : $conf->global->EDI_USER), 'edi_user', 1);
print '</td>';
print '<td>' . $langs->trans("EdiUserDetail") . '</td>';
print '</tr>';


$var = !$var;
print '<tr ' . $bc[$var] . '>';
print '<td valign="top">' . $langs->trans("EdiYourUniqNum") . '</td>';
print '<td>' .
        '<input type="text" name="edi_uniq_num" value="' . (($conf->global->EDI_UNIQNUM) ? $conf->global->EDI_UNIQNUM : make_ean13_ILN($conf->global->MAIN_INFO_SOCIETE_NOM . $conf->global->MAIN_INFO_SOCIETE_ADDRESS . $conf->global->MAIN_INFO_SOCIETE_TOWN)) . '" />' .
        '</td>';
print '<td>' . $langs->trans("EdiYourUniqNumDetail") . '</td>';
print '</tr>';

print '<tr ' . $bc[$var] . '>';
print '<td valign="top">' . $langs->trans("EdiGLNFullQualified") . '</td>';
print '<td>' .
        '<input type="checkbox" name="edi_full_qualified" value="1" ' . (($conf->global->EDI_GLNFULLQUALIFIED == 1 ) ? 'checked="checked"' : '' ) . '" />' .
        '</td>';
print '<td>' . $langs->trans("EdiGLNFullQualifiedDetail") . '</td>';
print '</tr>';


print '<tr ' . $bc[$var] . '><td colspan="2" align="right">';
print '<input type="submit" class="button" value="' . $langs->trans("Modify") . '">';
print "</td></tr>\n";

print '</table>';
print '</form>';
print '<br>';


print '<table class="noborder" width="100%">';
print '<caption>' . $langs->trans("EdiCommuncation") . '</caption>';

print '<tr class="liste_titre">';
print '<td width="20%">' . $langs->trans("EdiInformation") . '</td>';
print '<td width="50%">' . $langs->trans("EdiValeur") . '</td>';
print '<td width="30%">' . $langs->trans("EdiDetails") . '</td>';
print '</tr>';

print '<tr>';
print '<td>' . $langs->trans("EdiMyUrl") . '</td>';
print '<td>' . dol_buildpath("/edi/receive.php", 2) . '</td>';
print '<td>' . $langs->trans("EdiMyUrlDetail") . '</td>';
print '</tr>';

print '<tr>';
print '<td>' . $langs->trans("EdiMyMethod") . '</td>';
print '<td>POST / GET</td>';
print '<td>' . $langs->trans("EdiMyMethodDetail") . '</td>';
print '</tr>';


print '<tr>';
print '<td>' . $langs->trans("EdiMyVariable") . '</td>';
print '<td>file</td>';
print '<td>' . $langs->trans("EdiMyVariableDetail") . '</td>';
print '</tr>';

print '<tr>';
print '<td>' . $langs->trans("EdiUrlSample") . '</td>';
print '<td><a target="_blank" href="'.dol_buildpath("/edi/receive.php", 2).'?file='.urlencode('DTM+7:201309200717:203\'').'">'.dol_buildpath("/edi/receive.php", 2).'?file='.urlencode('DTM+7:201309200717:203\'').'</a></td>';
print '<td>' . $langs->trans("EdiUrlSampleDetail") . '</td>';
print '</tr>';

print '</table>';


print '<form method="post" action="calling.php">';
print '<input type="hidden" name="token" value="' . $_SESSION['newtoken'] . '">';
print '<input type="hidden" name="action" value="setvalue">';

$var = true;



//print '<table class="noborder" width="100%">';
print '<table class="noborder" width="100%" style="display:none;">';
print '<caption>' . $langs->trans("CallingProviderChoose") . '</caption>';
print '<tr class="liste_titre">';
print '<td width="100">' . $langs->trans("Name") . '</td>';
// print '<td>'.$langs->trans("Description").'</td>';
// print '<td>'.$langs->trans("Example").'</td>';
print '<td align="center" width="60">' . $langs->trans("Status") . '</td>';
// print '<td align="center" width="16">'.$langs->trans("Infos").'</td>';
print "</tr>\n";

clearstatcache();

foreach ($conf->file->dol_document_root as $dirroot) {
    $dir = $dirroot . "/edi/vendor/EDI/Mapping/";

    if (is_dir($dir)) {
        $handle = opendir($dir);
        if (is_resource($handle)) {
            $var = true;

            while (($file = readdir($handle)) !== false) {


                if (is_dir($dir . $file) && $file != '.' && $file != '..') {
// 					$file = substr($file, 0, dol_strlen($file)-4);
// 			var_dump($file); 
// 					dol_include_once("/edi/vendor/EDI/Mapping/".$file.".php");
// 					$module = new $file;
// 					if ($conf->global->CALLING_ADDON == "$file")
// 						$current = $module;
// 
// 					// Show modules according to features level
// 					if ($module->version == 'development'  && $conf->global->MAIN_FEATURES_LEVEL < 2) continue;
// 					if ($module->version == 'experimental' && $conf->global->MAIN_FEATURES_LEVEL < 1) continue;
// 
// 					if ($module->isEnabled())
// 					{
// 						$var=!$var;
                    print '<tr ' . $bc[$var] . '><td>' . $file . "</td>\n";
// 						print $module->info();
// 						print '</td>';
// 
//                         // Show example of numbering module
//                         print '<td nowrap="nowrap">';
// 
//                         if ($module->UseSending()) print $langs->trans('CallingApiSendActive').'<br />';
// 
//                         if ($module->UseReceving()) print $langs->trans('CallingApiRecevingActive');
// 
//                         print '</td>'."\n";
// 
                    print '<td align="center">';
                    if ($conf->global->CALLING_ADDON == "$file") {
                        print img_picto($langs->trans("Activated"), 'on');
                    } else {
                        print '<a href="' . $_SERVER["PHP_SELF"] . '?action=setmod&amp;value=' . $file . '">';
                        print img_picto($langs->trans("Disabled"), 'off');
                        print '</a>';
                    }
                    print '</td>';
// 
// 						print '<td align="center">';
// 						print $html->textwithpicto('',$htmltooltip,1,0);
// 						print '</td>';
// 
                    print '</tr>';
// 					}
                }
            }
            closedir($handle);
        }
    }
}

print '</table><br>';

print '</form>';
?>
