<?php
/* Copyright (C) 2007-2017 Laurent Destailleur  <eldy@users.sourceforge.net>
  * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 *      \file       htdocs/commande/info.php
 *      \ingroup    commande
 * 		\brief      Page des informations d'une commande
 */
  namespace CORE;
  
$res = 0;
if (!$res && file_exists("../main.inc.php"))
    $res = @include("../main.inc.php");
if (!$res && file_exists("../../main.inc.php"))
    $res = @include("../../main.inc.php");
if (!$res && file_exists("../../../main.inc.php"))
    $res = @include("../../../main.inc.php");
if (!$res && file_exists("../../../../main.inc.php"))
    $res = @include("../../../../main.inc.php");
if (!$res && file_exists("../../../dolibarr/htdocs/main.inc.php"))
    $res = @include("../../../dolibarr/htdocs/main.inc.php");     // Used on dev env only
if (!$res && file_exists("../../../../dolibarr/htdocs/main.inc.php"))
    $res = @include("../../../../dolibarr/htdocs/main.inc.php");   // Used on dev env only
if (!$res && file_exists("../../../../../dolibarr/htdocs/main.inc.php"))
    $res = @include("../../../../../dolibarr/htdocs/main.inc.php");   // Used on dev env only
if (!$res)
    die("Include of main fails");

// CORE 
global $db;



/**
	@brief Call Specific Class provider for OScssShop Exts 
		This class garanted process for dolibarr evolution 
*/
dol_include_once('/framework/main.inc.php');
dol_include_once('/framework/core/lib/framework.lib.php');

include_once(DOL_DOCUMENT_ROOT.'/core/class/html.formfile.class.php');

namespace CORE\EDI;

dol_include_once('/edi/core/lib/edi.lib.php');
dol_include_once('/edi/class/edi.class.php');

loadClass('Societe');
// loadClass('Facture');
// loadClass('Commandefournisseur');
// loadClass('Commande');
// loadClass('ProductFournisseur');
// loadClass('Product');
// loadClass('Societe');

// loadClass('Edi');
namespace EDI;
use \Form;
use \FormFile;
use \Societe;
use \Edi;


use \CORE\FRAMEWORK\CommandeFournisseur ;
use \CORE\FRAMEWORK\Commande;



 
 
// Get parameters
$id			= GETPOST('id', 'int');
$action		= GETPOST('action', 'alpha');
$cancel     = GETPOST('cancel', 'aZ09');
$backtopage = GETPOST('backtopage', 'alpha');

// Initialize technical objects
$object=new Edi($db);
// $StaticSociete= new Societe($db);
$object = $StaticEdi = new Edi($db);
// $Edi = new Edi($db);
$object->fetch($id ); 

// print_r($object); 

$StaticEdi->id =  $Edi->ref_parent; 
$StaticEdi->name =  $Edi->ref_parent; 
/*
 * View
 */

 $Class = ucwords($Edi->dol_type); 
 if(class_exists($Class) ) {
	//  echo $Class; 
	$cLassStatic = new $Class($db);
	$cLassStatic->fetch($Edi->dol_type_id); 
 }
 
// $extrafields = new ExtraFields($db);
// $diroutputmassaction=$conf->edi->dir_output . '/temp/massgeneration/'.$user->id;
$hookmanager->initHooks(array('edicard', 'edicardlist'));     // Note that conf->hooks_modules contains array
// Fetch optionals attributes and labels
// $extralabels = $extrafields->fetch_name_optionals_label('edi');
// $search_array_options=$extrafields->getOptionalsFromPost($extralabels,'','search_');

// Initialize array of search criterias
$search_all=trim(GETPOST("search_all",'alpha'));
$search=array();
foreach($object->fields as $key => $val)
{
    if (GETPOST('search_'.$key,'alpha')) $search[$key]=GETPOST('search_'.$key,'alpha');
}

if (empty($action) && empty($id) && empty($ref)) $action='view';

// Protection if external user
if ($user->societe_id > 0)
{
	//accessforbidden();
}
//$result = restrictedArea($user, 'edi', $id);

// fetch optionals attributes and labels
// $extralabels = $extrafields->fetch_name_optionals_label($object->table_element);

// Load object
include DOL_DOCUMENT_ROOT.'/core/actions_fetchobject.inc.php';  // Must be include, not include_once  // Must be include, not include_once. Include fetch and fetch_thirdparty but not fetch_optionals



/*
 * ACTIONS
 *
 * Put here all code to do according to value of "action" parameter
 */

$parameters=array();
$reshook=$hookmanager->executeHooks('doActions',$parameters,$object,$action);    // Note that $action and $object may have been modified by some hooks
if ($reshook < 0) setEventMessages($hookmanager->error, $hookmanager->errors, 'errors');

if (empty($reshook))
{
	$error=0;

	if ($cancel)
	{
		if ($action != 'addlink')
		{
			$urltogo=$backtopage?$backtopage:dol_buildpath('/edi/edi_list.php',1);
			header("Location: ".$urltogo);
			exit;
		}
		if ($id > 0 || ! empty($ref)) $ret = $object->fetch($id,$ref);
		$action='';
	}

	// Action to add record
	if ($action == 'add' && ! empty($user->rights->edi->create))
	{
        foreach ($object->fields as $key => $val)
        {
            if (in_array($key, array('rowid', 'entity', 'date_creation', 'tms', 'import_key'))) continue;	// Ignore special fields

            $object->$key=GETPOST($key,'alpha');
            if ($val['notnull'] && $object->$key == '')
            {
                $error++;
                setEventMessages($langs->trans("ErrorFieldRequired",$langs->transnoentitiesnoconv($val['label'])), null, 'errors');
            }
        }

		if (! $error)
		{
			$result=$object->createCommon($user);
			if ($result > 0)
			{
				// Creation OK
				$urltogo=$backtopage?$backtopage:dol_buildpath('/edi/edi_list.php',1);
				header("Location: ".$urltogo);
				exit;
			}
			else
			{
				// Creation KO
				if (! empty($object->errors)) setEventMessages(null, $object->errors, 'errors');
				else  setEventMessages($object->error, null, 'errors');
				$action='create';
			}
		}
		else
		{
			$action='create';
		}
	}

	// Action to update record
	if ($action == 'update' && ! empty($user->rights->edi->create))
	{
	    foreach ($object->fields as $key => $val)
        {
            $object->$key=GETPOST($key,'alpha');
            if (in_array($key, array('rowid', 'entity', 'date_creation', 'tms', 'import_key'))) continue;
            if ($val['notnull'] && $object->$key == '')
            {
                $error++;
                setEventMessages($langs->trans("ErrorFieldRequired",$langs->transnoentitiesnoconv($val['label'])), null, 'errors');
            }
        }

		if (! $error)
		{
			$result=$object->updateCommon($user);
			if ($result > 0)
			{
				$action='view';
			}
			else
			{
				// Creation KO
				if (! empty($object->errors)) setEventMessages(null, $object->errors, 'errors');
				else setEventMessages($object->error, null, 'errors');
				$action='edit';
			}
		}
		else
		{
			$action='edit';
		}
	}

	// Action to delete
	if ($action == 'confirm_delete' && ! empty($user->rights->edi->delete))
	{
		$result=$object->deleteCommon($user);
		if ($result > 0)
		{
			// Delete OK
			setEventMessages("RecordDeleted", null, 'mesgs');
			header("Location: ".dol_buildpath('/edi/edi_list.php',1));
			exit;
		}
		else
		{
			if (! empty($object->errors)) setEventMessages(null, $object->errors, 'errors');
			else setEventMessages($object->error, null, 'errors');
		}
	}
}




/*
 * VIEW
 *
 * Put here all code to build page
 */
$form=new Form($db);
$formfile=new FormFile($db);
llxHeader('','Edi','');
// Example : Adding jquery code
print '<script type="text/javascript" language="javascript">
jQuery(document).ready(function() {
	function init_myfunc()
	{
		jQuery("#myid").removeAttr(\'disabled\');
		jQuery("#myid").attr(\'disabled\',\'disabled\');
	}
	init_myfunc();
	jQuery("#mybutton").click(function() {
		init_myfunc();
	});
});
</script>';
// Part to create
if ($action == 'create')
{
	print load_fiche_titre($langs->trans("NewObject", $langs->transnoentitiesnoconv("Edi")));
	print '<form method="POST" action="'.$_SERVER["PHP_SELF"].'">';
	print '<input type="hidden" name="token" value="'.$_SESSION['newtoken'].'">';
	print '<input type="hidden" name="action" value="add">';
	print '<input type="hidden" name="backtopage" value="'.$backtopage.'">';
	dol_fiche_head(array(), '');
	print '<table class="border centpercent">'."\n";
	foreach($object->fields as $key => $val)
	{
	    if (in_array($key, array('rowid', 'entity', 'date_creation', 'tms', 'fk_user_creat', 'fk_user_modif', 'import_key'))) continue;
    	print '<tr id="field_'.$key.'"><td';
    	print ' class="titlefieldcreate';
    	if ($val['notnull']) print ' fieldrequired';
    	print '"';
    	print '>'.$langs->trans($val['label']).'</td>';
    	print '<td><input class="flat" type="text" name="'.$key.'" value="'.(GETPOST($key,'alpha')?GETPOST($key,'alpha'):'').'"></td>';
    	print '</tr>';
	}
	print '</table>'."\n";
	dol_fiche_end();
	print '<div class="center"><input type="submit" class="button" name="add" value="'.dol_escape_htmltag($langs->trans("Create")).'"> &nbsp; <input type="submit" class="button" name="cancel" value="'.dol_escape_htmltag($langs->trans("Cancel")).'"></div>';
	print '</form>';
}
// Part to edit record
if (($id || $ref) && $action == 'edit')
{
	print load_fiche_titre($langs->trans("MyModule"));
	print '<form method="POST" action="'.$_SERVER["PHP_SELF"].'">';
	print '<input type="hidden" name="action" value="update">';
	print '<input type="hidden" name="backtopage" value="'.$backtopage.'">';
	print '<input type="hidden" name="id" value="'.$object->id.'">';
	dol_fiche_head();
	print '<table class="border centpercent">'."\n";
	foreach($object->fields as $key => $val)
	{
	    if (in_array($key, array('rowid', 'entity', 'date_creation', 'tms', 'fk_user_creat', 'fk_user_modif', 'import_key'))) continue;
    	print '<tr><td';
    	print ' class="titlefieldcreate';
    	if ($val['notnull']) print ' fieldrequired';
    	print '"';
    	print '>'.$langs->trans($val['label']).'</td>';
    	print '<td><input class="flat" type="text" name="'.$key.'" value="'.(GETPOST($key,'alpha')?GETPOST($key,'alpha'):'').'"></td>';
    	print '</tr>';
	}
	print '</table>';
	dol_fiche_end();
	print '<div class="center"><input type="submit" class="button" name="save" value="'.$langs->trans("Save").'">';
	print ' &nbsp; <input type="submit" class="button" name="cancel" value="'.$langs->trans("Cancel").'">';
	print '</div>';
	print '</form>';
}
// Part to show record
if ($object->id > 0 && (empty($action) || ($action != 'edit' && $action != 'create')))
{
    $res = $object->fetch_optionals($object->id, $extralabels);
	$head = ediPrepareHead($object);
	dol_fiche_head($head, 'card', $langs->trans("Edi"), -1, 'edi@edi');
	$formconfirm = '';
	// Confirmation to delete
	if ($action == 'delete') {
	    $formconfirm = $form->formconfirm($_SERVER["PHP_SELF"] . '?id=' . $object->id, $langs->trans('DeleteEdi'), $langs->trans('ConfirmDeleteEdi'), 'confirm_delete', '', 0, 1);
	}
	// Confirmation of action xxxx
	if ($action == 'xxx')
	{
	    $formquestion=array();
	    /*
	        $formquestion = array(
	            // 'text' => $langs->trans("ConfirmClone"),
	            // array('type' => 'checkbox', 'name' => 'clone_content', 'label' => $langs->trans("CloneMainAttributes"), 'value' => 1),
	            // array('type' => 'checkbox', 'name' => 'update_prices', 'label' => $langs->trans("PuttingPricesUpToDate"), 'value' => 1),
	            // array('type' => 'other',    'name' => 'idwarehouse',   'label' => $langs->trans("SelectWarehouseForStockDecrease"), 'value' => $formproduct->selectWarehouses(GETPOST('idwarehouse')?GETPOST('idwarehouse'):'ifone', 'idwarehouse', '', 1)));
	    }*/
	    $formconfirm = $form->formconfirm($_SERVER["PHP_SELF"] . '?id=' . $object->id, $langs->trans('XXX'), $text, 'confirm_xxx', $formquestion, 0, 1, 220);
	}
	if (! $formconfirm) {
	    $parameters = array('lineid' => $lineid);
	    $reshook = $hookmanager->executeHooks('formConfirm', $parameters, $object, $action); // Note that $action and $object may have been modified by hook
	    if (empty($reshook)) $formconfirm.=$hookmanager->resPrint;
	    elseif ($reshook > 0) $formconfirm=$hookmanager->resPrint;
	}
	// Print form confirm
	print $formconfirm;
	// Object card
	// ------------------------------------------------------------
	$linkback = '<a href="' .dol_buildpath('/edi/edi_list.php',1) . '?restore_lastsearch_values=1' . (! empty($socid) ? '&socid=' . $socid : '') . '">' . $langs->trans("BackToList") . '</a>';
	$morehtmlref='<div class="refidno">';
	/*
	// Ref bis
	$morehtmlref.=$form->editfieldkey("RefBis", 'ref_client', $object->ref_client, $object, $user->rights->edi->creer, 'string', '', 0, 1);
	$morehtmlref.=$form->editfieldval("RefBis", 'ref_client', $object->ref_client, $object, $user->rights->edi->creer, 'string', '', null, null, '', 1);
	// Thirdparty
	$morehtmlref.='<br>'.$langs->trans('ThirdParty') . ' : ' . $soc->getNomUrl(1);
	// Project
	if (! empty($conf->projet->enabled))
	{
	    $langs->load("projects");
	    $morehtmlref.='<br>'.$langs->trans('Project') . ' ';
	    if ($user->rights->edi->creer)
	    {
	        if ($action != 'classify')
	        {
	            $morehtmlref.='<a href="' . $_SERVER['PHP_SELF'] . '?action=classify&amp;id=' . $object->id . '">' . img_edit($langs->transnoentitiesnoconv('SetProject')) . '</a> : ';
	            if ($action == 'classify') {
	                //$morehtmlref.=$form->form_project($_SERVER['PHP_SELF'] . '?id=' . $object->id, $object->socid, $object->fk_project, 'projectid', 0, 0, 1, 1);
	                $morehtmlref.='<form method="post" action="'.$_SERVER['PHP_SELF'].'?id='.$object->id.'">';
	                $morehtmlref.='<input type="hidden" name="action" value="classin">';
	                $morehtmlref.='<input type="hidden" name="token" value="'.$_SESSION['newtoken'].'">';
	                $morehtmlref.=$formproject->select_projects($object->socid, $object->fk_project, 'projectid', $maxlength, 0, 1, 0, 1, 0, 0, '', 1);
	                $morehtmlref.='<input type="submit" class="button valignmiddle" value="'.$langs->trans("Modify").'">';
	                $morehtmlref.='</form>';
	            } else {
	                $morehtmlref.=$form->form_project($_SERVER['PHP_SELF'] . '?id=' . $object->id, $object->socid, $object->fk_project, 'none', 0, 0, 0, 1);
	            }
	        }
	    } else {
	        if (! empty($object->fk_project)) {
	            $proj = new Project($db);
	            $proj->fetch($object->fk_project);
	            $morehtmlref.='<a href="'.DOL_URL_ROOT.'/projet/card.php?id=' . $object->fk_project . '" title="' . $langs->trans('ShowProject') . '">';
	            $morehtmlref.=$proj->ref;
	            $morehtmlref.='</a>';
	        } else {
	            $morehtmlref.='';
	        }
	    }
	}
	*/
	$morehtmlref.='</div>';
	dol_banner_tab($object, 'ref', $linkback, 1, 'ref', 'ref', $morehtmlref);
	print '<div class="fichecenter">';
	print '<div class="fichehalfleft">';
	print '<div class="underbanner clearboth"></div>';
	print '<table class="border centpercent">'."\n";
	foreach($object->fields as $key => $val)
	{
	
	// 	    if (in_array($key, array('num_received', 'data', 'date_creation', 'tms', 'fk_user_creat', 'fk_user_modif', 'import_key'))) continue;
    	$format = '<tr><td';
    	$format.= ' class="titlefieldcreate';
    	if ($val['notnull']) $format.= ' fieldrequired';
    	$format.= '"';
    	$format.= '>%s</td>';
    	$format.= '<td>%s</td>';
    	$format.= '</tr>';
		// Fields from hook
		$parameters=array( 'key'=>$key, 'obj'=>$object, 'arr'=>$val, 'format'=>$format);
		$reshook=$hookmanager->executeHooks('printFieldValue',$parameters);    // Note that $action and $object may have been modified by hook
		print $hookmanager->resPrint ;
						
// 	    if (in_array($key, array('num_received', 'data', 'date_creation', 'tms', 'fk_user_creat', 'fk_user_modif', 'import_key'))) continue;
//     	print '<tr><td';
//     	print ' class="titlefieldcreate';
//     	if ($val['notnull']) print ' fieldrequired';
//     	print '"';
//     	print '>'.$langs->trans($val['label']).'</td>';
//     	print '<td>'.$object->$key.'</td>';
//     	print '</tr>';
	}
	// Other attributes
	include DOL_DOCUMENT_ROOT . '/core/tpl/extrafields_view.tpl.php';
	print '</table>';
	print '</div>';
	print '<div class="fichehalfright">';
	print '<div class="ficheaddleft">';
	print '<div class="underbanner clearboth"></div>';
	print '<table class="border centpercent">';
	// ...
	/// TODO deport in boxe sectio adn add dashboard scenario
		print '<tr>';
	
		$parameters=array('currentcontext'=>'edicardlist' , 'obj'=>$row );
			$reshook=$hookmanager->executeHooks('printFieldListTitle',$parameters);    // Note that $action and $object may have been modified by hook
			print $hookmanager->resPrint ;
		print '</tr>';
			
		$StaticEdi = new Edi($db);

		$r = printline($StaticEdi, array(), 1, $object->id, $object->fk_soc);
		foreach($r as $row) {
// 		print_r($row); 
		print '<tr>';
			$parameters=array('currentcontext'=>'edicardlist' , 'obj'=>$row );
			$reshook=$hookmanager->executeHooks('printFieldListValue',$parameters);    // Note that $action and $object may have been modified by hook
			print $hookmanager->resPrint ;
		print '</tr>';
		}
		
	print '</table>';
	print '</div>';
	print '</div>';
	print '</div>';
	print '<div class="clearboth"></div><br>';
	dol_fiche_end();
	// Buttons for actions
	if ($action != 'presend' && $action != 'editline') {
    	print '<div class="tabsAction">'."\n";
    	$parameters=array();
    	$reshook=$hookmanager->executeHooks('addMoreActionsButtons',$parameters,$object,$action);    // Note that $action and $object may have been modified by hook
    	if ($reshook < 0) setEventMessages($hookmanager->error, $hookmanager->errors, 'errors');
    	if (empty($reshook))
    	{
    	    // Send
            print '<div class="inline-block divButAction"><a class="butAction" href="' . $_SERVER["PHP_SELF"] . '?id=' . $object->id . '&action=presend&mode=init#formmailbeforetitle">' . $langs->trans('SendByMail') . '</a></div>'."\n";
    		if ($user->rights->edi->write)
    		{
    			print '<div class="inline-block divButAction"><a class="butAction" href="'.$_SERVER["PHP_SELF"].'?id='.$object->id.'&amp;action=edit">'.$langs->trans("Modify").'</a></div>'."\n";
    		}
    		if ($user->rights->edi->delete)
    		{
    			print '<div class="inline-block divButAction"><a class="butActionDelete" href="'.$_SERVER["PHP_SELF"].'?id='.$object->id.'&amp;action=delete">'.$langs->trans('Delete').'</a></div>'."\n";
    		}
    	}
    	print '</div>'."\n";
	}
	// Select mail models is same action as presend
	if (GETPOST('modelselected')) {
	    $action = 'presend';
	}
	if ($action != 'presend')
	{
// 	    print '<div class="fichecenter"><div class="fichehalfleft">';
// 	    print '<a name="builddoc"></a>'; // ancre
// 	    // Documents
// 			$sub = $object->fetch_object(); 
// 	    $comref = dol_sanitizeFileName($sub->ref);
// 	    $relativepath = $comref . '/' . $comref . '.pdf';
// 		  $filedir = $conf->{$object->dol_type}->dir_output . '/' . $comref;
// 
// 	
// 	    $urlsource = $_SERVER["PHP_SELF"] . "?id=" . $object->id;
// 	    $genallowed = $user->rights->edi->creer;
// 	    $delallowed = $user->rights->edi->supprimer;
// 	    print $formfile->showdocuments('edi', $comref, $filedir, $urlsource, $genallowed, $delallowed, $object->modelpdf, 1, 0, 0, 28, 0, '', '', '', $soc->default_lang);
// 	    // Show links to link elements
// 	    $linktoelem = $form->showLinkToObjectBlock($object, null, array('edi'));
// 	    $somethingshown = $form->showLinkedObjectBlock($object, $linktoelem);
// 	    print '</div><div class="fichehalfright"><div class="ficheaddleft">';
// 	    // List of actions on element
// 	    include_once DOL_DOCUMENT_ROOT . '/core/class/html.formactions.class.php';
// 	    $formactions = new \FormActions($db);
// 	    $somethingshown = $formactions->showactions($object, 'edi', $socid);
// 	    print '</div></div></div>';
	}
	/*
	 * Action presend
	 */
    /*
	if ($action == 'presend')
	{
		$object->fetch_projet();
		$ref = dol_sanitizeFileName($object->ref);
		include_once DOL_DOCUMENT_ROOT . '/core/lib/files.lib.php';
		$fileparams = dol_most_recent_file($conf->commande->dir_output . '/' . $ref, preg_quote($ref, '/').'[^\-]+');
		$file = $fileparams['fullname'];
		// Define output language
		$outputlangs = $langs;
		$newlang = '';
		if ($conf->global->MAIN_MULTILANGS && empty($newlang) && ! empty($_REQUEST['lang_id']))
			$newlang = $_REQUEST['lang_id'];
		if ($conf->global->MAIN_MULTILANGS && empty($newlang))
			$newlang = $object->thirdparty->default_lang;
		if (!empty($newlang))
		{
			$outputlangs = new Translate('', $conf);
			$outputlangs->setDefaultLang($newlang);
			$outputlangs->load('commercial');
		}
		// Build document if it not exists
		if (! $file || ! is_readable($file)) {
			$result = $object->generateDocument(GETPOST('model') ? GETPOST('model') : $object->modelpdf, $outputlangs, $hidedetails, $hidedesc, $hideref);
			if ($result <= 0) {
				dol_print_error($db, $object->error, $object->errors);
				exit();
			}
			$fileparams = dol_most_recent_file($conf->commande->dir_output . '/' . $ref, preg_quote($ref, '/').'[^\-]+');
			$file = $fileparams['fullname'];
		}
		print '<div id="formmailbeforetitle" name="formmailbeforetitle"></div>';
		print '<div class="clearboth"></div>';
		print '<br>';
		print load_fiche_titre($langs->trans('SendEdiByMail'));
		dol_fiche_head('');
		// Cree l'objet formulaire mail
		include_once DOL_DOCUMENT_ROOT . '/core/class/html.formmail.class.php';
		$formmail = new FormMail($db);
		$formmail->param['langsmodels']=(empty($newlang)?$langs->defaultlang:$newlang);
        $formmail->fromtype = (GETPOST('fromtype')?GETPOST('fromtype'):(!empty($conf->global->MAIN_MAIL_DEFAULT_FROMTYPE)?$conf->global->MAIN_MAIL_DEFAULT_FROMTYPE:'user'));
        if($formmail->fromtype === 'user'){
            $formmail->fromid = $user->id;
        }
		$formmail->trackid='ord'.$object->id;
		if (! empty($conf->global->MAIN_EMAIL_ADD_TRACK_ID) && ($conf->global->MAIN_EMAIL_ADD_TRACK_ID & 2))	// If bit 2 is set
		{
			include DOL_DOCUMENT_ROOT.'/core/lib/functions2.lib.php';
			$formmail->frommail=dolAddEmailTrackId($formmail->frommail, 'ord'.$object->id);
		}
		$formmail->withfrom = 1;
		$liste = array();
		foreach ($object->thirdparty->thirdparty_and_contact_email_array(1) as $key => $value)
			$liste [$key] = $value;
		$formmail->withto = GETPOST('sendto') ? GETPOST('sendto') : $liste;
		$formmail->withtocc = $liste;
		$formmail->withtoccc = $conf->global->MAIN_EMAIL_USECCC;
		if (empty($object->ref_client)) {
			$formmail->withtopic = $outputlangs->trans('SendEdiRef', '__REF__');
		} else if (! empty($object->ref_client)) {
			$formmail->withtopic = $outputlangs->trans('SendEdiRef', '__REF__ (__REFCLIENT__)');
		}
		$formmail->withfile = 2;
		$formmail->withbody = 1;
		$formmail->withdeliveryreceipt = 1;
		$formmail->withcancel = 1;
		// Tableau des substitutions
		$formmail->setSubstitFromObject($object);
		$formmail->substit ['__REF__'] = $object->ref;
		$custcontact = '';
		$contactarr = array();
		$contactarr = $object->liste_contact(- 1, 'external');
		if (is_array($contactarr) && count($contactarr) > 0)
		{
			foreach ($contactarr as $contact)
			{
				if ($contact['libelle'] == $langs->trans('TypeContact_commande_external_CUSTOMER')) {	// TODO Use code and not label
					$contactstatic = new Contact($db);
					$contactstatic->fetch($contact ['id']);
					$custcontact = $contactstatic->getFullName($langs, 1);
				}
			}
			if (! empty($custcontact)) {
				$formmail->substit['__CONTACTCIVNAME__'] = $custcontact;
			}
		}
		// Tableau des parametres complementaires
		$formmail->param['action'] = 'send';
		$formmail->param['models'] = 'edi_send';
		$formmail->param['models_id']=GETPOST('modelmailselected','int');
		$formmail->param['ediid'] = $object->id;
		$formmail->param['returnurl'] = $_SERVER["PHP_SELF"] . '?id=' . $object->id;
		// Init list of files
		if (GETPOST("mode") == 'init') {
			$formmail->clear_attached_files();
			$formmail->add_attached_files($file, basename($file), dol_mimetype($file));
		}
		// Show form
		print $formmail->get_form();
		dol_fiche_end();
	}*/
}
// End of page
llxFooter();
$db->close();
