<?php
/* Copyright (C) 2015 Oscss-Shop Team <support@oscss-shop.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

namespace CORE;

dol_include_once('comm/action/class/cactioncomm.class.php');
dol_include_once('comm/action/class/actioncomm.class.php');


loadClass('fixversion');

namespace CORE\FRAMEWORK;

use \CORE\FRAMEWORK\ActionComm as ActionComm;
use \CActionComm;
use \Fixversion;

class ActionComm Extends \ActionComm
{

    /**
      @brief add event in calendar
      @param $user Object Dolibarr User
      @param $societe Object Dolibarr Societe
      @param $DolMessage Object DolMessage Module
      @return none

     */
    public function SetEvent(\User $user, \Societe $societe, $Object, $MessageEdi)
    {
        global $conf, $langs;

        $error = 0;

        $cactioncomm = new CActionComm($this->db);

        // Initialisation objet actioncomm
        $usertodo          = $user;
        $this->usertodo    = $usertodo;
        $this->userownerid = $usertodo->id;
        $this->userdoneid  = $usertodo->id;


// 			if (!empty($conf->global->CODE_ACTIONCOMM_EDI) )
// 					$cactioncomm_code = $conf->global->CODE_ACTIONCOMM_EDI;
// 			else
        $cactioncomm_code = "AC_OTH_AUTO";

        $cactioncomm->fetch($cactioncomm_code);

        $this->type_id      = $cactioncomm->id;
        $this->type_code    = $cactioncomm->code;
        $this->priority     = 0;
        $this->fulldayevent = 0;
        $this->location     = '';
        $this->percentage   = '-1';
        $this->label        = $langs->trans('EdiSendProcessed', get_class($MessageEdi));
        $this->fk_project   = 0;
        $this->datep        = dol_now(); // $Object->date;
        $this->note         = '';
        $this->fk_element   = $Object->id;


        $FV = new Fixversion($db);

        $elementtype       = $FV->GetTypeByClassName(get_class($Object));
        $this->elementtype = $FV->GetTypeByClassName(get_class($Object));

        if (isset($societe->id) && $societe->id > 0) {
            $this->societe = $societe;
            $this->socid   = $societe->id;
        }

        if (!$error) {
            $this->db->begin();

            // On cree l'action
            $idaction = $this->add($user);

            if ($idaction > 0) {
                if (!$this->error) {
                    $this->db->commit();
                } else $this->db->rollback();
            } else $this->db->rollback();
        }
    }
}
class_alias('CORE\FRAMEWORK\ActionComm', '\ActionCommEdi');
