<?php 
/* Copyright (C) 2015 Oscss-Shop Team <support@oscss-shop.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
 
 
Class Edi 
	extends CommonObject{
		/**
		* @var string ID to identify managed object
		*/
		public $element = 'edi';
		/**
		* @var string Name of table without prefix where object is stored
		*/
		public $table_element = 'edi_element';

		/**
		* @var array  Does this field is linked to a thirdparty ?
		*/
		protected $isnolinkedbythird = 1;
		/**
		* @var array  Does edi support multicompany module ? 0=No test on entity, 1=Test with field entity, 2=Test with link by societe
		*/
		protected $ismultientitymanaged = 0;
		/**
		* @var string String with name of icon for edi
		*/
		public $picto = 'edi';


		/**
		*             'type' if the field format, 'label' the translation key, 'enabled' is a condition when the filed must be managed,
		*             'visible' says if field is visible in list (-1 means not shown by default but can be aded into list to be viewed)
		*             'notnull' if not null in database
		*             'index' if we want an index in database
		*             'position' is the sort order of field
		*             'searchall' is 1 if we want to search in this field when making a search from the quick search button
		*             'isameasure' must be set to 1 if you want to have a total on list for this field. Field type must be summable like integer or double(24,8).
		*             'comment' is not used. You can store here any text of your choice.
		*/


		/**
		* @var array  Array with all fields and their property
		*/
		public $fields=array(
			'ref_uniq' => array('type'=>'varchar(14)', 'label'=>'EdiRefUniq', 'visible'=>1, 'enabled'=>1, 'position'=>1, 'notnull'=>1, 'index'=>1, 'comment'=>'EdiRefUniq',),
// 			'ref' => array('type'=>'varchar(64)', 'label'=>'Ref', 'visible'=>1, 'enabled'=>1, 'position'=>10, 'notnull'=>1, 'index'=>1, 'searchall'=>1, 'comment'=>'Reference of object',),
			'ref_parent' => array('type'=>'varchar(14)', 'label'=>'EdiParentRefUniq', 'visible'=>1, 'enabled'=>1, 'position'=>20, 'notnull'=>1, 'index'=>1,),
			
// 			'label' => array('type'=>'varchar(255)', 'label'=>'Label', 'visible'=>1, 'enabled'=>1, 'position'=>30, 'searchall'=>1,),
// 			'qty' => array('type'=>'double(24,8)', 'label'=>'Qty', 'visible'=>1, 'enabled'=>1, 'position'=>40,),
			'count_message' => array('type'=>'integer', 'label'=>'EdiCountMess', 'visible'=>-1, 'enabled'=>1, 'position'=>1000, 'index'=>1,),
// 			'date_creation' => array('type'=>'datetime', 'label'=>'DateCreation', 'visible'=>-1, 'enabled'=>1, 'position'=>500, 'notnull'=>1,),
// 			'tms' => array('type'=>'timestamp', 'label'=>'DateModification', 'visible'=>-1, 'enabled'=>1, 'position'=>500, 'notnull'=>1,),
			'num_received' => array('type'=>'integer', 'label'=>'EdiNumReceived', 'visible'=>0, 'enabled'=>1, 'position'=>1000, 'index'=>2,),
			
			'dol_type' => array('type'=>'integer', 'label'=>'EdiDolType', 'visible'=>1, 'enabled'=>1, 'position'=>1000, 'index'=>1,),
				
			'dol_type_id' => array('type'=>'integer', 'label'=>'EdiDolTypeId', 'visible'=>0, 'enabled'=>1, 'position'=>1000, 'index'=>1,),
			
			'message_type' => array('type'=>'integer', 'label'=>'EdiMessageType', 'visible'=>1, 'enabled'=>1, 'position'=>1000, 'index'=>1,),
			
			'norme' => array('type'=>'varchar(5)', 'label'=>'EdiNorme', 'visible'=>1, 'enabled'=>1, 'position'=>1000, 'index'=>1,),
			
			'data' => array('type'=>'integer', 'label'=>'EdiData', 'visible'=>0, 'enabled'=>1, 'position'=>1000, 'index'=>1,),
			
			'message' => array('type'=>'text', 'label'=>'EdiMessage', 'visible'=>1, 'enabled'=>1, 'position'=>1000, 'index'=>1,),
			
			'accepted' => array('type'=>'text', 'label'=>'EdiAccepted', 'visible'=>1, 'enabled'=>1, 'position'=>1000, 'index'=>1,),
		);


	/**
		@var internal id int 
	*/
	public $id
			, $name 
			, $num_received
			, $ref_parent
			, $dol_type
			, $dol_type_id
			, $datec 
			, $message_type 
			, $norme
			, $message
			, $brut_message
			, $accepted
			/**
				@var int rowid in table edi_thirdparty
			*/
			, $edi_thirdparty_rowid
			/**
				@var int client_mode in table edi_thirdparty
			*/
			, $edi_thirdparty_client_mode
			/**
				@var result array of EDI Reader 
			*/
			, $array_messg
			/**
				@var object Setup 
			*/
			, $setup
			, $thirdparty

			, $object_ref
			; 
		// If this object has a subtable with lines

		/**
		* @var int    Name of subtable line
		*/
		//public $table_element_line = 'edidet';
		/**
		* @var int    Field with ID of parent key if this field has a parent
		*/
		//public $fk_element = 'fk_edi';
		/**
		* @var int    Name of subtable class that manage subtable lines
		*/
		//public $class_element_line = 'ediline';
		/**
		* @var array  Array of child tables (child tables to delete before deleting a record)
		*/
		//protected $childtables=array('edidet');
		/**
		* @var ediLine[]     Array of subtable lines
		*/
		//public $lines = array();

		/**
			@var string 
		*/
// 		public $element='edi';
		/**
			@var string
		*/
// 		public $table_element='edi_element';
		/**
			@var object 
		*/
		public $user;
	
	
	
			
			
	protected $trace
					;
	
	
	/**
		@var string name
	*/
	public $user_id; 

	

	
	public function __construct($db, $user =false){
	
		if($user == false)  {
			global $user;
		}
			
			
		static $i =0; 
		$i++;
		
		$this->i = $i; 
		$this->db = $db;
		$this->user = $user;
	}
	
	
	
	public function specimen(){
		$this->id = 0; 
		$this->message_id = '';
	}
	
	

	
	
	/**
		@fn SetSociete($Societe)
	*/
	public function SetSociete($Societe, $SocieteEdi = null){
		$this->thirdparty =$Societe; 
		
		if($SocieteEdi == null) 
			$this->edithirdparty = $Societe;
		else 
			$this->edithirdparty = $SocieteEdi;
	}
	
	/**
		@fn SetTrace($trace)
	*/
	public function SetTrace($trace){
		$this->trace =$trace; 
	}
	
	
	/**
		@fn SetupLoader()
	*/
	private function SetupLoader(){
	
		$trace = $this->trace;
		
		dol_include_once("/edi/class/setup_loader.class.php");

		$this->setup = new setup_loader($this->db);
		// trick to load the corresponding row : pass int row
		$this->setup->load_user($this->edithirdparty->id,  $this->edi_societe_client_mode); 

		if ($this->setup->user->trans_mode !== $this->trans_mode && $this->trans_mode !='email') {
				$trace->message = 'transmission mode not allowed'; 
				$trace->trace_message();
				die($trace->message);
				
				$trace->setMessage( 'transmission mode not allowed');
				$trace->accept_message(-2); 
				$trace->trace_message();
		}
	}
	
	/**
		@fn create(\User $user, $notrigger = 0)
		@param $user object
		@param $notrigger int 
	*/
	public function create(\User $user, $notrigger = 0){
		global $conf;

		$error = 0;
		
		
		$this->SetupLoader(); 
		
		
		$current_user = $user; 
		$setup = $this->setup;
		$norme = $this->norme; 
		$type_message = $this->type_message; 
		$trace = $this->trace; 
		$r = $this->array_messg; 
		


		$file_to_include = dol_buildpath("/edi/plugin/$norme" . $setup->descriptor->$norme->message->input->$type_message->file);
		
		if (file_exists($file_to_include)) {
			try {

				include_once($file_to_include);
				$myclass = '\\EDI\\reception\\' . $type_message;

				
				if(! empty( $conf->global->EDIDEBUGLEVEL ) && $conf->global->EDIDEBUGLEVEL >= 2 )
					if (!isset($this->thirdparty) || !isset($this->thirdparty->id) || $this->thirdparty->id == 0) {
						trigger_error("[PROCESS][CREATE] plugins : ".$myclass." NO THIRDPARTY !!!", E_USER_NOTICE);
					} else {
						trigger_error("[PROCESS][CREATE] plugins : ".$myclass." thirdparty ".$this->thirdparty->id, E_USER_NOTICE);
					}
				// copy readed array
				$receive = new $myclass($r);

				$receive->SetDB($this->db); 
				// convert to an doli object
				$receive->decode( $this->thirdparty, $trace );

				$user->fetch($conf->global->EDI_USER); 
				$user->getrights(); 
				$u = $user; 
				

				// store it in DB
				$res = $receive->import($this->db, $u);
				
				
				if($type_message =='APERAK' )
					$fixedparent = $trace->ref_parent;
				else 
					$fixedparent = false;
				
				
				if(! empty( $conf->global->EDIDEBUGLEVEL ) && $conf->global->EDIDEBUGLEVEL >= 5 )
					trigger_error(__class__.'>'.__function__.'>'.__line__.' -- perv RefUniq ', E_USER_NOTICE );
				
				
				$rtrace = $trace->RefUniq($res->object->socid, get_class($res->object) , $res->object->id  ); 

				
				//message is valid
				if( !empty($res->dol_type) )
					$trace->dol_type = $res->dol_type ;
				//message is valid
				if( !empty($res->dol_type_id) && $res->dol_type_id > 0 )
					$trace->dol_type_id = $res->dol_type_id ; 
				if($fixedparent !=false) 
					$trace->ref_parent = $fixedparent;
					
// 						$trace->accept_message();
// 						trigger_error("[PROCESS][CREATE] APERAK : parent ".$fixedparent."  ", E_USER_NOTICE);
				if($fixedparent !=false && $type_message =='APERAK') 
					$trace->AcceptedEnd($fixedparent, '2');
				elseif($type_message !='APERAK' && preg_match('#(ftp|email|manual)#i', $this->trans_mode) ) 
					$trace->accept_message(2);
				else
					$trace->accept_message(1);

		
				// end process in 
				// trace message input 
				$trace->trace_message();
				
				/**
					Calulat path and file
				*/
				$this->output_file = output_file(  $receive->GetPath() , $receive->ref, $receive->count_message ) ; 
				
				if(! empty( $conf->global->EDIDEBUGLEVEL ) && $conf->global->EDIDEBUGLEVEL >= 5 )
					trigger_error('[OUTPUT_FILE]  '.$this->output_file .' && array '.print_r(array($receive->GetPath() , $receive->ref, $receive->count_message), true) , E_USER_NOTICE );
					
				
				if ( !file_exists( dirname($this->output_file ) ) ) 
					dol_mkdir( dirname($this->output_file ) );
				/**
					Write file 
				*/
				/// TODO impelement check test and error for return trace message
				$handle = fopen( $this->output_file, "w");
				if ($handle !== false) {
						fwrite($handle, $this->brut_message);
						fclose($handle);
				}

				/**
					SEGMENT FOR PROCESS Event in Calendar
				*/
// 						$ActionComm = new ActionCommEdi($this->db); 
// 						$ActionComm->SetEvent( $user,  $this->thirdparty ,  $res->object , $receive );


				if(! empty( $conf->global->EDIDEBUGLEVEL ) && $conf->global->EDIDEBUGLEVEL >= 5 )
						trigger_error('$type_message '.$type_message.' -- $error '.$error.' -- $notrigger '.$notrigger , E_USER_NOTICE );
						
						
				if (
						// block loop by APERAK Action
						$type_message !='APERAK' 
						&& ! $error 
						&& ! $notrigger
						)
				{
				
						// force ref based on ,refrence object 
						$this->ref = $res->object->ref;
						$this->object_ref =  $res->object ;
						$this->dol_type_id = $res->dol_type_id; 
					
						$this->ref_parent = $trace->ref_uniq; 
						
						if(! empty( $conf->global->EDIDEBUGLEVEL ) && $conf->global->EDIDEBUGLEVEL >= 5 )
						trigger_error(__class__.'>'.__function__.'>'.__line__.' --run trigger called  ' , E_USER_NOTICE );
						// Call trigger
						$result=$this->call_trigger('EDI_CONFIRM_APERAK',$current_user);
						if ($result < 0) { $error++; }
						// End call triggers
				}
	
	
			} catch (Exception $ex) {
					// la réception c'est mal passée
					$trace->message =  'Error in processing : '. $ex->getMessage(). "\n";
					$error++;
					echo $trace->message ;
			}
		} else {
				$trace->message = 'transmission message not supported';
				$error++;
		}


		$trace->trace_message();
								
		if(! empty( $conf->global->EDIDEBUGLEVEL ) && $conf->global->EDIDEBUGLEVEL >= 5 )
		trigger_error('[EDI] --end create' , E_USER_NOTICE );
	}
	
	/**
	*/
	public function update($user){
	}
	
	/**
	*/
	public function fetch($id=0){
		global $conf,$langs;
		
		$sql = "SELECT a.`fk_ref_uniq`, s.nom, s.rowid id, `num_received`,`created_time` date, `trans_mode` , `message_type`,`norme`,`message`,`data`,`accepted`,`related_to` , `dol_type` , `dol_type_id`, `ref_parent` FROM `" . MAIN_DB_PREFIX . "edi_activity` a LEFT JOIN " . MAIN_DB_PREFIX . "edi_element  as ee ON(fk_ref_uniq = ref_uniq ) LEFT JOIN " . MAIN_DB_PREFIX . "societe s on s.rowid = a.fk_soc WHERE  fk_ref_uniq='".$id."' ORDER BY created_time DESC";
// echo $sql; 
		$result = $this->db->query($sql);
		if ($result)
		{
			$obj = $this->db->fetch_object($result);
 
			$this->id =  $obj->fk_ref_uniq; //olds 
			$this->name =  $obj->fk_ref_uniq;  //olds 
			
			$this->ref_uniq=  $obj->fk_ref_uniq;
			
			
			$this->num_received =  $obj->num_received; 
			
			$this->ref_parent =  $obj->ref_parent; 
			$this->dol_type = strtolower($obj->dol_type); 
			$this->dol_type_id=  $obj->dol_type_id; 
			$this->datec =  $obj->date; 

			
			$this->message_type =  $obj->message_type; 
			$this->norme=  $obj->norme; 
			$this->message =  $obj->message; 
			$this->data =  $obj->data; 
			$this->accepted=  $obj->accepted; 
			
// 			$this->fetch_object =  $obj->fetch_object; 
			
// 			$this->flagged =  $obj->flagged; 
// 			$this->answered =  $obj->answered; 
// 			$this->joint =  $obj->joint; 
			
// 			if($this->joint > 0 )
			$this->fetchObjectLinked('','',$this->id, $this->element);

			return $this->id; 
		}
		
		return false; 
	}
	
	/**
		@param $group_id int default is 0, if this not null; not use user_id but usergroupid
	*/
	public function delete($group_id=0, $number=1 ,$id=0, $ref=''){
		global $conf,$langs;
	/*	
		
		$sql = "DELETE FROM ".MAIN_DB_PREFIX."message";
		$sql.= " WHERE 1 ";
		
		if($id <= 0 ){
			if($group_id==0)
				$sql.= " AND user_id = '".$this->user->id."' ";
			else
				$sql.= " AND usergroup_id = '".$group_id."' ";
		}
		
		$sql.= "  AND number ='".$number."' ";
		$sql.= "  AND entity IN (".getEntity($this->element, 1).")";
		
		if($id > 0 ) 
			$sql .=" AND row_id = '" .$id."' ";
		else 
			$sql .=" AND message_id = '" .$ref."' ";

		return $this->db->query($sql);*/
	}
	
/**
	 *  Retourne le libelle du status d'un user (actif, inactif)
	 *
	 *  @param	int		$mode          0=libelle long, 1=libelle court, 2=Picto + Libelle court, 3=Picto, 4=Picto + Libelle long, 5=Libelle court + Picto
	 *  @return	string 			       Label of status
	 */
	function getLibStatut($mode=0)
	{
		return $this->LibStatut($this->status,$mode);
	}

	/**
	 *  Return the status
	 *
	 *  @param	int		$status        	Id status
	 *  @param  int		$mode          	0=long label, 1=short label, 2=Picto + short label, 3=Picto, 4=Picto + long label, 5=Short label + Picto, 5=Long label + Picto
	 *  @return string 			       	Label of status
	 */
	static function LibStatut($status,$mode=0)
	{
		global $langs;

		if ($mode == 0)
		{
			$prefix='';
			if ($status == 1) return $langs->trans('Enabled');
			if ($status == 0) return $langs->trans('Disabled');
		}
		if ($mode == 1)
		{
			if ($status == 1) return $langs->trans('Enabled');
			if ($status == 0) return $langs->trans('Disabled');
		}
		if ($mode == 2)
		{
			if ($status == 1) return img_picto($langs->trans('Enabled'),'statut4').' '.$langs->trans('Enabled');
			if ($status == 0) return img_picto($langs->trans('Disabled'),'statut5').' '.$langs->trans('Disabled');
		}
		if ($mode == 3)
		{
			if ($status == 1) return img_picto($langs->trans('Enabled'),'statut4');
			if ($status == 0) return img_picto($langs->trans('Disabled'),'statut5');
		}
		if ($mode == 4)
		{
			if ($status == 1) return img_picto($langs->trans('Enabled'),'statut4').' '.$langs->trans('Enabled');
			if ($status == 0) return img_picto($langs->trans('Disabled'),'statut5').' '.$langs->trans('Disabled');
		}
		if ($mode == 5)
		{
			if ($status == 1) return $langs->trans('Enabled').' '.img_picto($langs->trans('Enabled'),'statut4');
			if ($status == 0) return $langs->trans('Disabled').' '.img_picto($langs->trans('Disabled'),'statut5');
		}
		if ($mode == 6)
		{
			if ($status == 1) return $langs->trans('Enabled').' '.img_picto($langs->trans('Enabled'),'statut4');
			if ($status == 0) return $langs->trans('Disabled').' '.img_picto($langs->trans('Disabled'),'statut5');
		}
	}

	/**
		*    	Return a link on thirdparty (with picto)
		*
		*		@param	int		$withpicto		Add picto into link (0=No picto, 1=Include picto with link, 2=Picto only)
		*		@param	string	$option			Target of link ('', 'customer', 'prospect', 'supplier')
		*		@param	int		$maxlen			Max length of text
		*		@return	string					String with URL
		*/
	public function getNomUrl($withpicto=0,$option='',$maxlen=0, $params=""){
        global $conf,$langs;


        $result='';


					$file = 'card.php'; 
					
        $lien = '<a class="linkSubject" href="'. dol_buildpath('/edi/'.$file, 1) .'?';

        if($this->id > 0 )
					$lien.='id='.$this->id;

				
				if(strlen($params) > 1)
					$lien.=(substr($params,0,1)=='&')? $params : '&'.$params; 
					
					
					
					
        // Add type of canvas
        $lien.=(!empty($this->canvas)?'&amp;canvas='.$this->canvas:'').'">';
        $lienfin='</a>';

        if ($withpicto) $result.=($lien.img_object($langs->trans("EdiCardView").'','edi@edi').$lienfin);
        if ($withpicto && $withpicto != 2) $result.=' ';
        $result.=$lien.($maxlen?dol_trunc($this->name,$maxlen):$this->name).$lienfin;


        return $result;
    }
}

