<?php
/* Copyright (C) 2015 Oscss-Shop Team <support@oscss-shop.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
dol_include_once("/edi/class/trace.class.php");
dol_include_once('/edi/class/setup_loader.class.php');

loadClass('societe');

use \CORE\FRAMEWORK\Societe as Societe;

class job extends EDI_trace
{

    function __construct($db)
    {
        $this->db = $db;
        parent::__construct($db);
    }

    function program($socid, $message, $norme, $backtopage = false)
    {
        global $user, $conf, $mysoc;

        $setup = new setup_loader($this->db);
        $setup->load_user($socid);
        if ($socid && isset($setup->descriptor->$norme) && isset($setup->descriptor->$norme->message->output->$message)) {

            // societe
            $this->object = new Societe($this->db);
            $this->object->fetch($socid);

            // generate
            $res = $this->RefUniq($socid, 'Societe', $socid);

            // data for edi log
            $this->setMessageType($message);
            $this->setNorme($norme);
            $this->setDirection('output');
            $this->setTransMode($setup->user->trans_mode);
            $this->set_my_soc_id($socid);
            $this->accept_message();

            //
            $this->mysoc = $mysoc;
            $this->setup = $setup;

            dol_include_once('/edi/plugin/'.$norme.$setup->descriptor->$norme->message->output->$message->file);
            $this->build_file();
            //die('/edi/plugin/'.$norme.$setup->descriptor->$norme->message->output->$message->file);
            // data for edi_sen task
            $callable            = 'send_edi_'.$setup->user->trans_mode;
            $this->ref_uniq      = $res->ref_uniq;
            $this->count_message = $res->count_message;
            $sql                 = "INSERT INTO ".MAIN_DB_PREFIX."edi_send ( method, file,  fk_soc, fk_ref_uniq )"
                ." VALUES ( '".$callable."', '".$this->output_file."', '".$socid."', '".$this->ref_uniq."')";
            //
            $this->db->query($sql);
//print $sql;

            //save trace
            $this->trace_message();
            //$this->db->commit();
        }
        if (!empty($backtopage)) {
            header("Location: ".dol_buildPath($backtopage, 2));
            exit;
        }
    }

    /**
      @fn run_trigger()
      @brief execute trigger for this order
     */
    public function build_file()
    {

        $class           = 'EDI\\'.$this->message_type;
        $this->coreclass = new $class($this->object, $this->mysoc, $this->setup);

        $cl      = explode('\\', get_class($this->coreclass->obj_ref));
        $typedoc = strtolower($cl[count($cl) - 1]);
        /**
          Extract ref_uniq
         */
        $res     = $this->RefUniq($this->coreclass->obj_ref->socid, $typedoc, $this->coreclass->obj_ref->id);

        // print_r($res);
        // exit;

        $res->dol_type    = $typedoc;
        $res->dol_type_id = $this->coreclass->obj_ref->id;

        /**
          Extract generate array and construct output
         */
        $this->coreclass->Generate($res);

        /**
          Calulat path and file
         */
        $this->output_file = output_file($this->coreclass->GetPath().'%s'.$res->ref_uniq.'.edi.txt', $this->message_type);

        if (!file_exists(dirname($this->output_file))) dol_mkdir(dirname($this->output_file));
        /**
          Write file
         */
        /// TODO impelement check test and error for return trace message
        $handle = fopen($this->output_file, "wb");
        if ($handle !== false) {
            fwrite($handle, $this->coreclass->encodeUNA());
            //print '<pre>'.$this->coreclass->encodeUNA(FALSE);die();
            fclose($handle);
        }

        return $res;
    }
}
