<?php
/* Copyright (C) 2015 Oscss-Shop Team <support@oscss-shop.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */


dol_include_once('/core/class/CMailFile.class.php');
dol_include_once("/edi/class/trace.class.php");

function dump($content, $return = FALSE)
{
    if ($return) {
        return var_export($content, true);
    } else {
        echo "<pre>";
        var_dump($content);
        echo "</pre>";
    }
}

class edi_send extends EDI_trace
{
    var $db;

    /**
     */
    public function __construct($db)
    {
        $this->db        = $db;
        parent::__construct($this->db);
        $this->direction = 'output';
    }

    /**
      @fn send_edi_email()
     */
    public function send_edi_email()
    {
        global $langs;

        $this->setMessage(file_get_contents($this->output_file));
        $subject           = $langs->trans('EdiMailSubject');
        $to                = $this->setup->user->trans_destination;
        $from              = $this->mysoc->email;
        $body              = "<div>".$langs->trans('EdiMailBody')."</div>";
        $filename_list     = array($this->output_file);
        $mimetype_list     = array();
        $mimefilename_list = array(basename($this->output_file));
        dol_syslog("EDI mail $subject,$to,$from", LOG_INFO, 1);
        $mail              = new CMailFile($subject, $to, $from, $body, $filename_list, $mimetype_list, $mimefilename_list, "", "", 0, 1);
        if ($mail->sendfile()) { // mail sent
            $this->accept_message();
            return true;
        } else {
// TODO error in CmailFile 
//             $mail->dump_mail();
        }

        return false;
    }

    /**
      @fn send_edi_urlflux()
     */
    public function send_edi_urlflux()
    {
        global $conf;

        $this->db->commit(); // free mysql usage for other use ! VERY IMPORTANT

        //header('Content-Type: text/plain;charset=UTF-8');
        $file        = $this->output_file;
        $edi_message = @file_get_contents($file);
        if(!$edi_message){
			$this->response = 'ErrorTransportEdiFileNoFound';
			return false; 
		}
        $this->setData($edi_message);
        $url         = $this->setup->user->trans_destination;


        // prefered method by curl 
        if (empty($conf->global->EDIBLOKCURL) && function_exists('curl_init')) {
            $post = array('file' =>new CURLFile( realpath( $file ), 'txt', basename($file) ) );


			if(empty($post['file']->name) ){
				$this->response = 'ErrorTransportEdiFileNoLoaded';
				return false;
			}


            $mode = substr($url, 0,strpos($url,':') );
            
            $ch       = curl_init();
            curl_setopt($ch, CURLOPT_URL, $url);
            if($mode ==='https'){
				curl_setopt( $ch, CURLOPT_AUTOREFERER, TRUE );
				curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
				curl_setopt($ch, CURLOPT_SSLVERSION,3);
            }
            curl_setopt($ch, CURLOPT_POST, 1);
            curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: multipart/form-data'));
            curl_setopt($ch, CURLOPT_POSTFIELDS, $post);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
            $response = curl_exec($ch);
            
            if($response ===false ){
				$this->response = 'ErrorTransportEdi';
				return false;
			}
			if(!empty($response)){
				print 'This content is result of display process in '.$url."\n\n"; 
				print ($response); 
				exit; 
				$this->response = $response;
				return false;
			}
			curl_close($ch);
        } 
        // methode by fopen
        else {

            trigger_error(__CLASS__.__FUNCTION__.__LINE__.'  sent by fopen', E_USER_NOTICE);

            $post   = array(
                'file' => $edi_message
            );
            $params = array(substr($url, 0,strpos($url,':') ) => array(
                    'method' => 'POST',
                    'content' => http_build_query($post),
                    "ssl"=>array(
						"verify_peer"=>false,
						"verify_peer_name"=>false,
					),
            ));
//             print_r($params); 
            
            $ctx    = stream_context_create($params);
            $fp     = fopen($url, 'rb', false, $ctx);
            if (!$fp) {

                trigger_error('[EDI][SEND] error', E_USER_NOTICE);

                $this->setMessage("EDI Problem with $url, $php_errormsg");
//                 dol_syslog("EDI Problem with $url, $php_errormsg");
            }
            $response = @stream_get_contents($fp);
            if ($response === false) {
                $this->setMessage("EDI Problem reading data from $url, $php_errormsg");
//                 dol_syslog("EDI Problem reading data from $url, $php_errormsg");

                trigger_error('[EDI][SEND] error', E_USER_NOTICE);
            }
        }
		
		// No reponse Its Ok 
		// accepted message and next process
		if ($response == "") {
// 		 trigger_error('[EDI][SEND] error'.print_r($this,true), E_USER_NOTICE);
            $this->response = $response;
            $this->accept_message(1);
			$this->trace_message();
//             $this->AcceptedEnd(); 
            return true;
        }

        return false;
    }

    /**
			@fn send_edi_urlapi()
    */
    public function send_edi_urlapi() {
    
    
		$file = $this->output_file;
        $edi_message = file_get_contents($file);
        $this->setData($edi_message);
        $subclass = $this->setup->user->trans_destination;
        
        dol_include_once('/edi/class/'.$subclass.'.class.php');
        
        $cl = new $subclass(); 
        
        $resp = $cl->SendInvoice($this->output_file); 
        
        if(!$resp) {
			trigger_error('[EDI][SEND] error'  , E_USER_NOTICE);
			return false;
        }
        else{
			$result = json_decode($resp); 
        }
        

        return false; 
    }
    
    
    /**
      @fn send_edi_sftpkey()
     */
    public function send_edi_sftpkey()
    {
    
        $ftp_srv = $this->setup->user->trans_destination;
        $file    = $this->output_file;

		dol_include_once('/edi/class/transportsftp.class.php');
 
		$cl = new \TRANSPORT\transportsftp(	
							$this->setup->user->trans_destination
							, $this->setup->user->trans_login 
							, $this->setup->user->trans_pass
							, $this->setup->user->trans_file 
							
							); 
        
        $resp = $cl->SetMethod($this->setup->user->trans_mode); 
        
        $resp = $cl->send($this->output_file); 
        
		if(!$resp) {
			trigger_error('[EDI][SEND] error'  , E_USER_NOTICE);
			$this->response = implode("\n",$cl->errors);
        }
        else{
            $this->accept_message(1);
        }

		
		$this->trace_message();
		
		if($resp)
			return true; 
			
        return false;
    }
    
    /**
      @fn send_edi_ftp()
     */
    public function send_edi_ftp()
    {
        $ftp_srv = $this->setup->user->trans_destination;
        $file    = $this->output_file;
        $conn_id = $this->getFTPConnection($ftp_srv);

        $stream = fopen($file, 'r');

        if (ftp_fput($conn_id, $file, $stream, FTP_BINARY)) {
            dol_syslog('EDI transmission, FTP uploaded '.basename($file), 'TRANSMISSION');

            return true;
        } else {
            dol_syslog('EDI transmission, FTP error on upload '.basename($file), 'TRANSMISSION');
        }

        return false;
    }

    /**
      @fn getFtpConnection($uri)
      @param $uri
     */
    private function getFtpConnection($uri)
    {
        // Split FTP URI into:
        //[0] => ftp://USER:PASSWORD@domain.fr/home/rep/
        //[1] => USER
        //[2] => PASSWORD
        //[3] => domain.fr
        //[4] => /home/rep/
        preg_match("/ftp:\/\/(.*?):(.*?)@(.*?)(\/.*)/i", $uri, $match);

        // Set up a connection
        $conn = ftp_connect($match[3]);

        // Login
        if (ftp_login($conn, $match[1], $match[2])) {
            // Change the dir
            ftp_chdir($conn, $match[4]);

            // Return the resource
            return $conn;
        }

        // Or retun null
        return null;
    }
}
