<?php
/* Copyright (C) 2015 Oscss-Shop Team <support@oscss-shop.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */


/*
  TODO :
 * write update_user fct
 * write save_user fct
 */

class setup_loader
{
    var $descriptor, $db, $user;

    function __construct($db)
    {
        $this->db = $db;
        $this->load_conf_files();
    }

    /**
      @fn load_user();
      @brief update config for edi user
      @param int $tiers_id  id societe
      @param string $client_mode  type of client (client/vendor)
      @return object user
     */
    function load_user($tiers_id, $client_mode = 'client')
    {


        if (is_int($client_mode)) {
            $complement = " AND `rowid` = '".$this->db->escape($client_mode)."'";
        } else {
            $complement = " AND `client_mode` = '".$this->db->escape($client_mode)."'";
        }
        $this->user   = new stdClass();
        $this->fk_soc = $tiers_id;
        $sql          = "SELECT `rowid`, `edi_num`, `trans_mode`, `trans_destination`, trans_dest_other FROM `".MAIN_DB_PREFIX."edi_societe`
            WHERE `fk_soc` = '".$this->db->escape($tiers_id)."' $complement ";
        $resql        = $this->db->query($sql);

        if ($resql && $this->db->num_rows($resql) == 1) {
            $user_details = $this->db->fetch_object($resql);

            $this->user = $user_details;
            $tp =  json_decode($user_details->trans_dest_other);
            

            if(is_object($tp)) 
            foreach($tp as $k=>$v)
				$this->user->{'trans_'.$k} = $v; 
				
            
            $rowid      = $user_details->rowid;
        } else {
            $this->user->edi_num           = "";
            $this->user->trans_mode        = "";
            $this->user->trans_destination = "";
            $this->user->trans_dest_other = "";
            $rowid                         = 0;
        }

        $this->user->setup = new stdClass();
        foreach ($this->descriptor as $norme => $norme_array) {
            foreach ($norme_array->message as $direction => $direction_array) {
                foreach ($direction_array as $message => $message_array) {
                    $sql   = "SELECT allowed FROM `".MAIN_DB_PREFIX."edi_societe_setup`
                            WHERE `fk_soc_row` = '$rowid' 
                            AND `norme` = '$norme' 
                            AND `message` = '$message'
                            AND `direction` = '$direction'";
                    $resql = $this->db->query($sql);
                    if (!isset($this->user->setup->$norme)) { // avoid warning in log
                        $this->user->setup->$norme = new stdClass();
                    }
                    if (!isset($this->user->setup->$norme->message)) { // avoid warning in log
                        $this->user->setup->$norme->message = new stdClass();
                    }
                    if (!isset($this->user->setup->$norme->message->$direction)) { // avoid warning in log
                        $this->user->setup->$norme->message->$direction = new stdClass();
                    }
                    if ($resql && $this->db->num_rows($resql) == 1) {
                        $setup                                                    = $this->db->fetch_object($resql);
                        // or we have info in DB
                        $this->user->setup->$norme->message->$direction->$message = $setup->allowed;
                    } else {
                        // or it s not allowed
                        $this->user->setup->$norme->message->$direction->$message = "0";
                    }
                }
            }
        }
//         print_r($this->user->setup); 
//         exit; 
        return $this->user;
    }

    /**
      @brief will inject datas in array
     */
    function update_user($edi_num, $trans_mode, $trans_destination, $trans_dest_other=null, $array)
    {
        $this->user->edi_num           = trim($edi_num);
        $this->user->trans_mode        = trim($trans_mode);
        $this->user->trans_destination = trim($trans_destination);
        $this->user->trans_dest_other = $trans_dest_other;
        foreach ($this->user->setup as $norme => $norme_array) {
            foreach ($norme_array->message as $direction => $direction_array) {
                foreach ($direction_array as $message => $allowed) {
                    if (isset($array->$norme->message->$direction->$message)) {
                        $this->user->setup->$norme->message->$direction->$message = 1;
                    } else {
                        $this->user->setup->$norme->message->$direction->$message = 0;
                    }
                }
            }
        }
    }

    /**
      @brief will save datas in DB
      @todo: use INSERT UPDATE, there is an uniq constraint
     */
    function save_user($client_mode = 'client')
    {

         $sql = "INSERT INTO ".MAIN_DB_PREFIX."edi_societe (fk_soc, client_mode, edi_num, trans_mode, trans_destination, trans_dest_other)
                VALUES ('{$this->fk_soc}','$client_mode','{$this->user->edi_num}','{$this->user->trans_mode}','{$this->user->trans_destination}','{$this->user->trans_dest_other}')
                ON DUPLICATE KEY UPDATE 
                edi_num='{$this->user->edi_num}',
                trans_mode='{$this->user->trans_mode}',
                trans_destination='{$this->user->trans_destination}',
                trans_dest_other='{$this->user->trans_dest_other}'";
 

        $r = $this->db->query($sql);

        foreach ($this->user->setup as $norme => $norme_array) {
            foreach ($norme_array->message as $direction => $direction_array) {
                foreach ($direction_array as $message => $allowed) {
                    $sql = "INSERT INTO ".MAIN_DB_PREFIX."edi_societe_setup (fk_soc_row, norme, direction, message, allowed)
                        VALUES ('{$this->user->rowid}','$norme','$direction','$message','$allowed') ON DUPLICATE KEY UPDATE fk_soc_row='{$this->user->rowid}',
													norme='{$norme}',
													direction='{$direction}',
													message='{$message}',
													allowed = '{$allowed}'
                        ";

//                         echo $sql; 
                    $this->db->query($sql);
                    if ($this->db->error) die($this->db->error);
                }
            }
        }

// exit;
    }

    public function add_conf_files($files)
    {

		
        foreach ($files as $file) {

			
            switch (true) {

                // can replace a plugin
                case preg_match('/descriptor\.json/', $file['stored_filename']):

                    $descriptor = json_decode(file_get_contents($file['filename']));
                    $this->merge_descriptor($descriptor); // can replace a plugin
                    break;

                // will not replace a trigger, just add
                case preg_match('/trigger\.json/', $file['stored_filename']):
                    $trigger = json_decode(file_get_contents($file['filename']));
                    $this->add_trigger($trigger); // will not replace a trigger, just add
                    break;

                case preg_match('/\.lang$/i', $file['stored_filename']):
                    $file_parts = pathinfo($file['stored_filename']);
                    if (strpos($file['stored_filename'], '-') == FALSE) return false;
                    list($path, $filename) = explode('-', $file['stored_filename']);
                    $path       = dol_buildpath('/edi/langs/').$path;
                    copy($file['filename'], $path.DIRECTORY_SEPARATOR.$filename);
                    break;

                // install plugin
                default:
                    //check it s a PHP file
                    $file_parts = pathinfo($file['stored_filename']);

                    if ($file_parts['extension'] == "php") {
                        if (strpos($file['stored_filename'], '-') == FALSE) return false;
                        list($path, $filename) = explode('-', $file['stored_filename']);
                        $path = dol_buildpath('/edi/plugin/').implode(DIRECTORY_SEPARATOR, explode('_', $path));
                        mkdir($path, 0777, true);
                        copy($file['filename'], $path.DIRECTORY_SEPARATOR.$filename);
                    } else {
                        return false;
                    }
                    break;
            }
        }
        return $this->save_conf_files();
    }

    /**
		Add line in descriptor if line not exists
    */
    private function add_trigger($triggers)
    {
        foreach ($triggers as $norme => $norme_array) {
        
			foreach ($norme_array as $method => $norme_array_m) {

				foreach ($norme_array_m as $event => $triggers_array) {

					foreach ($triggers_array as $type=>$trigger_array) {
						if (!isset($this->descriptor->$norme)) 
							$this->descriptor->$norme                  = new stdClass();
						if (!isset($this->descriptor->$norme->$method)) 
							$this->descriptor->$norme->$method         = new stdClass();
						if (!isset($this->descriptor->$norme->$method->$event)) 
							$this->descriptor->$norme->$method->$event = new stdClass();
						if (!isset($this->descriptor->$norme->$method->$event->$type)) 
							$this->descriptor->$norme->$method->$event->$type = array();
							
						$exist = false;

						
						foreach($this->descriptor->$norme->$method->$event->$type as $test)
							if($test->file == $trigger_array->file)
								$exist = true;
								
						if(!$exist )
							array_push($this->descriptor->$norme->$method->$event->$type, $trigger_array);
					}
				}
			}
        }
    }

    private function merge_descriptor($descriptor)
    {
        $array1           = json_decode(json_encode($this->descriptor), true);
        $array2           = json_decode(json_encode($descriptor), true);
        $arrayOut         = array_replace_recursive($array1, $array2);
        $this->descriptor = json_decode(json_encode($arrayOut), false);
    }

    /**
      @fn load_conf_files()
      @brief load list of support type of echange
      @return array
     */
    private function load_conf_files()
    {


        $dir = dol_buildpath('/edi/plugin/').'*/descriptor.json';

        $array = new stdClass();
        $files = glob($dir, GLOB_BRACE);
        foreach ($files as $file) {
            $rep           = explode('/', dirname($file));
            $norme         = array_pop($rep);
            $array->$norme = json_decode(file_get_contents($file));
        }
        $this->descriptor = $array;
        return $array;
    }

    function save_conf_files()
    {
        $return = true;
        foreach ($this->descriptor as $norme => $array) {
            $path = dol_buildpath('/edi/plugin/'.$norme);
            if (is_dir($path)) {
                $filename = $path.DIRECTORY_SEPARATOR.'descriptor.json';
                $return   = $return && file_put_contents($filename, json_encode($array, JSON_PRETTY_PRINT));
            }
        }
        return $return;
    }

    function find_users($norme = '', $message = '')
    {
        $soc = array();
        $sql = "SELECT  DISTINCT(es.fk_soc)
            FROM `".MAIN_DB_PREFIX."edi_societe_setup` as `esc`
            LEFT JOIN `".MAIN_DB_PREFIX."edi_societe` as `es` ON esc.`fk_soc_row` = es.rowid
            WHERE edi_num IS NOT NULL
            AND edi_num !=''
            AND direction='output'
            AND norme='$norme'
            AND client_mode = 'vendor'
            AND message = '$message'";

        //trigger_error("TRIGGER find_users: ".str_replace("\r\n", '', $sql), E_USER_NOTICE);
        $resql = $this->db->query($sql);
        while ($row   = $this->db->fetch_object($resql)) {
            $soc[] = $row->fk_soc;
        }
        return $soc;
    }
}
