<?php
/* Copyright (C) 2015 Oscss-Shop Team <support@oscss-shop.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */


class EDI_trace {

    private $db
        , $accepted
        , $traced
    ;
    public $direction
				, $message
				, $trans_mode
				, $fk_soc
				, $message_type
				, $related_to
				, $norme
				, $ref_parent
				, $dol_type
				, $dol_type_id
				;

    /**
     */
    function __construct($db)
    {
        global $conf;
        $this->db           = $db;
        $this->trans_mode   = '';
        $this->set_my_soc_id();
        $this->related_to   = "NULL";
        $this->message_type = '';
        $this->norme        = '';
        $this->accepted     = 0;
        $this->traced       = false;
        $this->response     = "";
        $this->message      = "";
        $this->data         = "";
        $this->entity       = $conf->entity;

//         if (GETPOST('trans_mode', 'alpha') === "email") {
//             $this->trans_mode = 'email';
//         }
    }

    /**
     */
    function setDirection($direction)
    {
        $this->direction = $direction;
    }

    /**
     */
    public function getNbMessages($extend = '')
    {
        $sql   = "SELECT COUNT(*) NB FROM `".MAIN_DB_PREFIX."edi_activity` WHERE `direction` = '{$this->direction}' $extend";
        $resql = $this->db->query($sql);
        $count = $this->db->fetch_object($resql);
        return $count->NB;
    }

    /**
     */
    function getNbMessagesFailed()
    {
        return $this->getNbMessages('AND `accepted`=0');
    }

    /**
    */
    public function setData($data) {
				$this->data = $data;
    }

    /**
    */
    public function setMessage($message) {
			global $conf;

			$this->message = $this->message."\n".$message;

			if(! empty( $conf->global->EDIDEBUGLEVEL ) && $conf->global->EDIDEBUGLEVEL >= 3)
			trigger_error('[INFO]'.$message  , E_USER_NOTICE);
    }

    /**
     */
    function setMessageType($message)
    {
        $this->message_type = $message;
    }

    /**
     */
    function setNorme($message)
    {
        $this->norme = $message;
    }

    /**
		@fn setTransMode()
		@param string $trans_mode
		@return none
     */
    function setTransMode($trans_mode)
    {
        $this->trans_mode = $trans_mode;
    }

    /**
     */
    public function accept_message($val = 1)
    {
        $this->accepted = $val;
    }

    public function GetAccepted()
    {
        return $this->accepted;
    }

    /**
      @brief check if refuniq exists
     */
    public function CheckRefExist($fk_soc, $ref_uniq = '', $ref_parent = '')
    {
        $sql = " SELECT ee.*, ea.accepted FROM ".MAIN_DB_PREFIX."edi_element ee LEFT JOIN ".MAIN_DB_PREFIX."edi_activity ea ON(fk_ref_uniq = ref_uniq)  WHERE ee.fk_soc =  '{$fk_soc}' ";

        if ($ref_uniq != '') $sql .= " AND  `ref_uniq` =  '{$ref_uniq}' ";

        if ($ref_parent != '') $sql .= " AND  `ref_parent` =  '{$ref_parent}'  ";

        if (!empty($conf->global->EDIDEBUGLEVEL) && $conf->global->EDIDEBUGLEVEL >= 5) trigger_error(__function__.' '.$sql, E_USER_NOTICE);


        $resql = $this->db->query($sql);
        if ($resql) {
            $num = $this->db->num_rows($resql);

            if ($num > 0) {
                $obj = $this->db->fetch_object($resql);


                if ($obj->ref_uniq == $ref_uniq) {
                    $this->dol_type    = strtolower($obj->dol_type);
                    $this->dol_type_id = $obj->dol_type_id;
                    $this->accepted    = (int)$obj->accepted;
                    return true;
                } else return false;
            }
        }

        return false;
    }

    /**
      @fn RefUniq
      @brief
      @param $fk_soc int soc id
      @param $dol_type string type of docuement reference in dolibarr
      @param $dol_type_id int id of docuement reference in dolibarr
      @param $ref_uniq string current ref if exists
      @return object StdClass
      ->ref_uniq
      ->count_message
      ->ref_parent
     */
    public function RefUniq(
    $fk_soc
    , $dol_type
    , $dol_type_id
    , $ref_uniq = ''
    )
    {
        global $conf;

        $dol_type         = strtolower($dol_type);
        $t                = new stdClass();
        $t->ref_uniq      = '';
        $t->count_message = 1;
        $t->ref_parent    = '';

        $sql = " SELECT * FROM ".MAIN_DB_PREFIX."edi_element WHERE `fk_soc` =  '{$fk_soc}' ";
        $sql .= " AND ( `dol_type` =  '{$dol_type}' AND `dol_type_id` =  '{$dol_type_id}') ";

        if ($ref_uniq != '') {
            $sql .= " AND ( `ref_parent` =  '{$ref_uniq}' OR `ref_uniq` =  '{$ref_uniq}') ";

            $t->ref_uniq = $ref_uniq;
        }

        $sql .= " ORDER BY count_message DESC";

//         trigger_error($sql. 'doltype'.$dol_type, E_USER_NOTICE);
        
        if (!empty($conf->global->EDIDEBUGLEVEL) && $conf->global->EDIDEBUGLEVEL >= 5) trigger_error(__class__.'>'.__function__.'>'.__line__.' -- '.$sql, E_USER_NOTICE);


        $resql = $this->db->query($sql);

        $compteur = 1;


        if ($resql) {
            $num = $this->db->num_rows($resql);
            $i   = 0;

            while ($i < $num) {
                $obj = $this->db->fetch_object($resql);
                $i++;

                if ($i > 1) continue;

                if (!empty($obj->ref_parent)){
					$t->ref_parent = $obj->ref_parent;
					$t->ref_uniq   = '';
				}
                elseif (empty($t->ref_parent)) {
                    $t->ref_parent = $obj->ref_uniq;
                    $t->ref_uniq   = '';
                }
// 							if( $obj->count_message > $t->count_message)
// 								$t->count_message = ((int)$obj->count_message + 1 );
            }

            $t->count_message = ((int) $num + 1);
            
            if( $t->ref_parent ==  $t->ref_uniq)
				$t->ref_uniq   = '';
            if( $obj->count_message > 1 )
				$t->ref_uniq   = '';
        }

// trigger_error($t->ref_uniq. 'ref parent '.$t->ref_parent, E_USER_NOTICE);
        if (empty($t->ref_uniq)) {
            $ty = 0;
            if ($dol_type == 'commande') $ty = 1;
            elseif ($dol_type == 'commandefournisseur') $ty = 2;
            elseif ($dol_type == 'facture') $ty = 3;
            elseif ($dol_type == 'facturefournisseur') $ty = 4;
            elseif ($dol_type == 'expedition') $ty = 5;
            elseif ($dol_type == 'livraison') $ty = 6;

            $t->ref_uniq = date('ymdhis').$ty.$obj->count_message;//.$dol_type_id;
            
//             trigger_error('NEW ref '.$t->ref_uniq, E_USER_NOTICE);
            
        }
        if (!empty($conf->global->EDIDEBUGLEVEL) && $conf->global->EDIDEBUGLEVEL >= 5) trigger_error(__class__.'>'.__function__.'>'.__line__.' -- '.print_r($t, true), E_USER_NOTICE);
        return $t;
    }
    /**
			@brief test les variale defini et renvoi code de consolidation

			@return
					-101 error dol_type incorrect type
					-102 doltype empty

					-111 dol_type_id invalid

					-121 fk_soc invalid

					-201 ref_uniq empty
    */
//     public funciton CheckAndPass(){
//
// 			$this->accepted = 0;
//
// 			if( !empty($this->dol_type) ){
// 				if( !preg_match('#[a-z_]{3,}#i', $this->dol_type ) || (string)$this->dol_type != $this->dol_type )
// 					$this->accepted = -101;
//
// 			}
// 			else
// 					$this->accepted = -102;
//
// 			if( empty($this->dol_type_id) ||  $this->dol_type_id <0 )
// 				$this->accepted = -111;
//
// 			if( empty($this->fk_soc) ||  $this->fk_soc <0 )
// 				$this->accepted = -121;
//
// 			if( empty($this->ref_uniq) )
// 				$this->accepted = -201;
//
//
// 			return $this->accepted;
//     }
    /**
      @fn trace_message()
      @brief
      @return none
     */
    public function trace_message()
    {
        global $conf;
        if (!$this->traced) {


            $this->dol_type = strtolower($this->dol_type);

            $sql = " INSERT INTO ".MAIN_DB_PREFIX."edi_element ( `ref_uniq` , `fk_soc` , `ref_parent` , `count_message` , `dol_type` , `dol_type_id` )".
                " VALUES ( '{$this->ref_uniq}', '{$this->fk_soc}', ".(($this->ref_parent != '') ? "'{$this->ref_parent}'" : "NULL" )." , '{$this->count_message}', '{$this->dol_type}', '{$this->dol_type_id}' );";
//print $sql;

            if (!empty($conf->global->EDIDEBUGLEVEL) && $conf->global->EDIDEBUGLEVEL >= 5) trigger_error(__CLASS__.' '.$sql, E_USER_NOTICE);

            $this->db->query($sql);


            $sql = "INSERT INTO ".MAIN_DB_PREFIX."edi_activity ( `fk_ref_uniq`, `entity`, `fk_soc`, `created_time`, `ip`, `trans_mode`, `direction`, `num_received`, `message_type`, `norme`, `related_to`, `message`, `accepted`, `data`)".
                " VALUES ('{$this->ref_uniq}', '{$this->entity}', '{$this->fk_soc}', CURRENT_TIMESTAMP, '".$this->getipmessage()."', '{$this->trans_mode}', '{$this->direction}', '', '{$this->message_type}', '{$this->norme}', ".$this->related_to.", '".$this->db->escape($this->message)."', '{$this->accepted}', '".$this->db->escape($this->data)."')";
//print $sql;

            if (!empty($conf->global->EDIDEBUGLEVEL) && $conf->global->EDIDEBUGLEVEL >= 5) trigger_error(__CLASS__.' '.$sql, E_USER_NOTICE);


            //var_dump($sql);die();
            $this->db->query($sql);

        
            // Fix status parent
//             if($this->ref_parent>0){
// 				$this->AcceptedEnd($this->ref_parent); 
//             }
            
            $this->traced = TRUE;
            $this->db->commit();


            if (!empty($conf->global->EDIDEBUGLEVEL) && $conf->global->EDIDEBUGLEVEL >= 4) trigger_error($this->message, E_USER_NOTICE);
        }
    }

    /**
		Update Accpeted col 
    */
    public function AcceptedEnd($ref_parent, $accepted='0'){
		$sql = "UPDATE  ".MAIN_DB_PREFIX."edi_activity SET accepted = '".$accepted."' WHERE fk_ref_uniq = '".$ref_parent."'";
	
		$this->db->query($sql);
    }
    /**
      @fn getipmessage
      @return ip xxx.xxx.xxx.xxx
     */
    function getipmessage()
    {
        if (getenv('HTTP_CLIENT_IP') && strcasecmp(getenv('HTTP_CLIENT_IP'), 'unknown')) {
            $onlineip = getenv('HTTP_CLIENT_IP');
        } elseif (getenv('HTTP_X_FORWARDED_FOR') && strcasecmp(getenv('HTTP_X_FORWARDED_FOR'), 'unknown')) {
            $onlineip = getenv('HTTP_X_FORWARDED_FOR');
        } elseif (getenv('REMOTE_ADDR') && strcasecmp(getenv('REMOTE_ADDR'), 'unknown')) {
            $onlineip = getenv('REMOTE_ADDR');
        } elseif (isset($_SERVER['REMOTE_ADDR']) && $_SERVER['REMOTE_ADDR'] && strcasecmp($_SERVER['REMOTE_ADDR'], 'unknown')) {
            $onlineip = $_SERVER['REMOTE_ADDR'];
        }
        return $onlineip;
    }

    /**
      @fn
      @brief
      @param $id int id societe
      @return none;
     */
    function set_my_soc_id($id = 1)
    {
        if (isset($id) && $id != "") {
            $this->fk_soc = $id;
        } else {
            $this->fk_soc = 1;
        }
    }
}
