<?php
/* Copyright (C) 2016		 Oscss-Shop       <support@oscss-shop.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * 	\file       htdocs/core/boxes/box_marges.php
 * 	\ingroup    marges
 * 	\brief      Module to build boxe for events
 */
include_once DOL_DOCUMENT_ROOT . '/core/boxes/modules_boxes.php';
require_once DOL_DOCUMENT_ROOT.'/core/lib/date.lib.php';


/**
 * Class to manage the box to show last events
 */
class box_ediinfo extends ModeleBoxes {

    var $boxcode = "ediinfo";
    var $boximg = "object_list";
    var $boxlabel = "Box_ediinfo";
    var $depends = array();
    var $db;
    var $param;
    var $info_box_head = array();
    var $info_box_contents = array();
    var $source;

    
    
    public  $enabled = false
			, $defaulton = array('Edi','edi') ; 
    
    
    public function __construct($db, $param = '') {
        // specific
//         $this->source = new commandeImpact($db);
        //init
        $this->db = $db;
        $this->param = $param;
        parent::__construct($db, $param);
        
        global $user, $langs,  $conf;
        

					$this->enabled = true; 
    }

    /**
     *  Load data for box to show them later
     *
     *  @param	int		$max        Maximum number of records to load
     *  @return	void
     */
    function loadBox($max = 5) {
        global $user, $langs,  $conf, $bc;

        
        
			$ediinfo='';

			$ediinfo.= '<table summary="'.dol_escape_htmltag($langs->trans("EdiInformation")).'" class="noborder boxtable" width="100%">';

			$ediinfo.= '<tr '.$bc[false].'>';
			$ediinfo.= '<td class="nowrap">'.$langs->trans("EdiMyNumber").'</td><td>'.$conf->global->EDI_UNIQNUM.'</td></tr>';
			$ediinfo.= '<tr '.$bc[true].'>';
			$ediinfo.= '<td class="nowrap">'.$langs->trans("EdiMyUrl").'</td><td>'. dol_buildpath("/edi/receive.php", 2) .'</td>';
			$ediinfo.= "</tr>\n";
			$ediinfo.= "</table>\n";

							


  
			$this->info_box_contents[0][0] = array('td' => 'colspan="4" align="center" class="nohover"',
            'textnoformat' => $ediinfo);
            
        $this->info_box_head = array(
            'text' => $langs->trans("EdiInformation"),
            'limit' => dol_strlen($langs->trans("EdiInformation")),
            'graph' => 0,
            'target' => 'none'
        );

    }
    
    
    

    /**
     * 	Method to show box
     *
     * 	@param	array	$head       Array with properties of box title
     * 	@param  array	$contents   Array with properties of box lines
     * 	@return	void
     */
    function showBox($head = null, $contents = null, $nooutput=0) {
        parent::showBox($this->info_box_head, $this->info_box_contents);
    }

}


