<?php
/* Copyright (C) 2016		 Oscss-Shop       <support@oscss-shop.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 * or see http://www.gnu.org/
 */

/**
 *	\defgroup   masterkink
 *	\brief      
 */

/**
 *	\file       /edi/core/modules/modD96ainvoic.class.php
 *	\ingroup    chorus / edi
 */



global $conf;
if (isset($conf->framework) && $conf->framework->enabled) {
    dol_include_once('/framework/class/dolmodexts.class.php');
    global $langs;
    $langs->load('framework');
    class_alias('DolModExts', 'DolibarrD96ainvoic');
} 
else{
	include_once(DOL_DOCUMENT_ROOT ."/core/modules/DolibarrModules.class.php");
	class_alias('DolibarrModules', 'DolibarrD96ainvoic');
}


/**
 \class      modD96ainvoic
 \brief      Classe de description et activation du module 
 */

class modD96ainvoic 
	extends DolibarrD96ainvoic
{
	
	/**
		@var greffon 
	*/
	public $greffon = 1; 
	/**
		@var greffon parent string
	*/
	public $herit = 'edi';
	
	/**
	 *   \brief      Constructeur. Definit les noms, constantes et boites
	 *   \param      DB      handler d'acces base
	 */
	function __construct($DB)
	{
		global $langs, $conf;
		
		$this->db = $DB ;
		$this->numero = 121043 ;


		// Module label (no space allowed), used if translation string 'ModuleXXXName' not found (where XXX is value of numeric property 'numero' of module)
		$this->name = preg_replace('/^mod/i','',get_class($this));
		$this->description = "D96ainvoic";

		
		if (isset($conf->edi) && $conf->edi->enabled) {
			$this->GetFileBuild();
			$this->loadOscssConf();
			// Boites
// 			$this->loadbox('/'.$this->code.'/core/boxes/', '\CORE\MASTERLINK\\');
		}
		else 
			// Boites
			$this->boxes = array();
			
			$this->FixGreffon(); 


		// Data directories to create when module is enabled
// 		$this->dirs = array("/D96ainvoic");
		
        
		// Dependencies
		$this->depends = array('modEdi' );
		$this->requiredby = array();

		$this->conflictwith = array();

		// Defined all module parts (triggers, login, substitutions, menus, etc...) (0=disable,1=enable)
		$this->module_parts = array(
// 				 'hooks' => array(
// 										'greffon'
// 										, 'edi'
// 										, 'main'
// 					),
					
					'greffon'=>array('edi')
			);


// 		$this->config_page_url = array("index.php?page=chorus@edi");
		
		$r=0;

        $r++;
		
		/**
			@remarks End loaded config ans auto-config construct
		*/
		if (isset($conf->edi) && $conf->edi->enabled)
			$this->EndLoader(); 
	}

		/**
	 * Function called when module is enabled.
	 * The init function adds tabs, constants, boxes, permissions and menus (defined in constructor) into Dolibarr database.
	 * It also creates data directories
	 *
	 * @param string $options   Options when enabling module ('', 'newboxdefonly', 'noboxes')
     *                          'noboxes' = Do not insert boxes
     *                          'newboxdefonly' = For boxes, insert def of boxes only and not boxes activation
	 * @return int				1 if OK, 0 if KO
	 */
	public function init( $options = ''){
		global $conf, $db;

		
		$sql = array(
		);
		
	
// 		dol_include_once('/core/class/extrafields.class.php');
// 		$extrafields=new ExtraFields($this->db);
// 		$res = $extrafields->addExtraField('choruscodeservice', 'D96ainvoic Code Service', 'varchar', 0, '255', 'contact', 0, 0, '', array());
	
	
	
		dol_include_once('/edi/core/lib/edi.lib.php');
		dol_include_once('/edi/class/setup_loader.class.php');

		$setup = new setup_loader($db);

		$setup->add_conf_files(array( array('stored_filename'=>'descriptor.json', 'filename'=>dol_buildpath('/edi/plugin/D96A/d96ainvoic_trigger.json',0) ) ) );
		
		$setup->save_conf_files();

		return $this->_init($sql, $options);
	}

    /**
     *      \brief      Function called when module is disabled.
     *                  Remove from database constants, boxes and permissions from Dolibarr database.
     *                  Data directories are not deleted.
     *      \return     int             1 if OK, 0 if KO
     */
	function remove($options = '')
	{
		global $conf;
		
		$sql = array(
		);


		return $this->_remove($sql, $options);
	}


	
	/**
		@fn FixGreffon()
		@brief Specific for greffon by edi engine
		@return none
	*/
	public function FixGreffon(){
	
		// No listen in general config module
		$this->special = 5;
		$this->hidden = true;
		
		$this->family = "Configuration";
	}
		
		/**
			@fn ListFile()
			@brief Specific for greffon by edi engine
			@return none
		*/
    public function ListFile(){
			$this->files = array(
				 '/core/modules/modMasterklink.php'
				,'/class/action_chorus.class.php'
				,'/class/html.chorus.class.php'
				,'/class/chorus.class.php'
				,'/sql/llx_chorus.key.sql' 
				,'/sql/llx_chorus.sql'
				
// 				,'/ChangeLog' 
			
			); 
    
    
    }
}
 
