<?php
/* Copyright (C) 2015 Oscss-Shop Team <support@oscss-shop.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */


/**
 * 		\defgroup   fournisseur     Module suppliers
 * 		\brief      Module pour gerer des societes et contacts de type fournisseurs
 * 		\file       htdocs/core/modules/modFournisseur.class.php
 * 		\ingroup    fournisseur
 * 		\brief      Fichier de description et activation du module Fournisseur
 */
global $conf;
if (isset($conf->framework) && $conf->framework->enabled) {
    dol_include_once('/framework/class/dolmodexts.class.php');
    global $langs;
    $langs->load('framework');
    class_alias('DolModExts', 'DolibarrModulesEdi');
} else class_alias('DolibarrModules', 'DolibarrModulesEdi');

/**
 * 	Classe de description et activation du module EDI
 */
class modEdi extends DolibarrModulesEdi
{

    /**
     *   Constructor. Define names, constants, directories, boxes, permissions
     *
     *   @param      DoliDB		$db      Database handler
     */
    function __construct($db)
    {
        global $conf, $langs;

        $this->db     = $db;
        $this->numero = 121003;
        // Module label (no space allowed), used if translation string 'ModuleXXXName' not found (where XXX is value of numeric property 'numero' of module)
        $this->name   = preg_replace('/^mod/i', '', get_class($this));

        if (isset($conf->framework) && $conf->framework->enabled) {

            $this->GetFileBuild();
            $this->loadOscssConf();
            // Boites
            $this->loadbox('/edi/core/boxes/', '\CORE\EDI\\');
        } else
        // Boites
            $this->boxes = array();


        $this->description = $langs->trans("EDIdescription");

        // Data directories to create when module is enabled
        $this->dirs = array();

       
		$required = json_decode(file_get_contents(dol_buildPath('/edi/core/requiredby.json',0)));

        // Dependencies Core Dolibarr Module
        $this->depends = array( "modProduct", 'modService');

        if (is_array($required->depends))
                foreach ($required->depends as $row)
                $this->depends[] = 'mod'.$row->module;

        $this->requiredby = array();

        if (is_array($required->requiredby))
                foreach ($required->requiredby as $row)
                $this->requiredby[] = 'mod'.$row->module;
                
                

        $this->module_parts = array(
            'triggers' => 1
            // Set this to 1 if module overwrite template dir (core/tpl)
//             'tpl' => 1,
            , 'hooks' => array(
                'ediexternaltabs'
                , 'edicard'
                , 'edilist'
                , 'edicardlist'
                , 'ediwaiting'
                , 'ordercard'
            )  // Set here all hooks context managed by module. You can also set hook context 'all'
            /**
              @remark Specifical section of framework compatibilitie view Oscss-Shop company
             */
            // default 0, 1 for active ; Construst in admin section the panel for manage extra fields  fo this object ; the menu of config section is auto adjusted
// 						 , 'useextrafields' => 	array(
// 									$this->code
// // 								, $this->code.'taskin'
// 							)
            // default 0, 1 for active ; Construst in admin section the panel for manage extra fields  fo this object ; the menu of config section is auto adjusted
// 						 , 'useextrafieldsline' => 0
            // Actiavte segment of odt , complement of models param
            // this section create In cst_table NAme of SAMPLE_ADDON_PDF
// 						, 'genericmodels' => array(
// 									'internal' =>array(
// 											'type'=> array('pdf', 'odt')
// 										)
// 								, 'external' =>array(
// 											'taskin'=>array(
// 													'type'=> array('pdf', 'odt')
// 													, 'perms' =>'!empty($conf->global->QUALITYREPORT_USE_TASKIN)'
// 												)
// 								)
// 							)
            // Activate module for generate ref in object
            // this section create In cst_table NAme of SAMPLE_ADDON
// 						, 'numberingrule' => array(
// 									'internal' =>array(
// 										'default' =>'mod_qualityreport_simple'
// 									)
// 								, 'external' =>array(
// 											'taskin'=>array(
// 													'default' =>'mod_qualityreport_simple'
// 													, 'perms' =>'!empty($conf->global->QUALITYREPORT_USE_TASKIN)'
// 												)
// 								)
// 							)
            , 'autotabs' => 1
        );


        $this->const[$r] = array(
            0 => "EDIBLOKCURL"
            , 1 => "chaine"
            , 2 => "0"
            , 3 => "EdiBlockCurlProcess"
            , 4 => 0
            , 9 => array(
                'method' => 'SelectYesNo'
                , 'group' => 'setmainoptions'
            )
        );
        $r++;

        $this->const[$r] = array(
            0 => "EDIDEBUGLEVEL"
            , 1 => "chaine"
            , 2 => "0"
            , 3 => "EdiDebugLevel"
            , 4 => 0
            , 9 => array(
                'method' => 'InputText'
                , 'group' => 'setmainoptions'
            )
        );
        $r++;

        $this->const[$r] = array(
            0 => "MAIN_USE_COMPANY_NAME_OF_CONTACT"
            , 1 => "chaine"
            , 2 => "0"
            , 3 => "MainUseCompanyNameOfContact"
            , 4 => 0
            , 9 => array(
                'method' => 'SelectYesNo'
                , 'group' => 'setmainoptions'
            )
        );
        $r++;


        // Array to add new pages in new tabs
//         $this->tabs = array(
// //         FOR TEST 
// //             'thirdparty:+EDIClient:EDIClient:edi@edi:/edi/tab/edi_societe.php?type=client&socid=__ID__',
//         );





        $this->rights[$r][0] = $this->numero + $r + 1;     // Permission id (must not be already used)
        $this->rights[$r][1] = 'Config Tiers'; // Permission label
        $this->rights[$r][2] = 'w';
        $this->rights[$r][3] = 0;      // Permission by default for new user (0/1)
        $this->rights[$r][4] = 'tiers';    // In php code, permission will be checked by test if ($user->rights->permkey->level1->level2)
        $this->rights[$r][5] = 'config';    // In php code, permission will be checked by test if ($user->rights->permkey->level1->level2)
        $r++;


        // Main menu entries
        $r=0;
        $this->menu[$r] = array(
            'fk_menu' => 0, // Put 0 if this is a top menu
            'type' => 'top', // This is a Top menu entry
            'titre' => 'EDI',
            'mainmenu' => 'edi',
            'leftmenu' => '',
            'url' => '/edi/index.php',
            'langs' => 'edi@edi', // Lang file to use (without .lang) by module. File must be in langs/code_CODE/ directory.
            'position' => $this->numero+100+$r,
            'enabled' => '$conf->edi->enabled', // Define condition to show or hide menu entry. Use '$conf->mymodule->enabled' if entry must be visible if module is enabled.
            //'perms' => '$user->rights->edi->message->view', // Use 'perms'=>'$user->rights->mymodule->level1->level2' if you want your menu with a permission rules
            'perms' => '1',
            'target' => '',
            'user' => 0);                    // 0=Menu for internal users, 1=external users, 2=both
        $r++;
        
        $this->menu[$r] = array(
            'fk_menu' => 'fk_mainmenu=edi', // Put 0 if this is a top menu
            'type' => 'left', // This is a Top menu entry
            'titre' => 'Environement',
            'mainmenu' => 'edi',
            'leftmenu' => 'content',
            'url' => '/edi/index.php',
            'langs' => 'edi@edi', // Lang file to use (without .lang) by module. File must be in langs/code_CODE/ directory.
            'position' => $this->numero+100+$r,
            'enabled' => '$conf->edi->enabled', // Define condition to show or hide menu entry. Use '$conf->mymodule->enabled' if entry must be visible if module is enabled.
            //'perms' => '$user->rights->edi->message->view', // Use 'perms'=>'$user->rights->mymodule->level1->level2' if you want your menu with a permission rules
            'perms' => '1',
            'target' => '',
            'user' => 0);                    // 0=Menu for internal users, 1=external users, 2=both
		 $r++;
		
		$this->menu[$r] = array(
            'fk_menu' => 'fk_mainmenu=edi,fk_leftmenu=content', // Put 0 if this is a top menu
            'type' => 'left', // This is a Top menu entry
            'titre' => 'ListThirdparty',
//             'mainmenu' => 'edi',
//             'leftmenu' => 'other',
            'url' => '/edi/list_thirdparty.php',
            'langs' => 'edi@edi', // Lang file to use (without .lang) by module. File must be in langs/code_CODE/ directory.
            'position' => $this->numero+100+$r,
            'enabled' => '$conf->edi->enabled', // Define condition to show or hide menu entry. Use '$conf->mymodule->enabled' if entry must be visible if module is enabled.
            //'perms' => '$user->rights->edi->message->view', // Use 'perms'=>'$user->rights->mymodule->level1->level2' if you want your menu with a permission rules
            'perms' => '1',
            'target' => '',
            'user' => 0);                    // 0=Menu for internal users, 1=external users, 2=both
		$r++;
		
		$this->menu[$r] = array(
            'fk_menu' => 'fk_mainmenu=edi,fk_leftmenu=content', // Put 0 if this is a top menu
            'type' => 'left', // This is a Top menu entry
            'titre' => 'ListEntry',
//             'mainmenu' => 'edi',
//             'leftmenu' => 'other',
            'url' => '/edi/list_events.php',
            'langs' => 'edi@edi', // Lang file to use (without .lang) by module. File must be in langs/code_CODE/ directory.
            'position' => $this->numero+100+$r,
            'enabled' => '$conf->edi->enabled', // Define condition to show or hide menu entry. Use '$conf->mymodule->enabled' if entry must be visible if module is enabled.
            //'perms' => '$user->rights->edi->message->view', // Use 'perms'=>'$user->rights->mymodule->level1->level2' if you want your menu with a permission rules
            'perms' => '1',
            'target' => '',
            'user' => 0);                    // 0=Menu for internal users, 1=external users, 2=both
		$r++;
		

		
		
		
        $this->menu[$r] = array(
            'fk_menu' => 'fk_mainmenu=edi', // Put 0 if this is a top menu
            'type' => 'left', // This is a Top menu entry
            'titre' => 'Other',
            'mainmenu' => 'edi',
            'leftmenu' => 'other',
            'url' => '/edi/index.php',
            'langs' => 'edi@edi', // Lang file to use (without .lang) by module. File must be in langs/code_CODE/ directory.
            'position' => $this->numero+100+$r,
            'enabled' => '$conf->edi->enabled', // Define condition to show or hide menu entry. Use '$conf->mymodule->enabled' if entry must be visible if module is enabled.
            //'perms' => '$user->rights->edi->message->view', // Use 'perms'=>'$user->rights->mymodule->level1->level2' if you want your menu with a permission rules
            'perms' => '1',
            'target' => '',
            'user' => 0);                    // 0=Menu for internal users, 1=external users, 2=both
		 $r++;
        
        $this->menu[$r] = array(
            'fk_menu' => 'fk_mainmenu=edi,fk_leftmenu=other', // Put 0 if this is a top menu
            'type' => 'left', // This is a Top menu entry
            'titre' => 'ListWaiting',
//             'mainmenu' => 'edi',
//             'leftmenu' => 'other',
            'url' => '/edi/list_waiting.php',
            'langs' => 'edi@edi', // Lang file to use (without .lang) by module. File must be in langs/code_CODE/ directory.
            'position' => $this->numero+100+$r,
            'enabled' => '$conf->edi->enabled', // Define condition to show or hide menu entry. Use '$conf->mymodule->enabled' if entry must be visible if module is enabled.
            //'perms' => '$user->rights->edi->message->view', // Use 'perms'=>'$user->rights->mymodule->level1->level2' if you want your menu with a permission rules
            'perms' => '1',
            'target' => '',
            'user' => 0);                    // 0=Menu for internal users, 1=external users, 2=both
		$r++;
		
        $this->menu[$r] = array(
            'fk_menu' => 'fk_mainmenu=edi,fk_leftmenu=other', // Put 0 if this is a top menu
            'type' => 'left', // This is a Top menu entry
            'titre' => 'ManualUpload',
//             'mainmenu' => 'edi',
//             'leftmenu' => 'other',
            'url' => '/edi/upload.php',
            'langs' => 'edi@edi', // Lang file to use (without .lang) by module. File must be in langs/code_CODE/ directory.
            'position' => $this->numero+100+$r,
            'enabled' => '$conf->edi->enabled', // Define condition to show or hide menu entry. Use '$conf->mymodule->enabled' if entry must be visible if module is enabled.
            //'perms' => '$user->rights->edi->message->view', // Use 'perms'=>'$user->rights->mymodule->level1->level2' if you want your menu with a permission rules
            'perms' => '1',
            'target' => '',
            'user' => 0);                    // 0=Menu for internal users, 1=external users, 2=both
		$r++;
		
            
        $this->menu[$r] = array(
            'fk_menu' => 'fk_mainmenu=edi,fk_leftmenu=other', // Put 0 if this is a top menu
            'type' => 'left', // This is a Top menu entry
            'titre' => 'Plugins',
//             'mainmenu' => 'edi',
//             'leftmenu' => 'other',
            'url' => '/edi/plugins.php',
            'langs' => 'edi@edi', // Lang file to use (without .lang) by module. File must be in langs/code_CODE/ directory.
            'position' => $this->numero+100+$r,
            'enabled' => '$conf->edi->enabled', // Define condition to show or hide menu entry. Use '$conf->mymodule->enabled' if entry must be visible if module is enabled.
            //'perms' => '$user->rights->edi->message->view', // Use 'perms'=>'$user->rights->mymodule->level1->level2' if you want your menu with a permission rules
            'perms' => '1',
            'target' => '',
            'user' => 0);                    // 0=Menu for internal users, 1=external users, 2=both

            
            
            
        $this->cronjobs      = array(
            0 => array('label' => $langs->trans('edi'), 'jobtype' => 'method', 'class' => '/edi/class/edi.message.class.php',
                'objectname' => 'EdiMessage', 'method' => 'sendcron', 'parameters' => '', 'comment' => $langs->trans('cronEDIaperak'),
                'frequency' => 1, 'unitfrequency' => 60, 'status' => 1, 'test' => true)
            ,1 => array('label' => $langs->trans('Dailyedi'), 'jobtype' => 'method', 'class' => '/edi/class/cron/specifictriggeractionsedi.class.php',
                'objectname' => 'Specifictriggeractionsedi', 'method' => 'sendcrondaily', 'parameters' => '', 'comment' => $langs->trans('cronEDIdaily'),
                'frequency' => 1, 'unitfrequency' => 86400, 'status' => 1, 'test' => true)
            ,2 => array('label' => $langs->trans('Hourlyedi'), 'jobtype' => 'method', 'class' => '/edi/class/cron/specifictriggeractionsedi.class.php',
                'objectname' => 'Specifictriggeractionsedi', 'method' => 'sendcronhourly', 'parameters' => '', 'comment' => $langs->trans('cronEDIhourly'),
                'frequency' => 1, 'unitfrequency' => 3600, 'status' => 1, 'test' => true)
            ,3 => array('label' => $langs->trans('Minutelyedi'), 'jobtype' => 'method', 'class' => '/edi/class/cron/specifictriggeractionsedi.class.php',
                'objectname' => 'Specifictriggeractionsedi', 'method' => 'sendcronminutely', 'parameters' => '', 'comment' => $langs->trans('cronEDIminutely'),
                'frequency' => 1, 'unitfrequency' => 60, 'status' => 1, 'test' => true)
        );

        /**
          @remarks End loaded config ans auto-config construct
         */
        if (isset($conf->framework) && $conf->framework->enabled) $this->EndLoader();
    }

    /**
     * 		Function called when module is enabled.
     * 		The init function add constants, boxes, permissions and menus (defined in constructor) into Dolibarr database.
     * 		It also creates data directories
     *
     *      @param      string	$options    Options when enabling module ('', 'noboxes')
     *      @return     int             	1 if OK, 0 if KO
     */
    function init($options = '')
    {
        global $conf;

        $this->remove($options);

        $sql = array();

        $this->load_tables();

        return $this->_init($sql, $options);
    }

    /**
     * 		Function called when module is disabled.
     *      Remove from database constants, boxes and permissions from Dolibarr database.
     * 		Data directories are not deleted
     *
     *      @param      string	$options    Options when enabling module ('', 'noboxes')
     *      @return     int             	1 if OK, 0 if KO
     */
    function remove($options = '')
    {
        $sql = array();

        return $this->_remove($sql, $options);
    }
    /**
     * 	Create tables and keys required by module
     * 	Files mymodule.sql and mymodule.key.sql with create table and create keys
     * 	commands must be stored in directory /mymodule/sql/
     * 	This function is called by this->init.
     *
     * 	@return		int		<=0 if KO, >0 if OK
     */
   	function load_tables()
 	{
 		  return $this->_load_tables('/edi/sql/');
 	}
}
