<?php
/* Copyright (C) 2016		 Oscss-Shop       <support@oscss-shop.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 * or see http://www.gnu.org/
 */



namespace EDI\reception;

use \ProductFournisseur;
use \EDI\Reader;
use \LoadClass;


dol_include_once('/edi/vendor/EDI/Reader.php');
dol_include_once('/edi/plugin/D96A/d96a.common.reader.class.php');
dol_include_once('/edi/plugin/D96A/lib.functions.php');
dol_include_once('/edi/class/actioncomm.class.php');


loadClass('Societe');

use \User;
use \Trace ;

// use \CommandeFournisseur;
use \CORE\FRAMEWORK\CommandeFournisseur;
use \CORE\FRAMEWORK\Commande;
use \CORE\FRAMEWORK\Societe as Societe;

use \CORE\FRAMEWORK\ActionComm as ActionComm;


class APERAK 
		extends D96aCommonReader {

    var  $edi
				, $output
				, $length = 0
				, $uniq_id
				, $obj_ref
				, $company
				, $tax = []
				;
    


    
    /**
    */
    public function __construct($r = null) {
        parent::__construct();
        return $this->setParsedFile($r->getParsedFile());
    }

    
    /**
    */
    public function decode(  $Societe, $trace ) {
//         global $company;
       
				$this->type= $this->readEdiDataValue('BGM', 1, 0);
   

        $this->obj_ref = new \stdClass();
        $this->obj_ref->senderobj = $Societe;
        $this->obj_ref->sender = $Societe->id;
        $this->obj_ref->ref = $this->readEdiDataValue('BGM', 1, 3);
        $this->obj_ref->date = $this->DTM2time('137');
        $this->obj_ref->date_echeance = $this->DTM2time('13');
        
        $this->obj_ref->id = $trace->dol_type_id; 
        
        $this->obj_ref->products = $this->groupExtract();

    }

    
    /**
    */
    public function import($db, $user) {
				global $conf; 


				if($this->type == '105'){
					$obj_ref = newClass('CommandeFournisseur');
					$this->path = DOL_DATA_ROOT.DIRECTORY_SEPARATOR.'fournisseur/commande'.DIRECTORY_SEPARATOR.'%1$s'.DIRECTORY_SEPARATOR.'%2$s'.".edi.txt";
				}
				elseif($this->type == '330'){
					$obj_ref = newClass('FactureFournisseur');
					$this->path = DOL_DATA_ROOT.DIRECTORY_SEPARATOR.'fournisseur/facture'.DIRECTORY_SEPARATOR.'%1$s'.DIRECTORY_SEPARATOR.'%2$s'.".edi.txt";
				}
				else{
					$obj_ref = newClass('Commande');
					$this->path = DOL_DATA_ROOT.DIRECTORY_SEPARATOR.'commande'.DIRECTORY_SEPARATOR.'%1$s'.DIRECTORY_SEPARATOR.'%2$s'.".edi.txt";
				}
        

        $state =  $this->readEdiDataValue('UNH', 4, 1);

				$obj_ref->fetch( $this->obj_ref->id ); 
					


				$Societe = new Societe($db); 
				$Societe->fetch($this->obj_ref->sender); 

        $b = new \stdClass(); 
        $b->dol_type = get_class($obj_ref) ;
        $b->dol_type_id = $obj_ref->id ; 
				$b->object = $obj_ref;
        
        $ActionComm = new ActionComm($db); 
        $ActionComm->SetEvent( $user, $Societe,  $obj_ref, $this );
        
        return $b; 
    }


		/**
			@fn GetPath()
			@brief
			@return string path 
    */
    public function GetPath(){
			return $this->path; 
    }

}
