<?php
/* Copyright (C) 2016		 Oscss-Shop       <support@oscss-shop.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 * or see http://www.gnu.org/
 */
namespace CORE\FRAMEWORK;
namespace EDI;

// on va utiliser le datetime plus bas donc on le déclare, pareil pour l'object Facture
use \DateTime;

use \CORE\FRAMEWORK\Societe as Societe;


	
class APERAK 

	extends D96aCommon {
    

    var $edi, 
				$output, 
				$length = 0, 
// 				$uniq_id, 
				$obj_ref, 
				$mysoc, 
				$tax = [], 
				$setup
				; 

				/**
					@var $path string path in document
				*/
		public  $path = '',
						$ref;

    public function __construct( $obj_ref, \Societe $mysoc, $setup) {
        $this->obj_ref = $obj_ref;
        $this->mysoc = $mysoc;
         $this->setup = $setup;

         
				$cl = explode('\\', get_class($this->obj_ref->object_ref) );
        $typedoc = strtolower($cl[count($cl)-1]) ; 
        
				$this->typedoc = strtolower($typedoc);
				/**
					Adjust comportement for origin orders
				*/
				if($typedoc =='commandefournisseur' )
					$this->initOrderSupplier($obj_ref); 
				elseif($typedoc =='commande' )
					$this->initOrder($obj_ref); 
				elseif($typedoc =='facture' )
					$this->initInvoice($obj_ref); 
				elseif($typedoc =='facturefournisseur' )
					$this->initInvoiceSupplier($obj_ref); 
					
    }

    /**
			@brief surclass function to had UNA delimiter
		*/
    public function Generate($allref) {

				/**
					identification message 
				*/
				$this->ref_unid = $allref->ref_uniq; 
				$this->count_message = $allref->count_message ; 
				$this->ref_parent = $allref->ref_parent ; 

				
				$this->prepare();
				

				parent::__construct();
				
        // build arrays
        $this->header();
        $this->message();
//         $this->trailer();
        
        
    }
    
    
    /**
			@fn InitOrder
    */
    protected function InitInvoiceSupplier(/*Commande*/ $obj_ref){

			$this->obj_ref = $obj_ref;
			$this->ref = $this->obj_ref->ref;
			$this->id = $this->obj_ref->dol_type_id;
			$this->path = DOL_DATA_ROOT.DIRECTORY_SEPARATOR.'fournisseur/facture'.DIRECTORY_SEPARATOR.'%1$s'.DIRECTORY_SEPARATOR.'aperak.'.'%2$s'.".edi.txt";
			
			// traiement d'un commande client, donc fournisseur pour le tier recepteur de cette commande
			$this->bgmtype= "330"; 
    }
    
    /**
			@fn InitOrder
    */
    protected function InitInvoice(/*Commande*/ $obj_ref){

			$this->obj_ref = $obj_ref;
			$this->ref = $this->obj_ref->ref;
			$this->id = $this->obj_ref->dol_type_id;
			$this->path = DOL_DATA_ROOT.DIRECTORY_SEPARATOR.'facture'.DIRECTORY_SEPARATOR.'%1$s'.DIRECTORY_SEPARATOR.'aperak.'.'%2$s'.".edi.txt";
			
			// traiement d'un commande client, donc fournisseur pour le tier recepteur de cette commande
			$this->bgmtype= "330"; 
    }
    
    /**
			@fn InitOrder
    */
    protected function InitOrder(/*Commande*/ $obj_ref){
			$this->obj_ref = $obj_ref;
			$this->ref = $this->obj_ref->ref;
			$this->id = $this->obj_ref->dol_type_id;
			$this->path = DOL_DATA_ROOT.DIRECTORY_SEPARATOR.'commande'.DIRECTORY_SEPARATOR.'%1$s'.DIRECTORY_SEPARATOR.'aperak.'.'%2$s'.".edi.txt";
			
			// traiement d'un commande client, donc fournisseur pour le tier recepteur de cette commande
			$this->bgmtype= "105"; 
    }
    
    /**
			@fn initOrderSupplier
    */
    protected function initOrderSupplier(/*CommandeFournisseur*/ $obj_ref){
			$this->obj_ref = $obj_ref;
			$this->ref = $this->obj_ref->ref;
			$this->id = $this->obj_ref->dol_type_id;
			$this->path = DOL_DATA_ROOT.DIRECTORY_SEPARATOR.'fournisseur/commande'.DIRECTORY_SEPARATOR.'%1$s'.DIRECTORY_SEPARATOR.'aperak.'.'%2$s'.".edi.txt";
			
			$this->bgmtype= "220"; 
    }
    
    
		/**
			@brief surclass function to had UNA delimiter
		*/
    public function encodeUNA($wrap = true) {
        $this->arr = $this->combine_array(); // output is in $this->arr
        $this->enableUNA();
        
        
 
        $this->encode($this->arr, $wrap);
        
//                 print_r($this->arr); 
//         exit;
        
        $this->output = $this->get();

        return $this->output;
    }
    
    
		/**
			@fn GetPath()
			@brief
			@return string path 
    */
    public function GetPath(){
			return $this->path; 
    }

    /**
			@fn prepare()
			@brief prepare and calculate data 
			@return none 
		*/
    private function prepare(){
    
			// confition regelement
			if($this->obj_ref->cond_reglement_id=='1'){ // a reception
				$this->paycond = 1; // Paiement direct
			}
			elseif($this->obj_ref->cond_reglement_id=='6'){ // proformat
				$this->paycond = 'P'; // Paiement direct
			}
			elseif($this->obj_ref->cond_reglement_id=='7'){ // proformat
				$this->paycond = "J12"; // Paiement direct
			}
			elseif($this->obj_ref->cond_reglement_id=='2'){ // proformat
				$this->paycond = "J30"; // Paiement direct
			}
			elseif($this->obj_ref->cond_reglement_id=='3'){ // proformat
				$this->paycond = "E30"; // Paiement direct
			}
			elseif($this->obj_ref->cond_reglement_id=='4'){ // proformat
				$this->paycond = "J60"; // Paiement direct
			}
			elseif($this->obj_ref->cond_reglement_id=='5'){ // proformat
				$this->paycond = "E60"; // Paiement direct
			}

			
			// mode payement
			if($this->obj_ref->mode_reglement_id=='7'){ // cheque
				$this->payid = 23 ;
				$this->paychan = 1; // Ordinary post
			}
			elseif($this->obj_ref->mode_reglement_id=='4'){ // cash 
				$this->payid = 10 ;
				$this->paychan = 9; // Personal (face-to-face)
			}
			elseif($this->obj_ref->mode_reglement_id=='3'){ // prelevement
				$this->payid = 31 ;
				$this->paychan = 5; // S.W.I.F.T.
			}
			elseif($this->obj_ref->mode_reglement_id=='2'){ // virment
				$this->payid = 30 ;
				$this->paychan = 5; // S.W.I.F.T.
			}
			elseif($this->obj_ref->mode_reglement_id=='2'){ // paiement interbancaire
				$this->payid = 42 ;
				$this->paychan = 5; // S.W.I.F.T.
			}	
    
    }
    
    
    


    /**
    */
    function header() {
			global $conf; 
			

			
			
			
        $this->header = array
            (
            
            // 
            $this->GetUNB(),
            
            // MESSAGE HEADER
						// Mandatory Max repeat: 1 
						// A service segment starting and uniquely identifying a message.
            $this->GetUNH( 'APERAK' ),
            
            //BGM M 1
						// BEGINNING OF MESSAGE
						// Mandatory Max repeat: 1 
						// A segment by which the sender must uniquely identify the obj_ref by 
             $this->GetBGM(),
            
            array(
                "DTM",
                make_DTM_time($this->obj_ref->date_creation) // created date
            ),
            array(
                "DTM",
                make_DTM_time(time(), "11") // date transmission (now)
            ),
            
            array(
                "FTX",
                "REG",
                "",
                "",
                array(
                    $this->mysoc->nom, // nom de la boite
                    ($this->mysoc->forme_juridique_code == 54) ? "SARL" : "Societe", // forme juridique
                    $this->mysoc->capital . " EUR"//capital
                )
        ));
        
        
        $this->header = array_merge($this->header, array(
            array(
                "CNT"
                , array(
										//6069 Control qualifier
										//MandatoryType: anLength: 0..3
										//Determines the source data elements in the message which forms the basis for 6066 Control value.
                    ''
										// 6066 Control value
										// MandatoryType: nLength: 0..18
										// Value obtained from summing the values specified by the Control Qualifier throughout the message (Hash total).
										, ''
										// 6411 Measure unit qualifier
										// ConditionalType: anLength: 0..3
										// Indication of the unit of measurement in which weight (mass), capacity, length, area, volume or other quantity is expressed.
										, ''
                )
            )
					) );
            
            
            
				// A group of segments to specify the identifications of message sender and message receiver with their contacts and communication channels.
        $this->header = array_merge($this->header, array(
							array(
								// NAD M 1
								// NAME AND ADDRESS
								// MandatoryMax repeat: 1 A segment to specify the identification of the message issuer and message receiver.
                "NAD"
                //3035 PARTY QUALIFIER
								//MandatoryType: anLength: 0..3
								//Code giving specific meaning to a party.
									// Vendor VN; 
                , "VN" 
                // C082 PARTY IDENTIFICATION DETAILS
								// Conditional
								// Identification of a transaction party by code.
                , array(
									// 3039 Party id. identification
									// MandatoryType: anLength: 0..35
									// Code identifying a party involved in a transaction.
									$this->setup->user->edi_num
									// 1131 Code list qualifier
									// ConditionalType: anLength: 0..3
									// Identification of a code list.
									, ""
									// 3055 Code list responsible agency, coded
									// ConditionalType: anLength: 0..3
									// Code identifying the agency responsible for a code list.
									, "9"
                )
                ,""
                ,$this->obj_ref->mysoc->nom
                ,$this->obj_ref->mysoc->adress
                ,$this->obj_ref->mysoc->town
                ,$this->obj_ref->mysoc->state_code
                ,$this->obj_ref->mysoc->zip
                ,$this->obj_ref->mysoc->country_code
            )
						, array(
								// NAD M 1
								// NAME AND ADDRESS
								// MandatoryMax repeat: 1 A segment to specify the identification of the message issuer and message receiver.
                "NAD"
                //3035 PARTY QUALIFIER
								//MandatoryType: anLength: 0..3
								//Code giving specific meaning to a party.
									// Vendor VN; 
                , "OB" 
                // C082 PARTY IDENTIFICATION DETAILS
								// Conditional
								// Identification of a transaction party by code.
                , array(
									// 3039 Party id. identification
									// MandatoryType: anLength: 0..35
									// Code identifying a party involved in a transaction.
									$this->setup->user->edi_num
									// 1131 Code list qualifier
									// ConditionalType: anLength: 0..3
									// Identification of a code list.
									, ""
									// 3055 Code list responsible agency, coded
									// ConditionalType: anLength: 0..3
									// Code identifying the agency responsible for a code list.
									, "9"
                )
                ,""
                ,$this->obj_ref->mysoc->nom
                ,$this->obj_ref->mysoc->adress
                ,$this->obj_ref->mysoc->town
                ,$this->obj_ref->mysoc->state_code
                ,$this->obj_ref->mysoc->zip
                ,$this->obj_ref->mysoc->country_code
            )
        ));
        

    }

    function message() {
//         for ($i = 0; $i < count($this->invoice->lines); $i++) {
//             $line = $this->invoice->lines[$i];
//             if (isset($this->tax[$line->tva_tx])) { // we had totals by tva rate
//                 $this->tax[$line->tva_tx] += $line->total_tva;
//             } else {
//                 $this->tax[$line->tva_tx] = $line->total_tva;
//             }
//             $this->message[$i] = array(
//                 array(
//                     "LIN", // product row
//                     "$i", // line number !!!
//                     "", // action 1-> add a line
//                     array(
//                         $line->barcode_type_code, // code barre produit
//                         "EN", // International Article Numbering Association
//                         "", // code product 128 -> service
//                         "9" // organism responsible of SN : 9 -> EAN (International Article Numbering association)
//                     )
//                 ),
//                 array(
//                     "IMD",
//                     "E", //Free-form short description
//                     "ANM", // pas standard D96A ...
//                     array(
//                         "",
//                         "",
//                         "",
//                         $line->desc// description courte du produit
//                     )
//                 ),
//                 array(
//                     "QTY",
//                     array(
//                         "47", // Invoiced quantity 
//                         $line->qty, // quantity
//                         "PCE" // units
//                     )
//                 ),
//                 array(
//                     "MOA", //monetary amount
//                     array(
//                         "203", // Line item amount
//                         format_number($line->multicurrency_total_ht) // total price for this product (D3E include)
//                     )
//                 ),
//                 array(
//                     "PRI", //brut price
//                     array(
//                         "AAB", // price without discount
//                         format_number($line->subprice), // price in catalog 12
//                         "", // Price type : PE -> per each
//                         "", // Price type qualifier recommand (AAA -> Reference price)
//                         "1", // unity quantity 1 (ex sold by 100ml here goes 100)
//                         "PCE" // units
//                     )
//                 ),
//                 array(
//                     "PRI", //net price
//                     array(
//                         "AAA", // price WITH discount AND D3E tax
//                         format_number($line->subprice), // price 10 + 25 D3E
//                         "", // Price type : PE -> per each
//                         "", // Price type qualifier recommand (AAA -> Reference price)
//                         "1", // unity quantity 1 (ex sold by 100ml here goes 100)
//                         "PCE" // units
//                     )
//                 ),
//                 array(
//                     "TAX",
//                     "7", //indicate it s a tax, not a fee
//                     "VAT", // it s a TVA
//                     "", // not use for  VAT
//                     "", // not use for VAT
//                     array(
//                         "", // not use for VAT
//                         "", // not use for VAT
//                         "", // not use for VAT
//                         format_number($line->tva_tx) // taux de TVA
//                     )
//             ));
//             if ($line->remise_percent != 0) {
//                 $this->message[$i] = array_merge($this->message[$i], array(
//                     array(
//                         "ALC", //ALLOWANCE OR CHARGE
//                         "A", //Allowance / remise
//                         "",
//                         "2", // remise sur facture
//                         "1", // computed on product raw
//                         array(
//                             "TD", //type de remise : Trade discount / remise négociée
//                             "",
//                             "",
//                             "REMISE" // description
//                         )
//                     ),
//                     array(
//                         "MOA", // discount details 
//                         array(
//                             "204", // inform we will provide a discount/allowance
//                             format_number($line->remise_percent) // discount per unit
//                         )
//                 )));
//             };
//             if (false) { //DEE tax or other
//                 $this->message[$i] = array_merge($this->message[$i], array(
//                     array(// DEEE tax
//                         "ALC", //ALLOWANCE OR CHARGE
//                         "C", // charge
//                         "3001000002459", // code of D3E (tax mobilier is 3001000002671, tax ammeublement 3001000002046)
//                         "2", // apply on invoice
//                         "1", // computed on product raw
//                         array(
//                             "TX", // it s a tax
//                             "",
//                             "",
//                             "TAXE DEEE" // description
//                         )
//                     ),
//                     array(
//                         "MOA", // taxe DEEE details 
//                         array(
//                             "23", // inform we will provide a Charge amount
//                             "0.25" // D3E tax per unit
//                         )
//                     ),
//                     array(
//                         "TAX",
//                         "7", //indicate it s a tax, not a fee
//                         "VAT", // it s a TVA
//                         "", // not use for  VAT
//                         "", // not use for VAT
//                         array(
//                             "", // not use for VAT
//                             "", // not use for VAT
//                             "", // not use for VAT
//                             "20.0" // taux de TVA !!!!!!! la tva pour la tax mobilier est à 5.5%
//                         )
//                     )
//                 ));
//             }
//         }
    }

//     function trailer() {
//         $this->trailer = array(
//             array(
//                 "UNS", // fin de section
//                 "S" // Detail/summary section separation
//             ),
//             ///////////////////////////////////// totals //////////////////////////////////////
//             array(
//                 "MOA", //total HT
//                 array(
//                     "125", // Taxable amount
//                     format_number($this->invoice->total_ht) // amount excluding taxes
//                 )
//             ),
//             array(
//                 "MOA", //total VAT
//                 array(
//                     "124", // Taxe amount
//                     format_number($this->invoice->total_tva) // amount taxes
//                 )
//             ),
//             array(
//                 "MOA", //total TTC
//                 array(
//                     "128", // Total amount
//                     format_number($this->invoice->total_ttc) // total amount including taxes
//                 )
//         ));
//         foreach ($this->tax as $rate => $total) {
//             $this->trailer = array_merge($this->trailer, array(
//                 array(// detail per tva rate : 20%
//                     "TAX",
//                     "7", //indicate it s a tax, not a fee
//                     "VAT", // it s a TVA
//                     "", // not use for  VAT
//                     "", // not use for VAT
//                     array(
//                         "", // not use for VAT
//                         "", // not use for VAT
//                         "", // not use for VAT
//                         format_number($rate) // taux de TVA !!!!!!! la tva pour la tax mobilier est à 5.5%
//                     )
//                 ),
//                 array(
//                     "MOA", // total tva 20%
//                     array(
//                         "124", // inform we will provide a tax
//                         format_number($total) // TVA 20% total tax
//                     )
//             )));
//         }
//         if (false) { // reserved for dEEE tax or other
//             $this->trailer = array_merge($this->trailer, array(
//                 array(// TOTAL DEEE tax
//                     "ALC", //ALLOWANCE OR CHARGE
//                     "C", // charge
//                     "3001000002459", // code of D3E (tax mobilier is 3001000002671, tax ammeublement 3001000002046)
//                     "2", // apply on invoice
//                     "1", // computed on product raw
//                     array(
//                         "TX", // it s a tax
//                         "",
//                         "",
//                         "TAXE DEEE" // description
//                     )
//                 ),
//                 array(
//                     "MOA", // taxe DEEE details 
//                     array(
//                         "23", // inform we will provide a Charge amount
//                         "2.50" // D3E tax per unit
//                     )
//                 )
//             ));
//         }
//     }
// 

}

