<?php
/* Copyright (C) 2016		 Oscss-Shop       <support@oscss-shop.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 * or see http://www.gnu.org/
 */

loadClass("Societe");
loadClass("CommandeFournisseur");
loadClass("Commande");
				
dol_include_once('/edi/class/send.class.php');
dol_include_once('/edi/class/actioncomm.class.php');
dol_include_once('/edi/vendor/EDI/Encoder.php');


dol_include_once('/edi/plugin/D96A/lib.functions.php');
dol_include_once('/edi/plugin/D96A/d96a.common.class.php');


dol_include_once('/edi/plugin/D96A/confirmation/APERAK.output.php');




class EdiTriggerAPERAK
	extends edi_send 
	{
    var $action
				, $object
				, $user
				, $langs
				, $conf
				, $entity
				, $db
				, $mysoc
				, $setup;
				
    var $output_file; // used in transmission also

    

    
    /**
			@fn __construct()
    */
    public function __construct(
													$action
													, $object
													, $user
													, $langs
													, $conf
													, $entity
													, $db
													, $mysoc
													, $setup
													){

        $this->action = $action;
        $this->object = $object;
        $this->user   = $user;
        $this->langs  = $langs;
        $this->conf   = $conf;
        $this->entity = $entity;
        $this->db     = $db;
        $this->mysoc  = $mysoc;
        $this->setup  = $setup;


        parent::__construct($db); // used to share db access
    }

    
		/**
			@fn run_trigger()
			@brief execute trigger for this order 
		*/
    public function run_trigger()
    {	
				global $conf, $langs; 

			if(! empty( $conf->global->EDIDEBUGLEVEL ) && $conf->global->EDIDEBUGLEVEL >= 5 )
				trigger_error("trigger EDI\APERAK launch" , E_USER_NOTICE);
// 				


        $c= new EDI\APERAK($this->object, $this->mysoc ,$this->setup);
				
// 				$cl = explode('\\', get_class($c->object) );
//         $typedoc = strtolower($cl[count($cl)-1]) ; 
        
        /**
					Extract ref_uniq
        */
        if(! empty( $conf->global->EDIDEBUGLEVEL ) && $conf->global->EDIDEBUGLEVEL >= 5 )
					trigger_error(' [WARNING]   '.' -- perv RefUniq ', E_USER_NOTICE ); 


        $res =$this->RefUniq($this->object->thirdparty->id, $c->typedoc , $c->obj_ref->id  ); 
        
        
        $res->dol_type = $c->typedoc; 
        $res->dol_type_id = $this->object->dol_type_id;  //$c->id; 
        $res->ref_parent = $this->object->ref_parent; 
//         $res->count_message = $c->count_message ; 
        
        if(! empty( $conf->global->EDIDEBUGLEVEL ) && $conf->global->EDIDEBUGLEVEL >= 5 )
					trigger_error(' [WARNING]   '.' -- perv '.print_r($res, true), E_USER_NOTICE ); 
        /**
					Extract generate array and construct output
        */
        $c->Generate($res); 
        
        
//         trigger_error(' [WARNING]   '.' -- Calulat path file  '.print_r(array( $c->GetPath() , $c->ref, $c->count_message), true), E_USER_NOTICE );
				/**
					Calulat path and file
				*/
				$this->output_file = output_file(  $c->GetPath() , $c->ref , $c->count_message) ; 


				if(empty($this->output_file) && ! empty( $conf->global->EDIDEBUGLEVEL ) && $conf->global->EDIDEBUGLEVEL >= 1 )
					trigger_error(' [FATAL]  file:: '.$this->output_file, E_USER_NOTICE ); 
 
				if ( !file_exists( dirname($this->output_file ) ) ) 
					dol_mkdir( dirname($this->output_file ) );
				/**
					Write file 
				*/
        $handle = @fopen( $this->output_file, "w+");
        if ($handle !== false) {
            fwrite($handle, $c->encodeUNA());
            fclose($handle);
        }


				return $res; 
    }
}