<?php
/* Copyright (C) 2015 Oscss-Shop Team <support@oscss-shop.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
 
namespace CORE\FRAMEWORK;


loadClass('ProductFournisseur');
loadClass('Product');

// namespace EDI\common;
namespace EDI\reception;

use \LoadClass;


use \CORE\FRAMEWORK\ProductFournisseur;
use \CORE\FRAMEWORK\Product;


dol_include_once('/edi/vendor/EDI/Reader.php');
dol_include_once('/edi/core/lib/tools.lib.php');



class D96aCommonReader
	extends \EDI\Reader {

	
	public	$header, 
					$message = [], 
					$trailer, 
					$arr; 
	
    /**
			Specifie type order 
				105 :: Commande fournisseur
				
				220 :: Commande client 
    */
	public $type; 
	
	public $heck_digit; 
	/**
	*/
	public $db; 
	
	
    /**
    */
    public function SetDB($db){
			$this->db = $db;
			return $this->db;
    }
    
    
    /**
    */
    public function readLIN() {
        $pointer = 0; //first product = 0
        while ($r->readEdiDataValue(['LIN', ['1' => "$pointer"]], 1) != "") {
            echo "passage $pointer " . $this->readEdiDataValue(['LIN', ['1' => "1"]], 3, 0);
            $pointer++;
            echo"\n";
        }
        print_r($r->errors());
    }

    /**
    */
    protected function DTM2time($PeriodQualifier) {
        $timeUK = $this->readEdiSegmentDTM($PeriodQualifier);
        return strtotime($timeUK);
    }

    /**
    */
    protected function groupExtract($start = 'LIN', $end = array('UNS'),$mode='dol') {
        $groups = array();
        $group = array();
        $position = 'before_search';
        foreach ($this->getParsedFile() as $edi_row) {
            $segment = $edi_row[0];
            if ($position == 'group_is' && ( $segment == $start || in_array($segment, $end) )) {
                $groups[] = $group;
                $group = array();
                $position = 'group_finish';
            }
            if ($segment == $start) {
                $position = 'group_is';
            }
            if ($position == 'group_is') {
                $group[] = $edi_row;
            }
            //echo $edi_row[0] . ' ' . $position . PHP_EOL;
        }
        if ($mode == 'dol') // convert to Dolibarr format
            return $this->edi2DolProducts($groups);
        else return $groups;
    }

    /**
    */
    protected function edi2DolProducts($groups) {
    global $db; 
    
    
		$cl = explode('\\', get_class($this) );//->coreclass->obj_ref) );
        $typedoc = strtolower($cl[count($cl)-1]) ; 
        
        
//       print_r($groups); 
        $groupsDol = array();
        foreach ($groups as $produit) {
            // use a reader to parse those array
            $r = new \EDI\Reader();
            $r->setParsedFile($produit);
//             print_r($r); 
            
            $ligne = $r->readEdiDataValue('LIN', 1);
            $desc = $r->readEdiDataValue('IMD', 3, 3);
            $pu = $r->readEdiDataValue(['PRI', ["1.0" => "AAB"]], 1, 1);
            if(empty($pu) || $pu<= 0) 
				 $pu = $r->readEdiDataValue(['PRI', ["1.0" => "AAA"]], 1, 1);
            
            $qty = array();
            
            if(in_array($typedoc, array('invoic')))
				$qty[47] = $r->readEdiDataValue(['QTY', ["1.0" => "47"]], 1, 1);
			elseif(in_array($typedoc, array('orders', 'ordrsp', 'ordchg'))){
				// livrable
				$qty[21] =  $r->readEdiDataValue(['QTY', ["1.0" => "21"]], 1, 1);
			}
			elseif(in_array($typedoc, array( 'ordrsp', 'ordchg'))){
				// livrable
				$qty[12] = $r->readEdiDataValue(['QTY', ["1.0" => "12"]], 1, 1);
				// delais livraison rupture momentanée
				$qty[83] = $r->readEdiDataValue(['QTY', ["1.0" => "83"]], 1, 1);
				// rupture momentanée sans date reapro
				$qty[185] = $r->readEdiDataValue(['QTY', ["1.0" => "185"]], 1, 1);
				// rupture definitive
				$qty[182] = $r->readEdiDataValue(['QTY', ["1.0" => "182"]], 1, 1);
				// envoyé gratuitement
				$qty[192] = $r->readEdiDataValue(['QTY', ["1.0" => "182"]], 1, 1);
			}
            
            
            $txtva = $r->readEdiDataValue(['TAX', ["2" => "VAT"]], 5, 3);
            
//             var_dump($this->type, $typedoc); 
//             var_dump($qty); 
//             exit; 


			foreach($qty as $code=>$qt) {
				//
				// context Comamnde Forunisseur 
				//
				if(in_array($this->type , array('105', '231')) ) {
					$groupsDol[$ligne] = array($desc, $pu, $qt, $txtva, 0, 0);
					
					$pfourn = new ProductFournisseur($this->db); 

					
					$fourn_ref = $r->readEdiDataValue('GIR',2,0); 
// 							;
					$pfourn->SearchRefProdForFourn($this->obj_ref->senderobj->id, $fourn_ref, $qty ); 
					
					$groupsDol[$ligne] = array_merge ($groupsDol[$ligne],  array(
						// section id product 
						$pfourn->fk_product
						// $fk_prod_fourn_price
						, $pfourn->product_fourn_price_id
						// ref_fourn
						, "$fourn_ref"
						// $remise_percent
						, $pfourn->fourn_remise_percent
						// 
						, 'HT'
						// 
						, 0
						// $info_bits
						, 0
						) );
				

				}
				//
				//  Facture Fournisseur
				//
				elseif(in_array($this->type , array( '326','330', '380', '384', '386')) ) {
					
					$prod= newClass('Product');
					$barcodearray = $r->readEdiDataValue('LIN', 3);
					if(!empty($barcodearray[0])){
						// FIX delete key barcode
						// compatibility dolibarr 
						/// TODO Check barcode Type and if activated 
						$prod->fetch(0, '','', substr($barcodearray[0], 0,-1) ); 
					}
					else {
						$pfourn = new ProductFournisseur($this->db); 
						$fourn_ref = $r->readEdiDataValue('PIA',2); 

						$pfourn->SearchRefProdForFourn($this->obj_ref->senderobj->id, $fourn_ref, $qt );
						
						$prod->id = (int)$pfourn->fk_product; 
// 						$prod->fourn_remise_percent = $pfourn->fourn_remise_percent; 
						
					}

	 
					// discount 
					$remise_percent = 0;
					if ($r->readEdiDataValue(['ALC', ["1" => "A"]], 3) == "2") { // there is a discount on this product
						$remise_percent = $r->readEdiDataValue(['MOA', ["1.0" => "204"]], 1, 1);
					}
					
					
					$groupsDol[$ligne] = array($desc, $pu,$txtva ,0,0, $qt);

					$groupsDol[$ligne] = array_merge ($groupsDol[$ligne],  array(
						// section id product 
						 (($prod->id>0)?$prod->id: 0 )
						// $remise_percent
						, $remise_percent
						// $date_start
						, ''
						// $date_end
						, ''
						// $ventil
						, 0
						// $info_bits
						, 0
						// 
						, 'HT'
						// $type
						, 0
						// $rang
						, -1
						// $notrigger
						, false
						// $array_options
						, 0
						// $fk_unit
						, null
						// $origin_id
						, 0
						// $pu_ht_devise
						, 0
						// ref fourn 
						, (!empty($fourn_ref)? $fourn_ref : '' )
						) );


				}
				//
				// context Comamnde Client
				//
				else{
					

					

					$prod= newClass('Product');
					
					
					$barcodearray = $r->readEdiDataValue('LIN', 3);
					if(!empty($barcodearray[0])){
						// FIX delete key barcode
						// compatibility dolibarr 
						/// TODO Check barcode Type and if activated 
						$prod->fetch(0, '','', substr($barcodearray[0], 0,-1) ); 
					}
					else {
						$prod_ref = $r->readEdiDataValue('GIR',2); 
						$prod->fetch(0, $prod_ref ); 
					}


					$fournprice = 0;
					$res = GetExternal( dol_buildpath('/edi/ajax/getSupplierPrices.php',2).'?bestpricefirst=1&idprod='.$prod->id );
					if($res){
						$ressuppprice=json_decode($res);

						if(is_array($ressuppprice))
						foreach($ressuppprice as $row){
							if(!empty($row->price) ){
								$fournprice = $row->price;
								break;
							}
						}
					}
					// discount 
					$remise_percent = 0;
					if ($r->readEdiDataValue(['ALC', ["1" => "A"]], 3) == "2") { // there is a discount on this product
						$remise_percent = $r->readEdiDataValue(['MOA', ["1.0" => "204"]], 1, 1);
					}
					
					/// FIX desc empty, report other data 
					if(empty($desc) ){
						if(!empty($barcodearray[0]))
							$desc.= 'Barcode : '.$barcodearray[0];
					}
					
					$groupsDol[$ligne] = array($desc, $pu, $qt);
					
					$groupsDol[$ligne] = array_merge ($groupsDol[$ligne],  array(
						(!empty($txtva)? $txtva : $prod->tva_tx)
						, 0
						, 0
						// section id product 
						, (($prod->id>0)?$prod->id: 0 )
						// remise_percent
						, $remise_percent
						// $info_bits
						, 0
						//fk_remise_except
						, 0
						// $price_base_type
						, 'HT'
						// pu_ttc
						, 0
						// date_start
						, ''
						// date_end
						, ''
						// product_type
						, (($prod->id>0)?$prod->type: 0 )
						// rang
						, -1
						// special_code
						, 0
						// fk_parent_line
						, 0
						// fk_fournprice
						, null
						// pa_ht
						,$fournprice
						// label
						, ''
						//array_options
						, 0
						// fk_unit
						, null
						// origin
						, ''
						// origin_id
						, 0
						// pu_ht_devise
						, 0
					) );

					
				}
            
            }

        }
// print_r($groupsDol); 
// exit; 

        return $groupsDol;
    }
}

