<?php
/* Copyright (C) 2016		 Oscss-Shop       <support@oscss-shop.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 * or see http://www.gnu.org/
 */
 
namespace EDI\reception;


use \FactureFournisseur;
use \Facture;
use \LoadClass;


dol_include_once('/edi/vendor/EDI/Reader.php');
dol_include_once('/edi/plugin/D96A/lib.functions.php');
dol_include_once('/edi/plugin/D96A/d96a.common.reader.class.php');

dol_include_once('/framework/core/lib/framework.lib.php');
dol_include_once('/compta/facture/class/facture.class.php'); // used for constant

dol_include_once('/contact/class/contact.class.php');
loadClass('ExtraFields'); 


class INVOIC 
	extends D96aCommonReader {


    
        var  $edi
				, $output
				, $length = 0
				, $uniq_id
				, $obj_ref
				, $company
				, $tax = []
				;

	/**
		Correspondance contact dolibarr / Code address Edi 
	*/
	public $listaddress = array(
		  60=> 'IV'
// 		, 101=> 'BY'
		, 50 => 'SU' //Not use , is me
		, 61=> 'DP'
	);
    
    
	/**
		Correspondance cond regl 
	*/
	public $cond_reglement = array(
		  1 => 1
	);
	
	/**
		Correspondance moyen de regl
	*/
	public $mode_reglement= array(
		  10 => 4
		, 20 => 2
		, 23 => 7
		, 30 => 2
		, 31 => 3
		, 42 => 2
	);
	
	
    
	/**
		@fn __construct()
		@brief 
    */
    public function __construct( $r = null) {
    
				$this->db = $db; 
    
        parent::__construct();
        return $this->setParsedFile($r->getParsedFile());
    }
    

	/**
		@fn decode( $Societe, $trace )
		@brief decode 
    */
    public function decode( $Societe, $trace ) {

		$this->type= $this->readEdiDataValue('BGM', 1);
   

        $this->obj_ref = new \stdClass();
		$this->obj_ref->senderobj = $Societe;
        $this->obj_ref->sender = $Societe->id;
        
        if($this->readEdiDataValue('BGM', 1,3) !=null)
			$this->obj_ref->ref = $this->readEdiDataValue('BGM', 1, 3);
		elseif($this->readEdiDataValue('BGM', 2) !=null)
			$this->obj_ref->ref = $this->readEdiDataValue('BGM', 2);
			
        $this->obj_ref->date = $this->DTM2time('137');
        $this->obj_ref->date_echeance = $this->DTM2time('13');
        
        $this->obj_ref->id = $trace->dol_type_id; 
        
        $this->obj_ref->products = $this->groupExtract();

    }

    /**
		@fn import()
		@param $db object 
		@param $user object 
		@return $trace object 
    */
    function import($db, $user) {
		global $conf, $langs; 
		
		$this->db = $db; 
		
		$state =  $this->readEdiDataValue('UNH', 4, 1);
				
				
        $invoice = newClass('FactureFournisseur');
        $invoice->ref = "";
        $invoice->ref_supplier = $this->obj_ref->ref;
        
        /// TODO 
        
        $type = $this->readEdiDataValue('BGM', 3);
        if($type == 9) 
			$invoice->type = Facture::TYPE_STANDARD;
        
        
        $invoice->description = "";
        $invoice->socid = $this->obj_ref->sender;
        $invoice->fk_soc = $this->obj_ref->sender;
        $invoice->date = $this->obj_ref->date;
        $invoice->date_echeance = $this->obj_ref->date_echeance;
        $invoice->entity = $conf->entity;
        

        
        // Fix Devise 
		if($this->readEdiDataValue('CUX', 1, 1) != null )
			$invoice->multicurrency_code = $this->readEdiDataValue('CUX', 1, 1);
			
			
			
		/**
			Payment
		*/
        $paysegment= $this->readEdiDataValue('PAI',1);
		/**
			4439 : Payment conditions, coded
			ConditionalType: anLength: 0..3
		*/
		if(isset($paysegment[0]) && $paysegment[0] > 0 )
			$invoice->cond_reglement_id = $this->cond_reglement[$paysegment[0]]; 
			

				
		/**
			4461 Payment means, coded
			ConditionalType: anLength: 0..3
		*/
		if(isset($paysegment[2]) && $paysegment[2] > 0 )
			$invoice->mode_reglement_id = $this->mode_reglement[$paysegment[2]]; 
        
        
        
		// Manage Address 
		// Add in contact fi exist 
		// Or add in note for delivery 
		$EF = new \CORE\FRAMEWORK\ExtraFields($this->db);
		foreach($this->listaddress  as $ktype=>$type ){
			$addGLN = $this->readEdiDataValue(array('NAD', array('1'=>$type) ), 2,0 );
			
			// add passed by GLN num 
			if(!empty($addGLN) && strlen($addGLN) == 13){
				$Contact=new \Contact($this->db);
				$EF->SetObject($Contact); //='socpeople';
				$EF->SetColum('edirum'); 
				
				$idContact = $EF->fetch($addGLN); 
				
				if(!$idContact && ! empty( $conf->global->EDIDEBUGLEVEL ) && $conf->global->EDIDEBUGLEVEL >= 5 )
					trigger_error("Extract NAD DP (\$txt):".print_r($txt, true) , E_USER_NOTICE);
					
				$result = $invoice->add_contact($idContact, $ktype , "external");
			}
			// add passed by detail 
			elseif($type == 'DP'){
				$s =  new \StdClass; 
				$s->socname= $this->readEdiDataValue(array('NAD', array('1'=>$type) ),4); 
				$s->address= $this->readEdiDataValue(array('NAD', array('1'=>$type) ),5); 
				$s->town= $this->readEdiDataValue(array('NAD', array('1'=>$type) ),6); 
				$s->state_code= $this->readEdiDataValue(array('NAD', array('1'=>$type) ),7); 
				$s->zip= $this->readEdiDataValue(array('NAD', array('1'=>$type) ),8); 
				$s->country_code= $this->readEdiDataValue(array('NAD', array('1'=>$type) ),9); 
				$s->phone = $this->readEdiDataValue(array('NAD', array('1'=>$type), array('2.3'=>'12') ),2,0);
				
				$title = $langs->trans("DeliveryAddress")." :\n";
				$socname = '';//$sender->socname; 
				$socname.= !empty($s->socname) ? $s->socname."\n" : "";

				$address = $s->address."\n";
				$address.= $s->zip . ' - '. $s->town."\n";
				$phone= ' Tel : '. $s->phone."\n";

				$txt = $title . $socname . $address . $phone ."\n";
			
				if(! empty( $conf->global->EDIDEBUGLEVEL ) && $conf->global->EDIDEBUGLEVEL >= 5 )
					trigger_error("Extract NAD DP (\$txt):".print_r($txt, true) , E_USER_NOTICE);
			}
		}
		

			
		// Extract Note
		$note = $this->readEdiDataValue(array('FTX', array('1'=>'DEL') ),4);
		if(! empty( $conf->global->EDIDEBUGLEVEL ) && $conf->global->EDIDEBUGLEVEL >= 5 )
		trigger_error("Extract FTX DEL(\$txt):".print_r($note, true) , E_USER_NOTICE);
		
		if(!empty($note)){
			if(is_array($note))
				$txt.= "\n".implode("\n", $note); 
			else 
				$txt.= "\n".$note; 
		}
		
		
		
        
//         $user->id = 1; // tricks to set superadmin as creator
        $result = $invoice->create($user);
        
//         print_r($this->obj_ref->products
        if ($result > 0) {
            foreach ($this->obj_ref->products as $products) {
                $r= call_user_func_array(array($invoice, 'addline'), $products);
               
            }
            
              $result = $invoice->update($user);
        } 
        else {
            
			if(! empty( $conf->global->EDIDEBUGLEVEL ) && $conf->global->EDIDEBUGLEVEL >= 1 )
				trigger_error(' [WARNING]  create invoice :'.$result. ' > ' . $invoice->error, E_USER_NOTICE ); 
				
			return false; 

        }


		$result = $invoice->validate($user);

				
		$b = new \stdClass(); 
        $b->dol_type = get_class($invoice) ;
        $b->dol_type_id = $invoice->id ; 
		$b->object = $invoice;
        

        return $b; 
        
    }



	/**
		@fn GetPath()
		@brief
		@return string path 
    */
    public function GetPath(){
			return $this->path; 
    }
}
