<?php
/* Copyright (C) 2016		 Oscss-Shop       <support@oscss-shop.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 * or see http://www.gnu.org/
 */

loadClass("Societe");
loadClass("FactureFournisseur");
loadClass("Facture");

dol_include_once('/edi/class/send.class.php');
dol_include_once('/edi/vendor/EDI/Encoder.php');

dol_include_once('/edi/plugin/D96A/lib.functions.php');
dol_include_once('/edi/plugin/D96A/d96a.common.class.php');
dol_include_once('/edi/plugin/D96A/facture/INVOIC.output.php');

class EdiTriggerINVOIC
	extends edi_send
{

    /**
			@var uniq ref message 
    */
    public $ref_uniq =''; 
    
    
    /**
			@fn __construct()
    */
    public function __construct(
								$action
								, $object
								, $user
								, $langs
								, $conf
								, $entity
								, $db
								, $mysoc
								, $setup
								){

        $this->action = $action;
        $this->object = $object;
        $this->user   = $user;
        $this->langs  = $langs;
        $this->conf   = $conf;
        $this->entity = $entity;
        $this->db     = $db;
        $this->mysoc  = $mysoc;
        $this->setup  = $setup;


        parent::__construct($db); // used to share db access
    }
    


	/**
		@fn run_trigger()
		@brief execute trigger for this order 
	*/
    public function run_trigger() {

        $this->coreclass= new EDI\INVOIC($this->object, $this->mysoc,$this->setup,$this->action);

        $this->coreclass->SetDB($this->db);
        
        
		$cl = explode('\\', get_class($this->coreclass->obj_ref) );
        $typedoc = strtolower($cl[count($cl)-1]) ; 
        /**
			Extract ref_uniq
        */



        $res =$this->RefUniq($this->coreclass->obj_ref->socid, $typedoc , $this->coreclass->obj_ref->id  ); 

        
        $res->dol_type = $typedoc; 
        $res->dol_type_id = $this->coreclass->obj_ref->id; 
        
        /**
			Extract generate array and construct output
        */
		$this->coreclass->Generate($res); 
        
        
		/**
			Calulat path and file
		*/
		$this->output_file = output_file(  $this->coreclass->GetPath() , $this->coreclass->ref ) ; 
		
		if ( !file_exists( dirname($this->output_file ) ) ) 
			dol_mkdir( dirname($this->output_file ) );
			
		/**
			Write file 
		*/
		/// TODO impelement check test and error for return trace message
        $handle = fopen( $this->output_file, "w");
        if ($handle !== false) {
            fwrite($handle, $this->coreclass->encodeUNA());
            fclose($handle);
        }
        

        
		return $res; 
    }
}

