<?php
/* Copyright (C) 2016		 Oscss-Shop       <support@oscss-shop.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 * or see http://www.gnu.org/
 */

loadClass("Societe");
loadClass("CommandeFournisseur");
loadClass("Commande");

dol_include_once('/edi/class/send.class.php');
dol_include_once('/edi/class/actioncomm.class.php');
dol_include_once('/edi/vendor/EDI/Encoder.php');


dol_include_once('/edi/plugin/D96A/lib.functions.php');
dol_include_once('/edi/plugin/D96A/d96a.common.class.php');
dol_include_once('/edi/class/job.class.php');

// class edi_trigger 
class EdiTriggerGeneric extends edi_send
{
    var $action
        , $object
        , $user
        , $langs
        , $conf
        , $entity
        , $db
        , $mysoc
        , $setup
        , $message_type;
    var $output_file; // used in transmission also
    public $coreclass;

    /**
      @fn __construct()
     */
    public function __construct(
    $action
    , $object
    , $user
    , $langs
    , $conf
    , $entity
    , $db
    , $mysoc
    , $setup
    , $message_type
    , $norme
    )
    {
        parent::__construct($db); // used to share db access
        $this->action       = $action;
        $this->socid        = $object;
        $this->user         = $user;
        $this->langs        = $langs;
        $this->conf         = $conf;
        $this->entity       = $entity;
        $this->db           = $db;
        $this->mysoc        = $mysoc;
        $this->setup        = $setup;
        $this->message_type = $message_type;
        $this->norme        = $norme;
    }

    /**
      @fn run_trigger()
      @brief execute trigger for this obj_ref
      this is in output context
      @return $object $res
     */
    public function run_trigger()
    {
        global $conf;

        if (!empty($conf->global->EDIDEBUGLEVEL) && $conf->global->EDIDEBUGLEVEL >= 5) trigger_error("trigger EDI\\$this->message_type launch", E_USER_NOTICE);

        // put job in queue list for cron
        $job = new job($this->db);
        $job->program($this->socid, $this->message_type, $this->norme);

        trigger_error("TRIGGER EDI job: ".$this->socid.','.$this->message_type.','.$this->norme, E_USER_NOTICE);
        return $res;
    }
}