<?php 
/* Copyright (C) 2015 Oscss-Shop Team <support@oscss-shop.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */


/**
	@brief Construct path for stock in document
	@param $path string
	@param $ref string 
	@return string 
*/
function output_file($path, $ref, $count=''){
	$ref2=(!empty($count))? $ref.'.'.$count : $ref ;
			
	return sprintf($path, $ref, $ref2);
}



/**
	@param date date arg 2014-03-30 03:00:00
	@param int code 137 stand for when a document/message is issued
	@param string format 102 is YYYYMMDD
	@return an array of date time array( 160727, 0038 )
*/
function make_DTM_time($timestamp, $type = 137, $format = "102") {
		switch ($format) {
				case "102":
						return array(
								$type,
								date("Ymd", (int) $timestamp),
								$format
						);
						break;

				default:
						break;
		}
}


/**
	@return an array of date time array( 160727, 0038 )
*/
function make_UNB_time() {
		return array(
				date("ymd"),
				date("Hi")
		);
}

		
		
/**
*/
function remove_space($str) {
		return str_replace(' ', '', $str);
}

/**
*/
function format_number($number, $decimals = 2, $dec_point = ".", $thousands_sep = "") {
		return number_format($number, $decimals, $dec_point, $thousands_sep);
}
    
?>
