<?php
/* Copyright (C) 2015- 							 		Oscim 	<support@oscim.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 *      \file       htdocs/commande/info.php
 *      \ingroup    commande
 * 		\brief      Page des informations d'une commande
 */
$res = 0;
if (!$res && file_exists("../main.inc.php"))
    $res = @include("../main.inc.php");
if (!$res && file_exists("../../main.inc.php"))
    $res = @include("../../main.inc.php");
if (!$res && file_exists("../../../main.inc.php"))
    $res = @include("../../../main.inc.php");
if (!$res && file_exists("../../../../main.inc.php"))
    $res = @include("../../../../main.inc.php");
if (!$res && file_exists("../../../dolibarr/htdocs/main.inc.php"))
    $res = @include("../../../dolibarr/htdocs/main.inc.php");     // Used on dev env only
if (!$res && file_exists("../../../../dolibarr/htdocs/main.inc.php"))
    $res = @include("../../../../dolibarr/htdocs/main.inc.php");   // Used on dev env only
if (!$res && file_exists("../../../../../dolibarr/htdocs/main.inc.php"))
    $res = @include("../../../../../dolibarr/htdocs/main.inc.php");   // Used on dev env only
if (!$res)
    die("Include of main fails");

// CORE 
global $db;
dol_include_once('/edi/core/lib/edi.lib.php');
dol_include_once('/edi/class/setup_loader.class.php');

$setup = new setup_loader($db);


// WARNING ! this section NEVER give info about fail attempt
// it s made to prevent intrusions

$valid = false; // will be used to track if import is ok

if (isset($_FILES['file']) &&
        $_FILES['file']['type'] == "application/x-zip" &&
        $_FILES['file']['error'] == 0) {
    $tmpkey = uniqid();
    $tmpdir = dol_buildpath('/edi/plugin/') . "tmp$tmpkey/";
    mkdir($tmpdir);
    $tmpfile = dol_buildpath('/edi/plugin/') . "tmp$tmpkey/$tmpkey.zip";

    if (move_uploaded_file($_FILES['file']['tmp_name'], $tmpfile)) { // move to /edi/plugin/ dir
        dol_include_once('/oscssshopexts/class/PclZip/pclzip.lib.php'); // load PclZip
        $archive = new PclZip($tmpfile); // start PclZip
        $properties = $archive->properties();
        if ($properties['status'] == "ok") { // archive is ok     
            if (!(($v_result_list = $archive->extract(PCLZIP_OPT_PATH, $tmpdir, PCLZIP_OPT_REMOVE_ALL_PATH)) == 0)) {
                
                // extraction was ok
                unlink($tmpfile); // remove zip file
                
                // import files and verify integrity
                $valid = $setup->add_conf_files($v_result_list);

                //cleanup extracted files
                foreach ($v_result_list as $fileExtracted) {
                    unlink($fileExtracted['filename']);
                }
            }
        }
    }
    unlink($tmpfile);
    rmdir($tmpdir);
    // normaly useless , just security
    unlink($_FILES['file']['tmp_name']);
}


/*
 * View
 */

/* * *************************************************
 * VIEW
 *
 * Put here all code to build page
 * ************************************************** */

// llxHeader('', iconv(iconv_get_encoding($langs->trans($lbl_folder)), $character_set_client . "//TRANSLIT", $langs->trans($lbl_folder)) . ' (' . $info->Nmsgs . ') ', '');
llxHeader('', 'Edi', '');
dol_fiche_head(edi_prepare_head(), 'plugins', $langs->trans("Edi"), 0, 'edi@edi');
?>
<table summary="" class="centpercent notopnoleftnoright" style="margin-bottom: 2px;">
    <tbody>
        <tr>
            <td class="nobordernopadding widthpictotitle" valign="middle">
                <img src="/htdocs/theme/eldy/img/title_generic.png" alt="" title="" id="pictotitle" border="0">
            </td>
            <td class="nobordernopadding" valign="middle">
                <div class="titre"><?= $langs->trans('EdiOtherPlugin') ?> <a href="https://www.dolistore.com/en/search?orderby=position&orderway=desc&search_query=edi+plugin&submit_search=" target="_blank">https://www.dolistore.com/</a>
                </div>
            </td>
        </tr>
    </tbody>
</table>
<p><?= $langs->trans('EdiOtherPluginMore') ?></p>
<hr />
<?php if ($valid): ?>
    <h2><?= $langs->trans('EdiUploadSuccess') ?></h2>
    <p><a href="<?= dol_buildpath("/societe/list.php?leftmenu=thirdparties", 2) ?>"><?= $langs->trans('EdiUploadSuccessMore') ?></a></p>
<?php else: ?>
    <h2><?= $langs->trans('EdiUploadError') ?></h2>
<?php endif; ?>


<?php
//llxFooter('done');
