<?php
/* Copyright (C) 2001-2004 Rodolphe Quiedeville <rodolphe@quiedeville.org>
 * Copyright (C) 2003      Eric Seigne          <erics@rycks.com>
 * Copyright (C) 2004-2010 Laurent Destailleur  <eldy@users.sourceforge.net>
 * Copyright (C) 2005-2009 Regis Houssin        <regis@dolibarr.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/**
 * 	    \file       htdocs/comm/action/listactions.php
 *      \ingroup    agenda
 * 		\brief      Page to list actions
 * 		\version    $Id: listactions.php,v 1.39.2.1 2011/01/19 11:17:18 eldy Exp $
 */
$res = 0;
if (!$res && file_exists("../main.inc.php")) $res = @include("../main.inc.php");
if (!$res && file_exists("../../main.inc.php")) $res = @include("../../main.inc.php");
if (!$res && file_exists("../../../main.inc.php")) $res = @include("../../../main.inc.php");
if (!$res && file_exists("../../../../main.inc.php")) $res = @include("../../../../main.inc.php");
if (!$res && file_exists("../../../dolibarr/htdocs/main.inc.php")) $res = @include("../../../dolibarr/htdocs/main.inc.php");     // Used on dev env only
if (!$res && file_exists("../../../../dolibarr/htdocs/main.inc.php")) $res = @include("../../../../dolibarr/htdocs/main.inc.php");   // Used on dev env only
if (!$res && file_exists("../../../../../dolibarr/htdocs/main.inc.php")) $res = @include("../../../../../dolibarr/htdocs/main.inc.php");   // Used on dev env only
if (!$res) die("Include of main fails");


require_once(DOL_DOCUMENT_ROOT."/core/lib/functions2.lib.php");
require_once(DOL_DOCUMENT_ROOT."/core/lib/company.lib.php");
require_once(DOL_DOCUMENT_ROOT."/core/lib/files.lib.php");


dol_include_once('/framework/core/lib/framework.lib.php');
dol_include_once('/edi/class/societe.edi.class.php');
dol_include_once('/edi/class/setup_loader.class.php');


$langs->load("companies");
$langs->load("agenda");

$langs->load("edi@edi");

$handle=@opendir(dol_buildpath( 'edi/langs/'.$langs->defaultlang.'/',0));
if (is_resource($handle))
{
	while (($file = readdir($handle))!==false){
		if ( substr($file, 0, 3) != 'edi'  && substr($file,-5) == '.lang')
			$langs->load(substr($file, 0,-5)."@edi");
	}
}


// Security check
$action = GETPOST("action", 'chaine');
$socid  = GETPOST("socid", 'int');

if ($user->societe_id) $socid = $user->societe_id;

$soc     = new SocieteEdi($db);
$soc->id = $socid;
$soc->fetch($socid);
$soc->info($socid);

//var_dump($soc);

// $result = restrictedArea($user, 'edi', 0, '', 'myactions');

// build arrayd of conf even if nothing in DB for this user
$client_mode = GETPOST("type", 'chaine'); // client or vendor
$setup       = new setup_loader($db);
$setup->load_user($socid, $client_mode);

$normes       = array();
$confirmation = array();
switch ($action) {
    case 'updateconf':

        $edi_num           = GETPOST("edi_num", 'chaine');
        $trans_mode        = GETPOST("trans_mode", 'chaine');
        $trans_destination = GETPOST("trans_destination", 'chaine');
        $other = null; 

        // array >> stdClass
        $norme             = json_decode(json_encode(GETPOST('norme', 'array')), FALSE);
//         var_dump($norme);
//         exit;

		if(isset($conf->edismtps) && $conf->edismtps->enabled && in_array($trans_mode, array('sftpkey', 'sftppass') ) ){
			$trans_login           = GETPOST("trans_login", 'chaine');
			$trans_pass           = GETPOST("trans_pass", 'chaine');
			$trans_file           = GETPOST("trans_file", 'chaine');
// 			        var_dump($trans_mode);
			if($trans_mode == 'sftpkey'){
				if (isset($_FILES['trans_file']) && $_FILES['trans_file']['error'] == 0) {
					$file = $_FILES['trans_file']['name'];
// 					print_r($_FILES); 
					
					$upload_dir = $conf->societe->multidir_output[$conf->entity].'/'. $soc->id . "/edi/".$client_mode.'/';//.'_key.pem'  ;
					
					$result = dol_add_file_process($upload_dir, 0, 1, 'trans_file', '');
					

				}
			}
			
			$other = json_encode( array('login'=>$trans_login,'pass'=>$trans_pass, 'file'=>$upload_dir.$file));
		}
// 		print_r($other); 
// 		
// 		exit; 

        $setup->update_user($edi_num, $trans_mode, $trans_destination, $other, $norme);
//         print_r($setup);die();
        $setup->save_user($client_mode);

        header('Location: '.dol_buildpath("/edi/tab/edi_societe_config.php?type=".$client_mode."&socid=$socid", 2));
        break;
}

/*
 *  View
 */

/*
 * Affichage onglets
 */

$help_url = 'EN:Module_Agenda_En|FR:Module_Agenda|ES:M&omodulodulo_Agenda';
llxHeader('', $soc->name.' - '.$langs->trans("EdiTabsSociete"), $help_url);
?>

<?php
$head     = societe_prepare_head($soc);
dol_fiche_head($head, 'editabsthirdparty', $langs->trans("ThirdParty"), 0, 'company');
$form     = new Form($db);
$buttons  = array(); 


// foreach(array('client', 'vendor') as $k=>$client_mode) {



$setup->load_user($socid, $client_mode);

print '<table width="100%" class="border">';
print '<tr><td width="30%">'.$langs->trans("ThirdPartyName").'</td><td width="70%" colspan="3">';
//$object->next_prev_filter = "te.fournisseur = 1";
print $form->showrefnav($soc, 'socid', '', ($user->societe_id ? 0 : 1), 'rowid', 'nom', '', '');
print '</td></tr>';

// Address
print '<tr><td valign="top">'.$langs->trans("Address").'</td><td colspan="3">';
dol_print_address($soc->address, 'gmap', 'thirdparty', $soc->id);
print '</td></tr>';

// Zip / Town
print '<tr><td class="nowrap">'.$langs->trans("Zip").' / '.$langs->trans("Town").'</td><td colspan="3">'.$soc->zip.(($soc->zip && $soc->town) ? ' / ' : '').$soc->town.'</td>';
print '</tr>';

// Country
print '<tr><td>'.$langs->trans("Country").'</td><td colspan="3">';
//$img=picto_from_langcode($object->country_code);
$img = '';
if ($soc->isInEEC()) print $form->textwithpicto(($img ? $img.' ' : '').$soc->country, $langs->trans("CountryIsInEEC"), 1, 0);
else print ($img ? $img.' ' : '').$soc->country;
print '</td></tr>';


print '</table>';
print '<form action="'.dol_buildpath('/edi/tab/edi_societe_config.php?type='.$client_mode.'&socid='.$socid.'&action=updateconf', 2).'" method="post" enctype="multipart/form-data">';

print '<table width="100%" class="border">';

print '<tr><td width="30%">'.$langs->trans("EdiUniqNum").'</td><td width="20%">';
print '<input type="text" name="edi_num" placeholder="ex: 2312070000018"  value="'.$setup->user->edi_num.'" />';
print '</td><td width="50%">'.$langs->trans("EdiUniqNumDetail").'</td></tr>';

print '<tr><td width="30%">'.$langs->trans("EdiModeOfTransmission").'</td><td width="20%"">';
print '<select name="trans_mode">';
print '<option value="manual"'.(($setup->user->trans_mode === "manual") ? ' selected' : '').'>'.$langs->trans("EdiManual").'</option>';
print '<option value="email"'.(($setup->user->trans_mode === "email") ? ' selected' : '').'>'.$langs->trans("Ediemail").'</option>';
print '<option value="urlapi"'.(($setup->user->trans_mode==="urlapi")?' selected':'').'>' . $langs->trans("Ediurlapi") . '</option>';
print '<option value="urlflux"'.(($setup->user->trans_mode === "urlflux") ? ' selected' : '').'>'.$langs->trans("Ediurlflux").'</option>';

print '<option value="ftp"'.(($setup->user->trans_mode === "ftp") ? ' selected' : '').'>'.$langs->trans("Ediftp").'</option>';

if (isset($conf->edismtps) && $conf->edismtps->enabled){
	print '<option value="sftpkey"'.(($setup->user->trans_mode === "sftpkey") ? ' selected' : '').'>'.$langs->trans("EdisftpKey").'</option>';
	print '<option value="sftppass"'.(($setup->user->trans_mode === "sftppass") ? ' selected' : '').'>'.$langs->trans("EdisftpPass").'</option>';
}

print '</select>';
print '</td><td width="50%">'.$langs->trans("EdiModeOfTransmissionDetail").'</td></tr>';

print '<tr><td width="30%">'.$langs->trans("EdiTipOfSpecification").'</td><td width="20%">';
print '<input name="trans_destination" type="text" value="'.$setup->user->trans_destination.'">';
print '</td><td width="50%">'.$langs->trans("EdiTipOfSpecificationDetail").'</td></tr>';

if (isset($conf->edismtps) && $conf->edismtps->enabled){

	print '<tr><td width="30%">'.$langs->trans("EdiTipOfSpecificationLogin").'</td><td width="20%">';
	print '<input name="trans_login" type="text" value="'.$setup->user->trans_login.'">';
	print '</td><td width="50%">'.$langs->trans("EdiTipOfSpecificationLoginDetail").'</td></tr>';

	print '<tr><td width="30%">'.$langs->trans("EdiTipOfSpecificationPass").'</td><td width="20%">';
	print '<input name="trans_pass" type="text" value="'.$setup->user->trans_pass.'">';
	print '</td><td width="50%">'.$langs->trans("EdiTipOfSpecificationPassDetail").'</td></tr>';

	print '<tr><td width="30%">'.$langs->trans("EdiTipOfSpecificationKey").'</td><td width="20%">';
	print $setup->user->trans_file.'<input name="trans_file" type="file" value="'.$setup->user->trans_file.'">';
	print '</td><td width="50%">'.$langs->trans("EdiTipOfSpecificationKeyDetail").'</td></tr>';
}

print '</table>';

if (!(empty($setup->user->edi_num) /*|| empty($setup->user->trans_destination)*/ )) {
    print '<h2>'.$langs->trans("EdiConf$client_mode").'</h2>';

    foreach ($setup->descriptor as $norme => $norme_array) {

//         $langs->load("$norme@edi");

        print '<table width="100%" class="border">';
        print '  <tr>';
        print '    <th colspan="4"><h3>'.$langs->trans("Edi{$norme}desc").'<br><small>'.$langs->trans("Edi{$norme}descDetail").'</small></h3></th>';
        print '  </tr>';

        print '  <tr>';
        print '    <td width="10%"><b>'.$langs->trans("EdiDirection").'</b></td>';
        print '    <td width="30%"><b>'.$langs->trans("EdiName").'</b></td>';
        print '    <td width="10%"><b>'.$langs->trans("EdiMessage").'</b></td>';
        print '    <td width="50%"><b>'.$langs->trans("EdiInformation").'</b></td>';
        print '  </tr>';

        foreach ($norme_array->message as $direction => $direction_array) {
            $first_passage = 1;
            foreach ($direction_array as $message => $message_array) {
                //var_dump(count((array)$direction_array));

                if (($client_mode == 'client' && $direction == '')) print '  <tr>';
                if ($first_passage++ == 1) {
                    print '    <td rowspan="'.count((array) $direction_array).'">'.$langs->trans("EdiDirection$direction").'</td>';
                }
                print '    <td>'.$langs->trans("Edi{$norme}$direction{$message}Title").'</td>';
                $check = ($setup->user->setup->$norme->message->$direction->$message) ? 'checked=""' : '';
                if (isset($setup->descriptor->$norme->message->$direction->$message->button) && $setup->user->setup->$norme->message->$direction->$message) {
                    $button    = $setup->descriptor->$norme->message->$direction->$message->button;
                    $buttons[] = $button;
                }
                print '    <td><label><input name="norme['.$norme.'][message]['.$direction.']['.$message.']" type="checkbox" value="1" '.$check.' /> '.$message.'</label></td>';
                print '    <td>'.$langs->trans("Edi{$norme}$direction{$message}TitleDetail").'</td>';
                print '  </tr>';
            }
        }

        print '</table>';
    }
}
print '<div class="tabsAction"><div class="inline-block divButAction">';
foreach ($buttons as $button) {
    $href = str_replace('__socid__', $socid, $button->href);
    print '<a class="butAction" href="'.dol_buildpath($href, 2).'">'.$langs->trans($button->title).'</a>';
}
print '<input type="submit" class="butAction" value="'.$langs->trans("EdiSave").'"></div>';
print '</div></form>';

// }

llxFooter('$Date: 2011/01/19 11:17:18 $ - $Revision: 1.39.2.1 $');
?>
