<?php
/* <one line to give the program's name and a brief idea of what it does.>
 * Copyright (C) 2015 ATM Consulting <support@atm-consulting.fr>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/**
 *	\file		lib/factor.lib.php
 *	\ingroup	factor
 *	\brief		This file is an example module library
 *				Put some comments here
 */

function factorsgfAdminPrepareHead()
{
    global $langs, $conf, $mysoc;

    $langs->load("factor@factorsgf");

    $h = 0;
    $head = array();

    $head[$h][0] = dol_buildpath("/factorsgf/admin/factor_setup.php", 1);
    $head[$h][1] = $langs->trans("Parameters");
    $head[$h][2] = 'settings';
    $h++;
    $head[$h][0] = dol_buildpath("/factorsgf/admin/factor_about.php", 1);
    $head[$h][1] = $langs->trans("About");
    $head[$h][2] = 'about';
    $h++;

    // Show more tabs from modules
    // Entries must be declared in modules descriptor with line
    //$this->tabs = array(
    //	'entity:+tabname:Title:@factor:/factor/mypage.php?id=__ID__'
    //); // to add new tab
    //$this->tabs = array(
    //	'entity:-tabname:Title:@factor:/factor/mypage.php?id=__ID__'
    //); // to remove a tab
    complete_head_from_modules($conf, $langs, $object, $head, $h, 'factor');

    return $head;
}

function _export_factures(&$db, &$format, &$TRefFacture)
{
        global $conf;
        $TfileName=array();
	switch ($format) {
		case 'natixis':
			$fileName = _parseNatixis($db, $TRefFacture);
			break;
                case 'SGF':
                        //c'est _parsePNS qui appelle _parseNA
			$TfileName = _parsePNS($db, $TRefFacture);
                        break;               
	}
	
	if ($TfileName[0]&&$TfileName[1])
	{
		//envoie des fichiers par email 
                $Tfilespath[0]=DOL_DATA_ROOT.'/factorsgf/'.$TfileName[0];
                $Tfilespath[1]=DOL_DATA_ROOT.'/factorsgf/'.$TfileName[1];
                
                $Tmime[0]='txt';$Tmime[1]='txt';
                $Tfilesname[0]=$TfileName[0];$Tfilesname[1]=$TfileName[1];
                //factoring.fichiertest@socgen.com
                $mailfile = new CMailFile('Fichiers',$conf->global->EMAIL_SEND,$conf->global->EMAIL_EXP,'SGF',$Tfilespath,$Tmime,$Tfilesname);
                //$mailfile->write_files($TfilesName,$Tmime,$TfilesName);
                $mailfile->sendfile();
                //header('Location: '.dol_buildpath('document.php?modulepart=factorsgf&file='.$fileName, 2));
		//exit;
	}
	
}

function _parsePNS(&$db, &$TRefFacture)
{
	global $conf,$langs,$mysoc;
	
	$TError = array();
        $TCodeClients=array();
        $nbclients=0;
	$texte="";
	foreach ($TRefFacture as $ref)
	{
		$facture = new Facture($db);
		$facture->fetch('', $ref);
		$facture->fetch_thirdparty();
		if (empty($facture->mode_reglement_code)) $TError['TErrorModeReglt'][] = $langs->transnoentitiesnoconv('ErrorFactorEmptyModeReglt', $facture->ref);

//1 	Type du fichier	X(4)	O	Mot clé initialisé à ‘CDFM’
                $texte.="CDFM;";
//2	Séparateur décimal	X(1)	O	Virgule ‘,’ ou point ‘.’                 
                $texte.=".;";
//3	Version	X(2)	O	‘04’. Respecter le zéro non significatif
                $texte.="04;";
//4	Format des dates	X(10)	O	AAAAMMJJ                
                $texte.="AAAAMMJJ;";
//5	Type de N° débiteur	X(1)	O	 ‘A’ par défaut                
                $texte.="A;";
//6	Date de constitution du fichier	X(10)	O	Date de création du fichier sur votre système
                $texte.=date('Ymd').";";
//7	Code société	9(2)	O	‘11’ par défaut
                $texte.="11;";
//8	N° Factor adhérent	X(15)	O	‘00001’ par défaut. Respecter les zéros non significatifs               
                $texte.="00001;";
//9	Numéro d’adhérent	X(7)	O	Votre numéro d’adhérent chez SGF. Respecter les zéros non significatifs
                $texte.=$conf->global->FACTOR_NUM_ADHERENT.";";
//10	Numéro de contrat adhérent	X(3)	O	Votre numéro de contrat chez SGF. Respecter les zéros non significatifs                
                $texte.=$conf->global->FACTOR_NUM_CONTRAT.";";
//11	Type d’activité	X(1)	O	‘D’ par défaut sauf spécification de votre interlocuteur SGF
                $texte.="D;";
//12	Code devise du compte adhérent	X(3)	O	Code ISO (Cf. annexe 2)
                $texte.=$conf->global->FACTOR_DEVISE.";";
//13	N° de compte débiteur	X(10)	O	Votre n° de compte du débiteur (votre référence client interne)
                $texte.=$facture->thirdparty->code_client.";";
//Construction tableau des codes clients uniques
                if (!array_search($facture->thirdparty->ref, $TCodeClients))
                {    
                    $TCodeClients[$nbclients]=$facture->thirdparty->ref;
                    $nbclients++;
                }                              
//14	Date d’arrêté comptable	X(10)	O	Date d’arrêté comptable du PNS
                $texte.=date('Ymd').";";
//15	Code devise	X(3)	O	Code ISO (Cf. annexe 3)
                $texte.=$facture->multicurrency_code.";";
//16	Type de pièce/opération 	X(2)	O	Type opération (Cf. annexe 1) AV:21 Facture: 01
                if ($facture->type==0) $texte.="01;";
                else if ($facture->type==2) $texte.="21;";
//17	Numéro de pièce / opération	X(15)	O	Pour les factures et avoirs, il s’agit du numéro figurant sur vos documents papier et non votre n° de pièce comptable. Il  correspond au n° figurant dans le fichier de « remises de factures et avoirs » si vous nous le transmettez.
                $texte.=$facture->ref.";";
//18	Date de pièce/opération	X(10)	O	Date de la pièce
                $texte.=dol_print_date($facture->date,"%Y%m%d",false,$lang,true).";";
//19	Date d’enregistrement	X(10)	O	Date d’enregistrement de la pièce
                $texte.=dol_print_date($facture->date,"%Y%m%d",false,$lang,true).";";
//20	Montant TTC	+9(11)V99	O	Montant initial de la pièce
                $texte.=round($facture->total_ttc,2).";";
//21	Filler	+9(11)V99	N	
                $texte.=";";
//22	Solde de la pièce	+9(11)V99	O	Positif si débiteur, négatif si créditeur
                $texte.=round($facture->total_ttc,2).";";
//23	Date échéance 1	X(10)	O	1ère date d’échéance
                $texte.=dol_print_date($facture->date_lim_reglement,"%Y%m%d",false,$lang,true).";";
//24	Solde  échéance 1	+9(11)V99	O	Solde du net à payer pour la 1ère échéance
                $texte.=round($facture->total_ttc, 2).";";
                $texte.="\r\n";
                
	}
	$_SESSION['TErrorModeReglt'] = $TError['TErrorModeReglt'];
	// write file
	$folder = ($conf->entity == 1) ? DOL_DATA_ROOT.'/factorsgf/' : DOL_DATA_ROOT.'/'.$conf->entity.'/factorsgf/';
	dol_mkdir($folder);
	//Nom du fichier
	$TfileName[0] = 'NC'.$conf->global->FACTOR_NUM_ADHERENT.'1.txt';
	$fullPath = $folder.$TfileName[0];
	$handle = fopen($fullPath, 'w+');
	if ($handle)
	{
		fwrite($handle, $texte);
		fclose($handle);
                $TfileName[1]= _parseNA($db, $TCodeClients);
		return $TfileName;
                
	}
	else {
		setEventMessages('ErrorCanNotCreateExportFile', array(), 'errors');
		return 0;
	}
}

function _parseNA(&$db, &$TCodeClient)
{
	global $conf,$langs,$mysoc;
	
	$TError = array();
	$texte="";
	foreach ($TCodeClient as $refclient)
	{
		
                $soc = new Societe($db);
                $soc->fetch($refclient);
                //echo "<pre>";print_r($soc);echo "</pre>";
                
//1 	Type du fichier	X(4)	O	Mot clé initialisé à ‘ADEB’ 
                $texte.="ADEB;";
//2	Séparateur décimal	X(1)	O	Virgule ‘,’ ou point ‘.’ 
                $texte.=".;";
//3	Version	X(2)	O	‘04’ par défaut. Respecter le zéro non significatif
                $texte.="04;";
//4	Format des dates	X(10)	O	AAAAMMJJ L’année est sur 4 positions, le mois et le jour sur 2.
                $texte.="AAAAMMJJ;";
//5	Type de N° débiteur	X(1)	O	‘A’ par défaut
                $texte.="A;";
//6	Date de constitution du fichier	X(10)	O	Date de création du fichier sur votre système
                $texte.=date('Ymd').";";
//7	Code société	9(2)	O	‘11’ par défaut
                $texte.="11;";
//8	N° Factor adhérent	X(15)	O	‘00001’ par défaut. Respecter les zéros non significatifs
                $texte.="00001;";
//9	Numéro d’adhérent	9(7)	O	Votre numéro d’adhérent chez SGF
                $texte.=$conf->global->FACTOR_NUM_ADHERENT.";";
//10	Numéro de contrat adhérent	9(3)	O	Votre numéro de contrat chez SGF    
                $texte.=$conf->global->FACTOR_NUM_CONTRAT.";";
//11	Type de contrat	X(1)	O	‘D’ par défaut sauf spécification de SGF
                $texte.="D;";
//12	Code devise du compte adhérent	X(3)	O	Code ISO de la devise de facturation (Cf. annexe 3)
                $texte.=$conf->global->FACTOR_DEVISE.";";
//13	Numéro de SIREN débiteur	9(9)	O	Obligatoire si le débiteur est français sauf si le n° de TVA est indiqué
                $texte.=substr($soc->idprof2,0,9).";";
//14	Code NIC (établissement facturé)	9(5)	N	5 derniers caractères du Siret du débiteur
                $texte.=substr($soc->idprof2,9,5).";";
//15	Montant demandé ou agrément	9(13)	O/N	Montant de votre demande d’approbation ou d’agrément d’assurance (A renseigner suivant le type de contrat signé avec SGF)
                $texte.=";";
////16	Devise demande ou agrément	X(3)	O/N	Code ISO (Cf. annexe 3) du montant précédent (champ 15)
                $texte.=";";
//17	Raison sociale	X(40)	O	Raison sociale du débiteur
                $texte.=$soc->nom.";";
//18	Adresse de Facturation ligne 1	X(40)	O	Au moins une ligne adresse renseignée
                $texte.=substr(str_replace( array( '<br>', '<br />', "\n", "\r" ), array( ' ', ' ', ' ', ' ' ), $soc->address),0,40).";";
//19	Adresse de Facturation ligne 2	X(40)	N
                $texte.=";";
//20	Adresse de Facturation ligne 3	X(40)	N
                 $texte.=";";
//21	Code postal Facturation	X(12)	O	
                $texte.=$soc->zip.";";
//22	Ville Facturation	X(40)	O
                $texte.=$soc->town.";";
//23	Code pays facturation	X(3)	O	Code ISO (Cf. annexe 2)
                $texte.=$soc->country_code.";";
//24	Téléphone	X(20)	O	N° de téléphone du débiteur
                $texte.=$soc->phone.";";
//25	N° de compte débiteur	X(30)	O	Votre référence interne dont Seul les 10 premiers caractères sont exploités
                $texte.=$soc->code_client.";";
//26	Date d’agrément	X(10)	N	Date de a demande ou de l’agrément (champ 15)
                $texte.=";";
//27	Filler	9(5)	N
                $texte.=";";	
//28	Filler	9(5)	N
                $texte.=";";
//29	Filler	X(11)	N
                $texte.=";";
//30	Filler	9(2)	N
                $texte.=";";	
//31	Filler	X(4)	N
                $texte.=";";
//32	Filler	X(30)	N
                $texte.=";";
//33	Filler	X(11)	N
                $texte.=";";
//34	Numéro de TVA CEE	X(14)	O	Obligatoire pour les débiteurs de l’Union Européenne hors France
                $texte.=$soc->tva_intra.";";
//35	Code pays débiteur	X(3)	O	Code ISO (Cf. annexe 2)
                $texte.=$soc->country_code.";";
//36	Raison sociale centre payeur	X(40)	N	Les données concernant le centre payeur ne sont pas à renseigner si elles sont identiques à celles de facturation
                $texte.=";";
//37	Adresse centre payeur ligne 1	X(40)	N
                $texte.=";";
//38	Adresse centre payeur ligne 2	X(40)	N
                $texte.=";";	
//39	Adresse centre payeur ligne 3	X(40)	N
                $texte.=";";
//40	Code postal centre payeur	X(12)	N
                $texte.=";";
//41	Ville centre payeur	X(40)	N	
                $texte.=";";
//42	Code pays centre payeur	X(3)	N	Code ISO (Cf. annexe 2)
                $texte.=";";
//43	N° de la police d’assurance	X(20)	O/N	Obligatoire si la police d’assurance est en gestion déléguée
                $texte.=";";
//44	N° débiteur chez votre assureur	X(60)	O/N	Obligatoire si la police d’assurance est en gestion déléguée
                $texte.=";";
//45	Délais de paiement	9(3)	N	Nombre de jours
                $texte.=";";
//46	Filler	X(1)	N
                $texte.=";";
//47	Nom du correspondant	X(30)	N	Nom de votre interlocuteur
                $texte.=";";
//48	Identifiant débiteur étranger	X(40)	O	Pour les débiteurs hors Union Européenne, équivalent du RCS local
                $texte.=";";

                $texte.="\r\n";
                
	}
	$_SESSION['TErrorModeReglt'] = $TError['TErrorModeReglt'];
	// write file
	$folder = ($conf->entity == 1) ? DOL_DATA_ROOT.'/factorsgf/' : DOL_DATA_ROOT.'/'.$conf->entity.'/factorsgf/';
	dol_mkdir($folder);
	//Nom du fichier
	$fileName = 'NA'.$conf->global->FACTOR_NUM_ADHERENT.'1.txt';
	$fullPath = $folder.$fileName;
	$handle = fopen($fullPath, 'w+');
	if ($handle)
	{
		fwrite($handle, $texte);
		fclose($handle);
		return $fileName;
	}
	else {
		setEventMessages('ErrorCanNotCreateExportFile', array(), 'errors');
		return 0;
	}
}
