<?php
/* Copyright (C) 2016		 Oscss-Shop       <support@oscss-shop.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 * or see http://www.gnu.org/
 */

 


/**
	@class ApiRegistration
	@brief this class used for link of API 
			method regroup URL of API and simplify usage in module extends framework 
*/
Class ApiRegistration {

	/**
	*/
	public $verbose = false; 
	
	/**
	*/
	public $url; 
	/**
	*/
	public $api_key_base; 
	/**
		@var 
	*/
	public $ValueConst;
	/**
		@var public external presonnalied key 
	*/
	public $apikey;
	/**
		@var public external prefix key 
	*/
	public $apiprefix;
	/**
		@var 
	*/
	public $submodisprev;
	/**
		@var 
	*/
	public $subarray = array();
	
	/**
	*/
	public function __construct($url, $api_key, $ValueConst){
		$this->url = trim($url); 
		$this->api_key_base = trim($api_key);
		$this->ValueConst = trim($ValueConst); 
		
		// fix key
		if(strlen($this->ValueConst) >29 )
			$this->SetConfigKey(); 
	}

	/**
		@brief Test a l'init pour verif master key and list module last activated
		@param $conf object dolibarr $conf var
		@return boolean treu / false for not ok
	*/
	public function CheckTestInit($conf){
	
		// fix key
		$this->SetConfigKey(); 

		
		// test master key 
		$url ='accounts/'.$this->apiprefix.'/?api_key='.$this->apikey.'&dolibarrurl='.urlencode($_SERVER['SERVER_NAME']); 
		$result = $this->Get(
			$url
			,array() 
			);

		if(!$result) 
			return false;
		if(!is_array($result) || !is_array($result['data']) )
			return false;
			


		if( !isset($result['data'][0]) || !is_array($result['data'][0]) || !array_key_exists('api_key', $result['data'][0])/* != $this->apikey */) 
			return false; 

		
		// 
		$result = $this->Get(
				'submodule/?api_key='. $this->apikey.'&dolibarrurl='.urlencode($_SERVER['SERVER_NAME'])
				,array() 
				);
 
			
		if(!$result) 
			return false; 
			
			
			
		// FIX 
		$this->api_key_base =  $result['data'][0]['api_key'];
		$this->api_key = $this->api_key_base  ; 
		$this->apiprefix = str_pad($result['data'][0]['id'], 6, "0", STR_PAD_LEFT) ; 


		$this->subarray = @$result['data']; 
		
		$this->submodisprev =/*$submodisprev =*/ true;
		foreach((array)@$result['data'] as $line){
// 				if($currentmod === $line['module'])d
				$this->submodisprev = /*$submodisprev = */ false;
		}
		
		return true; 
	}
	
	/**
		@fn SetRegistrationMaster()
		@brief Registration of api for user/dolibarrurl
			This method is required for registration other modules 
		@return ValueConst Key For Stocked in Conf doli
	*/
	public function SetRegistrationMaster($fields){
	

		$url = 'registration/?api_key='.$this->api_key_base; 

		$result = $this->Get(
			$url
			,$fields 
			, 'POST'
			); 

		if(!isset($result['data'][0]['api_key']) || empty($result['data'][0]['api_key']) )
			return false;
			

		$this->ValueConst = str_pad($result['data'][0]['id'], 6, "0", STR_PAD_LEFT) . $result['data'][0]['api_key'];
			
		// fix key
		$this->SetConfigKey();
		
		// TODO A revoir 
		if(isset($_SESSION['cacheversion']))
			unset($_SESSION['cacheversion']); 

		return $this->ValueConst; 
	}
	
	/**
	*/
	public function SetRegistrationModule($fields){

		/*$result =*/ $this->Get(
			'submodule/?api_key='.$this->apikey.'&dolibarrurl='.urlencode($_SERVER['SERVER_NAME'])
			,$fields 
			,'POST'); 
		$result = $this->curl_result; 

		if($result == false)
			return false; 

		if( $result['data'][0]['module'] != $fields['module'] ) 
			return false;
			
		// TODO A revoir 
		$_SESSION['cacheversion']=array();
			
		return $result['data'][0]; 
	}
	
	/**
	*/
	public function GetMyAccount($fields=array()){
	// fix key
		$this->SetConfigKey();
		
		$url = 'myactivation/?filter[id_owner]='.(int)$this->apiprefix.'&api_key='.$this->apikey.'&dolibarrurl='.urlencode($_SERVER['SERVER_NAME']); 
		
		$result = $this->Get(
			$url
			,$fields 
			); 
			
		return $result; 
	}
	
	/**
		@brief Get versions of module referenced for current user
		@fn GetVersion()
		@param array $fields param for api request 
		@return 
	*/
	public function GetVersion($fields=array()){
		global $conf; 
		
		
	// fix key
		$this->SetConfigKey();
		$url ="versions/?order_by=id&order=desc" ;
		if (empty($conf->global->MAIN_FEATURES_LEVEL) || $conf->global->MAIN_FEATURES_LEVEL <= 0)
			$url .='&filter[level]=stable';

		$url .="&api_key=".$this->apikey;

		$result = $this->Get(
			$url
			,$fields 
			); 
			
		return $result; 
	}
	
	
	/**
	*/
	public function GetApi(){
	
	}

	/**
		@fn SetConfigKey()
		@brief the value : $this->ValueConst is key, if is personal key, this is composedkey, but if is default or edotor key, this key is not composed
		@return none; 
	*/
	protected function SetConfigKey(){
		if(strlen($this->ValueConst) >29 ){
			$this->apikey = substr($this->ValueConst,6);
			$this->apiprefix = substr($this->ValueConst,0,6);
		}
		elseif(!empty($this->ValueConst) ) {
			$this->apikey = $this->ValueConst;
			$this->apiprefix = '000000';
		}
		else{
			$this->apikey = $this->api_key_base;
			$this->apiprefix = '000000';
		}
	}


	/**
		@brief 
		@param $fields 
	*/
	public function Get( $url, $fields = array(), $method='GET' ){
// echo  $this->url .$url; 

		$ch = curl_init();
		
		
		if( is_array($fields) && count($fields) )
			curl_setopt($ch,CURLOPT_POST, count($fields));
			
		switch ($method) {
			case "POST":
				curl_setopt($ch, CURLOPT_POST, 1);
				$httpheader[] = "Content-Type:application/json; ";

				if ($fields) curl_setopt($ch, CURLOPT_POSTFIELDS, $fields);

				break;
			case "PUT":

				curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'PUT');
				$httpheader[] = "Content-Type:application/json; ";

				if ($fields) curl_setopt($ch, CURLOPT_POSTFIELDS,  json_encode($fields));

				break;
			default:
				if ($fields) $url = sprintf("%s&%s", $url, http_build_query($fields));
				
	//             var_dump( $url ); 
		}

    
    
		curl_setopt($ch,CURLOPT_URL, $this->url .$url );
		
		if(substr($this->url, 0,strpos($this->url,':') ) ==='https'){
			curl_setopt( $ch, CURLOPT_AUTOREFERER, TRUE );
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
			curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
// 			curl_setopt($ch, CURLOPT_SSL_VERIFYSTATUS, FALSE);
			
// 			curl_setopt($ch, CURLOPT_SSLVERSION,2);
		}
		
// 		if( is_array($fields) && count($fields) ){
// 		
// // 			foreach($fields as $key=>$value) { $fields_string .= $key.'='.$value.'&'; }
// // 						rtrim($fields_string, '&');
// 						
// 			curl_setopt($ch,CURLOPT_POST, count($fields));
// 			curl_setopt($ch,CURLOPT_POSTFIELDS, $fields_string);
// 		}
		curl_setopt($ch,CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch,CURLOPT_HEADER, false);
		curl_setopt($ch,CURLOPT_FOLLOWLOCATION, false);
// 		curl_setopt($ch,CURLOPT_CONNECTTIMEOUT, 120);
// 		curl_setopt($ch,CURLOPT_TIMEOUT, 120);

		if($this->verbose)
			curl_setopt($ch,CURLOPT_VERBOSE, true);
		
		
		$result = curl_exec($ch);
		$info = curl_getinfo($ch);

		$this->curl_getinfo =  $info;
		$this->curl_error =  curl_error($ch);
		
		

		$this->curl_result = $result;
		if($this->verbose){
			print_r($this->curl_error);
			print_r($this->curl_getinfo);
			print_r($this->curl_result); 
		}

		curl_close($ch);
		if($result == false) 
			return false; 
			
		if($this->curl_getinfo['content_type'] != 'application/json')
			$result = json_encode($result,true);
		else
			$result = json_decode($result,true);

		return $result; 
	}

}
