<?php
/*
 * Copyright (C) 2017		 Oscss-Shop       <support@oscss-shop.fr>.
 *
 * This program is free software; you can redistribute it and/or modifyion 2.0 (the "License");
 * it under the terms of the GNU General Public License as published bypliance with the License.
 * the Free Software Foundation; either version 3 of the License, or
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 * or see http://www.gnu.org/
 */

//namespace CORE;

require_once DOL_DOCUMENT_ROOT.'/core/class/commonobject.class.php';

// namespace CORE\FRAMEWORK;
dol_include_once('/framework/class/trait/commonobjectview.trait.php');
dol_include_once('/framework/class/trait/commonobjectcontroler.trait.php');
require_once( dol_buildpath('/framework/vendor/Mustache/Autoloader.php', 0) );



Interface button {
}

Interface status {
	public function getLibStatut($mode = 0);
}

Interface generateDocument {
	/**
	 *  Create an intervention document on disk using template defined into QUALITYREPORT_ADDON_PDF
	 *
	 *  @param	string		$modele			Force template to use ('' by default)
	 *  @param	Translate	$outputlangs	Objet lang to use for translation
	 *  @param  int			$hidedetails    Hide details of lines
	 *  @param  int			$hidedesc       Hide description
	 *  @param  int			$hideref        Hide ref
	 *  @return int         				0 if KO, 1 if OK
	 */
	public function generateDocument($modele, $outputlangs, $hidedetails=0, $hidedesc=0, $hideref=0);
}

/**
	@remarks Precise interface for adjust process in two context ; 
		one ref adn ref in db is ref
		use two ref  in db ref_int / ref_ext
*/
Interface UniqRef {
}
Interface IntRef {
}


/**
	@remarks Precise interface for implement link to other boject 
	Complete showLinkToObjectBlock method hook in action class 
*/
Interface linkedObject{
}





Trait SupportMVC {
	function init(){
		global $langs; 
	
		if(empty($this->rootDir) ) 
				$this->rootDir = $this->element; 
				
		if(is_object($langs)){
			$langs->load($this->element.'@'.$this->element);
			$this->Form      = new Form($this->db);
		}
		$this->Directory = dol_buildpath($this->rootDir, 0);
		$this->Path      = dol_buildpath($this->rootDir, 2);
		

		

		
		// Unset fields that are disabled
		foreach($this->fields as $key => $val)
		{
			if (isset($val['enabled']) && empty($val['enabled']))
			{
				unset($this->fields[$key]);
			}
		}
		

		// put key in array for Mustache
		foreach ($this->fields as $key => &$array) {
			$array['key'] = $key;
		}


		
		if(is_object($langs))
			$this->implementMustache($this->Directory); // you can use $this->Mustache
        
	}
	
	public function create(User $user){
		global $conf;
// 		var_dump(__file__); 
// 		exit; 
		
		$defaultref = '';
		$modele     = /*empty($conf->global->ADVANCEDTICKET_ADDON) ? */'mod_test5_simple'/* : $conf->global->ADVANCEDTICKET_ADDON*/;

		// Search template files
		$file      = '';
		$classname = '';
		$filefound = 0;
		$dirmodels = array_merge(array('/'), (array) $conf->modules_parts['models']);
		foreach ($dirmodels as $reldir) {
			$file = dol_buildpath($reldir."core/modules/".$this->element."/".$modele.'.php', 0);
			if (file_exists($file)) {
				$filefound = 1;
				$classname = $modele;
				break;
			}
		}

		if ($filefound) {
			$result           = dol_include_once($reldir."core/modules/".$this->element."/".$modele.'.php');
			$modQualityReport = new $classname;

			$defaultref = $modQualityReport->getNextValue($this->thirdparty, $this);
		}

		if (is_numeric($defaultref) && $defaultref <= 0) {
			$defaultref = '';
		}
		
		// Update ref with new one
		if( empty($this->ref) ) 
			$this->ref = $defaultref;
			
		$this->tms = 'null'; 
		$this->fk_user_modif = 'null'; 
			
// 		if(method_exists(parent::
		$return = $this->createCommon($user);
// 		print_r($this); 
// 		exit; 
		
		return $return; 
	}

	
    /**
     * Prepare array with list of tabs
     *
     * @param   Object	$object		Object related to tabs
     * @return  array				Array of tabs to shoc
     */
    function prepare_head()
    {
		global $db, $langs, $conf, $user;
		

		$h = 0;
		$head = array();

		if($this->id>0) {
			$baseurl = dol_buildpath($this->rootDir.$this->Card, 1); 
			$head[$h][0] = $baseurl.'?id='.$this->id;
			$head[$h][1] = $langs->trans("Card");
			$head[$h][2] = 'card';
			$h++;
			
			
// 			$head[$h][0] = $baseurl.'?context=note&id='.$this->id;
// 			$head[$h][1] = $langs->trans("Card");
// 			$head[$h][2] = 'test12';
// 			$h++;
			
			if(in_array("generateDocument", class_implements($this))) {
				$head[$h][0] = $baseurl.'?context=attachedfile&id='.$this->id;
				$head[$h][1] = $langs->trans("Attachedfile");
				$head[$h][2] = 'attachedfile';
				$h++;
			}
			
			$head[$h][0] = $baseurl.'?context=agenda&id='.$this->id;
			$head[$h][1] = $langs->trans("Agenda");
			$head[$h][2] = 'agenda';
			$h++;


			// Show more tabs from modules
			complete_head_from_modules($conf, $langs, $this, $head, $h, $this->element);
			
        }
        
        return $head;
    }
    
    
   
    
	/**
	 * Update object into database
	 *
	 * @param  User $user      User that modifies
	 * @param  bool $notrigger false=launch triggers after, true=disable triggers
	 * @return int             <0 if KO, >0 if OK
	 */
	public function update(User $user, $notrigger = false)
	{
		return $this->updateCommon($user, $notrigger);
	}
	/**
	 * Delete object in database
	 *
	 * @param User $user       User that deletes
	 * @param bool $notrigger  false=launch triggers after, true=disable triggers
	 * @return int             <0 if KO, >0 if OK
	 */
	public function delete(User $user, $notrigger = false)
	{
		return $this->deleteCommon($user, $notrigger);
	}
	
	//public function doScheduledJob($param1, $param2, ...)
	public function doScheduledJob()
	{
		global $conf, $langs;
		//$conf->global->SYSLOG_FILE = 'DOL_DATA_ROOT/dolibarr_mydedicatedlofile.log';
		$error = 0;
		$this->output = '';
		$this->error='';
		dol_syslog(__METHOD__, LOG_DEBUG);
		$now = dol_now();
		$this->db->begin();
		// ...
		$this->db->commit();
		return $error;
	}
    
	/**
	 *	Charge les informations d'ordre info dans l'objet commande
	 *
	 *	@param  int		$id       Id of order
	 *	@return	void
	 */
	function info($id)
	{
		$sql = 'SELECT rowid, date_creation as datec, tms as datem,';
		$sql.= ' fk_user_creat, fk_user_modif';
		$sql.= ' FROM '.MAIN_DB_PREFIX.$this->table_element.' as t';
		$sql.= ' WHERE t.rowid = '.$id;
		$result=$this->db->query($sql);
		if ($result)
		{
			if ($this->db->num_rows($result))
			{
				$obj = $this->db->fetch_object($result);
				$this->id = $obj->rowid;
				if ($obj->fk_user_author)
				{
					$cuser = new User($this->db);
					$cuser->fetch($obj->fk_user_author);
					$this->user_creation   = $cuser;
				}
				if ($obj->fk_user_valid)
				{
					$vuser = new User($this->db);
					$vuser->fetch($obj->fk_user_valid);
					$this->user_validation = $vuser;
				}
				if ($obj->fk_user_cloture)
				{
					$cluser = new User($this->db);
					$cluser->fetch($obj->fk_user_cloture);
					$this->user_cloture   = $cluser;
				}
				$this->date_creation     = $this->db->jdate($obj->datec);
				$this->date_modification = $this->db->jdate($obj->datem);
				$this->date_validation   = $this->db->jdate($obj->datev);
			}
			$this->db->free($result);
		}
		else
		{
			dol_print_error($this->db);
		}
	}
    /**
     *  Retourne le libelle du status d'un user (actif, inactif)
     *
     *  @param	int		$mode          0=libelle long, 1=libelle court, 2=Picto + Libelle court, 3=Picto, 4=Picto + Libelle long, 5=Libelle court + Picto
     *  @return	string 			       Label of status
     */
    function getLibStatut($mode = 0)
    {
		if(isset($this->fields['status'])) 
			return $this->LibStatut($this->status, $mode);
		else 
			return $this->LibStatut($this->statut, $mode);
    }

    /**
     * Initialise object with example values
     * Id must be 0 if object instance is a specimen
     *
     * @return void
     */
    public function initAsSpecimen()
    {
        $this->initAsSpecimenCommon();
    }

    public function __destruct()
    {
        // already done ?
        //$this->db->close();
    }

    	/**
	 *  Create an intervention document on disk using template defined into QUALITYREPORT_ADDON_PDF
	 *
	 *  @param	string		$modele			Force template to use ('' by default)
	 *  @param	Translate	$outputlangs	Objet lang to use for translation
	 *  @param  int			$hidedetails    Hide details of lines
	 *  @param  int			$hidedesc       Hide description
	 *  @param  int			$hideref        Hide ref
	 *  @return int         				0 if KO, 1 if OK
	 */
	public function generateDocument($modele, $outputlangs, $hidedetails=0, $hidedesc=0, $hideref=0)
	{
		global $conf,$langs;

		if(!in_array("generateDocument", class_implements($this)))
			return ''; 
		$langs->load($this->element.'@'.$this->element);

		// Positionne modele sur le nom du modele de object a utiliser
		if (! dol_strlen($modele))
		{
            $key = strtoupper($this->element).'_ADDON_PDF';
			if (! empty($conf->global->$key))
			{
				$modele = $conf->global->$key;
			}
			else
			{
				$modele='';
			}
		}

		$modelpath = "core/modules/".$this->element."/doc/";

		return $this->commonGenerateDocument($modelpath, $modele, $outputlangs, $hidedetails, $hidedesc, $hideref);
	}
	
	
}







/**
 * Description of object
 *
 * @author Oscss Shop <support@oscss-shop.fr>
 */
class CommonObjectMVC 
	extends CommonObject
{

	/**
		@remark Call depend of trait 
	*/
	use SupportMVC;
    use CommonObjectView;
    use CommonObjectControler;
    
    
    public $arrayofjs      = array();
    public $arrayofcss     = array();
    public $Card           = 'task.php';
    public $DefaultAction  = 'view';
    public $DefaultContext = 'card';
    public $List           = 'list.php';

    function __construct($db)
    {
        global $langs;
        
		$this->init();
    }



}