<?php
/* Copyright (C) 2004-2017 Laurent Destailleur  <eldy@users.sourceforge.net>
 * Copyright (C) 2017 Mikael Carlavan <contact@mika-carl.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 *  \file       htdocs/poidstotal/class/actions_poidstotal.class.php
 *  \ingroup    poidstotal
 *  \brief      File of class to manage actions on propal
 */
require_once DOL_DOCUMENT_ROOT.'/core/class/commonobject.class.php';
require_once DOL_DOCUMENT_ROOT.'/product/class/product.class.php';
require_once DOL_DOCUMENT_ROOT .'/core/lib/product.lib.php';

if ($conf->soustotal->enabled)
{
	dol_include_once("/soustotal/class/soustotal.class.php");
}

class ActionsPoidsTotal
{ 

	function printObjectLineTitle($parameters, &$object, &$action, $hookmanager)
	{
		global $langs, $db, $mysoc, $conf;
		
		$langs->load('poidstotal@poidstotal');
	
		if ($action != 'editline')
		{
			$lines = $object->lines;

			for ($i = 0; $i < sizeof($lines); $i++)
			{
				$line = $lines[$i];

				if ($line->product_type == 0)
				{
					if ($line->fk_product > 0)
					{
					 	$product = new Product($db);
					 	$result = $product->fetch($line->fk_product);

						if ($result > 0)
						{
							if ($product->weight <= 0)
							{
								$object->lines[$i]->product_label .= ' '.img_picto($langs->trans('ProductWeightIsNotSet'),'no_weight.png@poidstotal');						
							}
		    			}
					}
					else
					{
						//pour les produits libres
												
						if($object->lines[$i]->array_options['options_poidsproduct']<=0){
							if ($conf->soustotal->enabled)
							{
								if (SousTotal::isTitleOrSubTotalOrFree($object->lines[$i])) {
									continue;
								}
							}
							
							if (empty($object->lines[$i]->label))
							{
								$object->lines[$i]->description .= ' '.img_picto($langs->trans('ProductWeightIsNotSet'),'no_weight.png@poidstotal');
							}
							else
							{
								$object->lines[$i]->label .= ' '.img_picto($langs->trans('ProductWeightIsNotSet'),'no_weight.png@poidstotal');
							}
						}
						

					}

	    		}
	    	}					
		}
		

		$this->resprints = '';
		return 0;		
	}

    function addMoreActionsButtons($parameters, &$object, &$action, $hookmanager)
    {
        global $langs, $db, $mysoc, $conf, $user;

        $langs->load('poidstotal@poidstotal');

        ?>
        <script type="text/javascript">
            $(document).ready(function(){
                $("tr.<?php echo $object->table_element_line; ?>_extras_poidsproduct").hide();
                $("#prod_entry_mode_free").change(function(){
                    if ($(this).is(':checked')) {
                        $("tr.<?php echo $object->table_element_line; ?>_extras_poidsproduct").show();
                    } else {
                        $("tr.<?php echo $object->table_element_line; ?>_extras_poidsproduct").hide();
                    }
                });
            });
        </script>
        <?php

        $this->resprints = '';
        return 0;
    }


	//hook lors de la création du produit pour ajouter un champ de poids
	/*function formCreateProductOptions($parameters, &$object, &$action, $hookmanager)
	{
		global $langs, $db, $mysoc, $conf, $user;
				
		$form = new Form($db);
		print '<span>';
		print '<label>&nbsp;'.$langs->trans("PoidsProduct").'</label>&nbsp;';
		print '<input name="poidsproduct" size="4">';
     
		print '</span>';			

		$this->resprints = '';
		return 0;		
	}
	
	
	//hook lors de l'édition de la ligne du produit pour ajouter un champ de poids
	function formEditProductOptions($parameters, &$object, &$action, $hookmanager)
	{
		global $langs, $db, $mysoc, $conf, $user;

		//on récupère la clé parente de la ligne car ici object c'est la propale
		$lineid=GETPOST('lineid');
		foreach($object->lines as $key => $value) {
			if($value->id==$lineid) {
    		$pkey=$key;
    		}
		}
		
		
		if(empty($object->lines[$pkey]->fk_product)){//que pour les produits libres
										
		print '<span>';
		print '<label>&nbsp;'.$langs->trans("PoidsProduct").'</label>&nbsp;';
		print '<input name="poidsproduct" size="10" value="'.$object->lines[$pkey]->array_options['options_poidsproduct'].'">';
		print '</span>';			
		}
		$this->resprints = '';
		
		return 0;		
	}
	*/

}


