<?php
/* Copyright (C) 2011-2016 Laurent Destailleur  <eldy@users.sourceforge.net>
 *
 * Licensed under the GNU GPL v3 or higher (See file gpl-3.0.html)
 */

/**
 *       \file       htdocs/google/gmaps_all.php
 *       \ingroup    google
 *       \brief      Page to show a map
 *       \author     Laurent Destailleur
 */

$res=0;
if (! $res && file_exists("../main.inc.php")) $res=@include("../main.inc.php");
if (! $res && file_exists("../../main.inc.php")) $res=@include("../../main.inc.php");
if (! $res && file_exists("../../../main.inc.php")) $res=@include("../../../main.inc.php");
if (! $res && @file_exists("../../../../main.inc.php")) $res=@include("../../../../main.inc.php");
if (! $res && @file_exists("../../../../../main.inc.php")) $res=@include("../../../../../main.inc.php");
if (! $res && preg_match('/\/(?:custom|nltechno)([^\/]*)\//',$_SERVER["PHP_SELF"],$reg)) $res=@include("../../../dolibarr".$reg[1]."/htdocs/main.inc.php"); // Used on dev env only
if (! $res) die("Include of main fails");
require_once(DOL_DOCUMENT_ROOT."/core/lib/company.lib.php");
require_once(DOL_DOCUMENT_ROOT."/core/lib/contact.lib.php");
require_once(DOL_DOCUMENT_ROOT."/core/lib/member.lib.php");
require_once(DOL_DOCUMENT_ROOT."/core/class/html.formother.class.php");
require_once(DOL_DOCUMENT_ROOT."/core/class/html.formcompany.class.php");
require_once(DOL_DOCUMENT_ROOT."/contact/class/contact.class.php");
//dol_include_once("/google/class/googlemaps.class.php");
dol_include_once("/aproximite/include/GoogleMapAPIv3.class.php");

require_once DOL_DOCUMENT_ROOT.'/core/class/extrafields.class.php';
include_once(DOL_DOCUMENT_ROOT.'/societe/class/societe.class.php');

$langs->load("aproximite@aproximite");
$langs->load("categories");

$adderrors = array();

if (GETPOST('action') == 'geo') {
    // on lance la phase de geocoding en masse
    include_once __DIR__ . '/include/geocode_all.php';
}

$mode = 'thirdparty';

$socid = GETPOST('rowid','int');

llxheader();

if (!empty($socid)) {

$object = new Societe($db);
$object->id = $socid;
$object->fetch($socid);

if ($object->array_options['options_lat_prox'] === NULL || $object->array_options['options_long_prox'] === NULL) {
    $object->update($socid);
}

if ($object->array_options['options_lat_prox'] !== NULL && $object->array_options['options_long_prox'] !== NULL) {

$latSoc = $object->array_options['options_lat_prox'];
$longSoc = $object->array_options['options_long_prox'];

$address = $object->getFullAddress(1,', ');
$url = $object->url;

$societe = $object;

$form=new Form($db);
$formother = new FormOther($db);
$formcompany = new FormCompany($db);

$content = "Default content";
$act = "";

//On fabrique les onglets
$head=array();
$title='';
$picto='';
$type='';


if ($user->societe_id) $socid=$user->societe_id;

$search_sale=GETPOST('search_sale');
$search_type=GETPOST('search_type');
$search_action=GETPOST('search_action');
$search_categ_cus=GETPOST('search_categ_cus');

$title=$langs->trans("AProximmite");
$picto='company';
$type='company';

$sql="SELECT s.*, e.lat_prox, e.long_prox "
        . "FROM ".MAIN_DB_PREFIX."societe as s ";

if ($search_action) {
    switch ($search_action) {
        case 'bill' : 
            $sql.=" INNER JOIN ".MAIN_DB_PREFIX."facture as f ON s.rowid = f.fk_soc";
            break;
        case 'propal' : 
            $sql.=" INNER JOIN ".MAIN_DB_PREFIX."propal as p ON s.rowid = p.fk_soc";
            break;
        case 'order' : 
            $sql.=" INNER JOIN ".MAIN_DB_PREFIX."commande as o ON s.rowid = o.fk_soc";
            break;
    }
}

if ($search_categ_cus) {
        
    $sql.=" INNER JOIN ".MAIN_DB_PREFIX."categorie_societe as cs ON s.rowid = cs.fk_soc";
}

if ($search_sale || (!$user->rights->societe->client->voir && ! $socid)) $sql.= "INNER JOIN ".MAIN_DB_PREFIX."societe_commerciaux as sc ON sc.fk_soc = s.rowid";
$sql.=" INNER JOIN ".MAIN_DB_PREFIX."societe_extrafields as e ON s.rowid = e.fk_object
WHERE e.lat_prox IS NOT NULL AND e.long_prox IS NOT NULL AND s.rowid !=" .$socid . ' AND s.entity = ' . $conf->entity;
if ($search_sale || (!$user->rights->societe->client->voir && ! $socid)) {
    $userParam = $search_sale ? $search_sale : $user->id;
    $sql.= " AND sc.fk_user = " . $userParam;
}
if ($search_type > 0 && in_array($search_type,array('1,3','2,3'))) $sql .= " AND s.client IN (".$db->escape($search_type).")";
if ($search_type > 0 && in_array($search_type,array('4')))         $sql .= " AND s.fournisseur = 1";

if ($search_action) {
    switch ($search_action) {
        case 'bill' : 
            $sql.=" AND f.fk_statut = 1";
            break;
        case 'propal' : 
            $sql.=" AND p.fk_statut != 2";
            break;
        case 'order' : 
            $sql.=" AND o.fk_statut != 3";
            break;
    }
}

if ($search_categ_cus) {
        
    $sql.=" AND cs.fk_categorie = " . $search_categ_cus;
}

print_fiche_titre($title);

dol_fiche_head(array(), 'gmaps', '', 0);


    	$langs->load("commercial");
    	print '<form name="formsearch" method="POST" action="'.$_SERVER["PHP_SELF"].'?rowid='.$socid.'">';
    	
    	print $langs->trans('ThirdPartiesOfSaleRepresentative'). ': ';
    	print $formother->select_salesrepresentatives($search_sale,'search_sale',$user, 0, 1, 'maxwidth300');

		print ' &nbsp; &nbsp; &nbsp; ';
		print $langs->trans("CustomersCategoriesShort").': ';
		 print '<select class="flat" name="search_type">';
                print '<option value="-1"'.($search_type==''?' selected':'').'>&nbsp;</option>';
                if (empty($conf->global->SOCIETE_DISABLE_CUSTOMERS)) print '<option value="1,3"'.($search_type=='1,3'?' selected':'').'>'.$langs->trans('Customer').'</option>';
                if (empty($conf->global->SOCIETE_DISABLE_PROSPECTS)) print '<option value="2,3"'.($search_type=='2,3'?' selected':'').'>'.$langs->trans('Prospect').'</option>';
                print '<option value="4"'.($search_type=='4'?' selected':'').'>'.$langs->trans('Supplier').'</option>';
                print '<option value="0"'.($search_type=='0'?' selected':'').'>'.$langs->trans('Others').'</option>';
                print '</select>';

    		print ' &nbsp; &nbsp; &nbsp; ';
    		print $langs->trans("ActionInProgress").': ';
    		print '<select class="flat" name="search_action">';
                print '<option value="-1"'.($search_action==''?' selected':'').'>&nbsp;</option>';
                print '<option value="propal"'.($search_action=='propal'?' selected':'').'>'.$langs->trans('PropalInProgress').'</option>';
                print '<option value="order"'.($search_action=='order'?' selected':'').'>'.$langs->trans('OrderInProgress').'</option>';
                print '<option value="bill"'.($search_action=='bill'?' selected':'').'>'.$langs->trans('BillUnpaid').'</option>';
                print '</select>';
                
                print ' &nbsp; &nbsp; &nbsp; ';
                
                if (! empty($conf->categorie->enabled))
                {
                    require_once DOL_DOCUMENT_ROOT . '/categories/class/categorie.class.php';
                    
                    print $langs->trans('CustomersProspectsCategoriesShort').': ';
                    print $formother->select_categories('customer',$search_categ_cus,'search_categ_cus',1);
                }
		
    	print ' &nbsp; &nbsp; &nbsp; ';
    	
		print ' <input type="submit" name="submit_search_sale" value="'.$langs->trans("Search").'" class="button"> &nbsp; &nbsp; &nbsp; ';
    	print '</form>';


        print '<br/><br/>';
        
// Fill array of contacts
$addresses = array();
$countgeoencoding=0;
$countgeoencodedok=0;
$countgeoencodedall=0;

// Loop
$resql=$db->query($sql);
if ($resql)
{
	$num=$db->num_rows($resql);
	$i=0;
	while ($i < $num)
	{
		$obj=$db->fetch_object($resql);
		if (empty($obj->country_code)) $obj->country_code=$mysoc->country_code;

		$error='';

		$addresstosearch=dol_format_address($obj,1," ");
		$address=dol_format_address($obj,1,", ");	// address to show

		$object=new stdClass();
		$object->id=$obj->rowid;
		$object->name=$obj->name?$obj->name:($obj->nom);
		$object->latitude = $obj->lat_prox;
		$object->longitude = $obj->long_prox;
		$object->address = $address;
		$object->url = $obj->url;
		$object->email = $obj->email;
		$object->phone = $obj->phone;

		if (! $error)
		{
			$addresses[]=$object;
		}

		$i++;
	}

}
else
{
	dol_print_error($db);
}

$gmap = new GoogleMapAPI();
$gmap->setDivId('test1');
$gmap->setDirectionDivId('route');
$gmap->setEnableWindowZoom(true);
$gmap->setEnableAutomaticCenterZoom(false);
$gmap->setDisplayDirectionFields($langs->trans("GEOCODEMISSING",dol_buildpath('/aproximite/aproximite.php?rowid='.GETPOST('rowid').'&action=geo', 1)), null, 'warnings');
$gmap->setClusterer(1);                  // For high number or record, we should use clusterer
$gmap->setSize('100%','500px');
$gmap->setZoom($conf->global->GOOGLE_GMAPS_ZOOM_LEVEL);
$gmap->setLang($user->lang);
$gmap->setDefaultHideMarker(false);
$gmap->setDefaultCenter($latSoc, $longSoc);

// Convert array of addresses into the output gmap string
$gmap->addArrayMarker($addresses, $langs, $mode);

// Marker central
$addresscleaned = dol_string_nospecial(dol_format_address($societe,1,", "),', ',array("\r\n","\n","\r"));
$substitjs=array("&#039;"=>"\\'",'\\'=>'\\\\',"\r"=>'\\r',"\n"=>'\\n');
//$substitjs['</']='<\/';	// We removed this. Should be useless.
if (empty($mode)) { $substitjs["'"]="\\'"; $substitjs['"']="\\'"; }
else if ($mode == 1) $substitjs["'"]="\\'";
else if ($mode == 2) { $substitjs['"']='\\"'; }
$addresscleaned = strtr($addresscleaned, $substitjs);
$html='';
$pagename=(((float) DOL_VERSION >= 6.0)?'/societe/card.php':'/societe/soc.php');
$html.= '<a href="'.DOL_URL_ROOT.$pagename.'?socid='.$societe->id.'">';
$html.= '<b>'.$societe->name.'</b>';
$html.= '</a>';
$html.= '<br/>'.$addresscleaned.'<br/>';
$urlforlink=$societe->url;
if (! preg_match('/^http/i',$urlforlink)) $urlforlink='http://'.$urlforlink;
if (! empty($societe->url)) $html.= '<a href="'.$urlforlink.'">'.$societe->url.'</a><br/>';
if (! empty($societe->phone)) $html.= $societe->phone.'<br/>';
if (! empty($societe->email)) $html.= $societe->email.'<br/>';
$gmap->addMarkerByCoords($latSoc, $longSoc, $societe->name, $html, '', 'https://maps.google.com/mapfiles/ms/icons/blue-dot.png');
$gmap->addCircle($latSoc, $longSoc, $conf->global->PROXIMITE_RESEARCH_RADIUS, '#6292e0');


$gmap->generate();
echo $gmap->getGoogleMap();


dol_fiche_end();


// If no addresses
if (count($addresses) == 0 && count($adderrors) == 0) print $langs->trans("NoAddressDefined").'<br><br>';


// Show errorsetEventMessages($langs->trans("GEOCODEMISSING",dol_buildpath('/aproximite/aproximite.php?rowid='.GETPOST('rowid').'&action=geo', 1)), null, 'warnings');
if (count($adderrors))
{
	$objectstatic=new Societe($db);

	print $langs->trans("FollowingAddressCantBeLocalized",count($adderrors)).':<br>'."\n";
	foreach($adderrors as $object)
	{
		$objectstatic->id=$object->rowid;
		$objectstatic->rowid=$object->rowid;
		$objectstatic->socid=$object->rowid;
		$objectstatic->name=$object->nom;	// Here $object is an array an 'name' is already a formatted string with firstname and lastname
		$objectstatic->nom=$object->nom;	// Here $object is an array an 'name' is already a formatted string with firstname and lastname
		$objectstatic->ref=$object->nom;	// Here $object is an array an 'name' is already a formatted string with firstname and lastname
		print $langs->trans("Name").": ".$objectstatic->getNomUrl(1).", ".$langs->trans("Address").": ".$object->address." -> ".$object->error." (error code = ".$object->error_code.")<br>\n";
	}
}


if (GETPOST('action') != 'geo' && count($adderrors) == 0) {

    // on cherche si il existe des entrées incomplètes
    $sql="SELECT s.* FROM ".MAIN_DB_PREFIX."societe as s 
    LEFT JOIN ".MAIN_DB_PREFIX."societe_extrafields as e ON s.rowid = e.fk_object
    WHERE (e.lat_prox IS NULL OR e.long_prox IS NULL) AND s.entity = " .$conf->entity;

    $resql=$db->query($sql);
    if ($resql)
    {

        $num=$db->num_rows($resql);

        if ($num > 0) {
            setEventMessages($langs->trans("GEOCODEMISSING",dol_buildpath('/aproximite/aproximite.php?rowid='.GETPOST('rowid').'&action=geo', 1)), null, 'warnings');
        }
    }

}
} else {
    print $langs->trans("SocLatLngEmpty"); 
} 

} else {
    setEventMessages($langs->trans("SocidEmpty"), null, 'errors');
}

llxfooter();

$db->close();

