<?php
/* Copyright (C) 2018	Grégory Blémand	<gregory.blemand@atm-consulting.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 *  \file       cliacobal/customref.php
 *  \brief      Page to show product custom reference
 */

include "config.php";
require_once DOL_DOCUMENT_ROOT.'/product/class/product.class.php';
require_once DOL_DOCUMENT_ROOT.'/core/lib/product.lib.php';

require_once DOL_DOCUMENT_ROOT.'/core/lib/company.lib.php';

$langs->load("companies");
$langs->load("products");
$langs->load("other");

$id=GETPOST('id', 'int');
$socid=GETPOST('socid', 'int');
$product_id=GETPOST('productid', 'int');
$ref=GETPOST('ref', 'alpha');
$customref=GETPOST('customref', 'alpha');
$cr_id=GETPOST('cr_id', 'int');
$tab=GETPOST('tab', 'alpha');
$action=(GETPOST('action','alpha') ? GETPOST('action','alpha') : 'view');

if (($id > 0 || ! empty($ref)) && $tab == "product")
{
    $object = new Product($db);
    $result = $object->fetch($id, $ref);
    
    if (! empty($conf->product->enabled)) $upload_dir = $conf->product->multidir_output[$object->entity].'/'.get_exdir(0, 0, 0, 0, $object, 'product').dol_sanitizeFileName($object->ref);
    elseif (! empty($conf->service->enabled)) $upload_dir = $conf->service->multidir_output[$object->entity].'/'.get_exdir(0, 0, 0, 0, $object, 'product').dol_sanitizeFileName($object->ref);
    
    if (! empty($conf->global->PRODUCT_USE_OLD_PATH_FOR_PHOTO))    // For backward compatiblity, we scan also old dirs
    {
        if (! empty($conf->product->enabled)) $upload_dirold = $conf->product->multidir_output[$object->entity].'/'.substr(substr("000".$object->id, -2),1,1).'/'.substr(substr("000".$object->id, -2),0,1).'/'.$object->id."/photos";
        else $upload_dirold = $conf->service->multidir_output[$object->entity].'/'.substr(substr("000".$object->id, -2),1,1).'/'.substr(substr("000".$object->id, -2),0,1).'/'.$object->id."/photos";
    }
}
elseif (($id > 0 || ! empty($ref)) && $tab == "thirdparty")
{
    $object = new Societe($db);
    $result = $object->fetch($id, $ref);
    
    if (! empty($conf->product->enabled)) $upload_dir = $conf->product->multidir_output[$object->entity].'/'.get_exdir(0, 0, 0, 0, $object, 'product').dol_sanitizeFileName($object->ref);
    elseif (! empty($conf->service->enabled)) $upload_dir = $conf->service->multidir_output[$object->entity].'/'.get_exdir(0, 0, 0, 0, $object, 'product').dol_sanitizeFileName($object->ref);
    
    if (! empty($conf->global->PRODUCT_USE_OLD_PATH_FOR_PHOTO))    // For backward compatiblity, we scan also old dirs
    {
        if (! empty($conf->product->enabled)) $upload_dirold = $conf->product->multidir_output[$object->entity].'/'.substr(substr("000".$object->id, -2),1,1).'/'.substr(substr("000".$object->id, -2),0,1).'/'.$object->id."/photos";
        else $upload_dirold = $conf->service->multidir_output[$object->entity].'/'.substr(substr("000".$object->id, -2),1,1).'/'.substr(substr("000".$object->id, -2),0,1).'/'.$object->id."/photos";
    }
}

$modulepart='product';

/*
 * Actions
 */

switch ($action)
{
    case "addref":
        if(empty($customref))
        {
            setEventMessage('Erreur : référence vide', 'errors');
        }
        else 
        {
            if(!empty($socid) && $socid !== -1) // tab product
            {
                $sql_test = "SELECT count(rowid) as num FROM ".MAIN_DB_PREFIX."custom_product_ref WHERE fk_soc='".$socid."' AND fk_product='".$id."'";
                $res_test = $db->query($sql_test);
                
                $obj = $db->fetch_object($res_test);
                
//                 var_dump($socid, $customref);
                if(empty($obj->num)){
                    $sql_add = "INSERT INTO ".MAIN_DB_PREFIX."custom_product_ref (`rowid`, `fk_soc`, `fk_product`, `ref`) VALUES (NULL, '".$socid."', '".$id."', '".$customref."')";
                    $resadd = $db->query($sql_add);
                    if (!$resadd) 
                        setEventMessage('Erreur : ajout ref impossible - '.$db->lasterror, 'errors');
                    else 
                        setEventMessage('Succés : référence enregistrée', 'mesgs');
                } else setEventMessage('Erreur : référence déjà existante', 'errors');
            } 
            elseif (!empty($product_id) && $product_id !== -1) // tab thirdparty
            {
                $sql_test = "SELECT count(rowid) as num FROM ".MAIN_DB_PREFIX."custom_product_ref WHERE fk_soc='".$id."' AND fk_product='".$product_id."'";
                $res_test = $db->query($sql_test);
                
                $obj = $db->fetch_object($res_test);
                
//                 var_dump($socid, $customref);
                if(empty($obj->num)){
                    $sql_add = "INSERT INTO ".MAIN_DB_PREFIX."custom_product_ref (`rowid`, `fk_soc`, `fk_product`, `ref`) VALUES (NULL, '".$id."', '".$product_id."', '".$customref."')";
                    $resadd = $db->query($sql_add);
                    if (!$resadd)
                        setEventMessage('Erreur : ajout ref impossible - '.$db->lasterror, 'errors');
                    else
                        setEventMessage('Succés : référence enregistrée', 'mesgs');
                } else setEventMessage('Erreur : référence déjà existante', 'errors');
            }
        }
        
        break;
        
    case "updateref":
        //                 var_dump($socid, $customref);
        $sql_add = "UPDATE ".MAIN_DB_PREFIX."custom_product_ref SET ref='".$customref."' WHERE rowid=".$cr_id;
        $resadd = $db->query($sql_add);
        if (!$resadd)
            setEventMessage('Erreur : ajout ref impossible - '.$db->lasterror, 'errors');
        else
            setEventMessage('Succés : référence enregistrée', 'mesgs');
        break;
    
    case "delref":
        $sql_del = "DELETE FROM ".MAIN_DB_PREFIX."custom_product_ref WHERE rowid=".$cr_id;
        $resdel = $db->query($sql_del);
        if($resdel) 
            setEventMessage('Succés : référence personnalisée supprimée', 'mesgs');
        else 
            setEventMessage('Erreur : référence non-supprimée', 'errors');
        break;
}


/*
 * View
 */

// fetch records
$num = 0;
if (($id > 0 || ! empty($ref)) && $tab == "product")
{
    $sql = "SELECT rowid, fk_soc as id, ref FROM ".MAIN_DB_PREFIX."custom_product_ref WHERE fk_product = ".$id;
}
elseif (($id > 0 || ! empty($ref)) && $tab == "thirdparty")
{
    $sql = "SELECT rowid, fk_product as id, ref FROM ".MAIN_DB_PREFIX."custom_product_ref WHERE fk_soc = ".$id;
}
$resql = $db->query($sql);
if (!$resql) setEventMessage('Erreur de récupération des références : '.$db->lasterror, 'errors');
else $num = $db->num_rows($resql);

$form = new Form($db);

$title = $langs->trans('ProductServiceCard');
$helpurl = '';
$shortlabel = dol_trunc($object->label,16);
if (GETPOST("type") == '0' || ($object->type == Product::TYPE_PRODUCT))
{
    $title = $langs->trans('Product')." ". $shortlabel ." - ".$langs->trans('Card');
    $helpurl='EN:Module_Products|FR:Module_Produits|ES:M&oacute;dulo_Productos';
}
if (GETPOST("type") == '1' || ($object->type == Product::TYPE_SERVICE))
{
    $title = $langs->trans('Service')." ". $shortlabel ." - ".$langs->trans('Card');
    $helpurl='EN:Module_Services_En|FR:Module_Services|ES:M&oacute;dulo_Servicios';
}
if ($tab == "thirdparty")
{
    $title = "Références produits client";
    $helpurl="";
}

llxHeader('', $title, $helpurl);

if ($tab == "product") 
{
    $head=product_prepare_head($object);
    $titre=$langs->trans("CardProduct".$object->type);
    $picto=($object->type== Product::TYPE_SERVICE?'service':'product');
    dol_fiche_head($head, 'tabCustomRef', $titre, 0, $picto);
    
    $linkback = '<a href="'.DOL_URL_ROOT.'/product/list.php?restore_lastsearch_values=1&type='.$object->type.'">'.$langs->trans("BackToList").'</a>';
    $object->next_prev_filter=" fk_product_type = ".$object->type;
    
    $shownav = 1;
    if ($user->societe_id && ! in_array('product', explode(',',$conf->global->MAIN_MODULES_FOR_EXTERNAL))) $shownav=0;
    
    dol_banner_tab($object, 'tab=product&ref', $linkback, $shownav, 'ref');
    
}
else 
{
    $head=societe_prepare_head($object);
    $titre=$langs->trans("ThirdParty");
    dol_fiche_head($head, 'tabCustomRef', $titre, 0, 'company');
    
    $linkback = '<a href="'.DOL_URL_ROOT.'/societe/list.php?restore_lastsearch_values=1">'.$langs->trans("BackToList").'</a>';
    
    dol_banner_tab($object, 'tab=thirdparty&id', $linkback, ($user->societe_id?0:1), 'rowid', 'nom');
}

print '<div class="fichecenter">';

// Form to add a new line
print '<form action="'.$_SERVER['PHP_SELF'].'?tab='.$tab.'&id='.$object->id.'" method="POST">';
print '<input type="hidden" name="token" value="'.$_SESSION['newtoken'].'">';
print '<input type="hidden" name="action" value="addref">';

print '<div class="div-table-responsive-no-min">';
print '<table class="noborder" width="100%">';

// Line for title
print '<tr class="liste_titre">';
print ($tab == "product") ? '<td class="width100">'.$langs->trans('ThirdParty').'</td>' : '<td class="width100">'.$langs->trans('Product').'</td>';
print '<td>'.$langs->trans('CustomRef').'</td><td></td>';
print '</tr>';

print '<!-- line to add new entry --><tr class="oddeven nodrag nodrop nohover">';
print '<td class="width100">';
if ($tab == "product") {
    print $form->select_company('', 'socid');
} else {
    print $form->select_produits('', 'productid', '', 20, 0, 1, 2, '', 1);
}
print '</td>';
print '<td><input type="text" class="flat quatrevingtpercent" value="" name="customref"></td>';
print '<td align="center"><input type="submit" class="button" name="actionadd" value="'.$langs->trans('Add').'"></td>';
print '</tr>';

print '</table></div></form>';

print_fiche_titre($langs->trans('CustomRef'));

// List of available record in database
print '<div class="div-table-responsive-no-min">';
print '<table class="noborder" width="100%">';

print '<tr class="liste_titre">';
print ($tab == "product") ? '<td class="width100">'.$langs->trans('ThirdParty').'</td>' : '<td class="width100">'.$langs->trans('Product').'</td>';
print '<td>'.$langs->trans('CustomRef').'</td><td></td>';
print '</tr>';

// loop on records
if (empty($num))
{
    print '<tr><td colspan="3" align="center">Aucune référence personnalisée à afficher</td></tr>';
}
else 
{
    while ($obj = $db->fetch_object($resql))
    {
        if ($tab == "product") $objStatic = new Societe($db);
        else $objStatic = new Product($db);
        $objStatic->fetch($obj->id);
        print '<tr>';
        print '<form action="'.$_SERVER['PHP_SELF'].'?tab='.$tab.'&id='.$object->id.'" method="POST">';
        print '<input type="hidden" name="token" value="'.$_SESSION['newtoken'].'">';
        print '<input type="hidden" name="action" value="updateref">';
        print '<input type="hidden" name="cr_id" value="'.$obj->rowid.'">';
        print '<td>'.$objStatic->getNomUrl(1).'</td>';
        print '<td><input type="text" class="flat quatrevingtpercent" value="'.$obj->ref.'" name="customref"></td>';
        print '<td><input type="submit" class="button" name="actionupdate" value="'.$langs->trans('Modify').'">&nbsp;<a href="'.$_SERVER['PHP_SELF'].'?tab='.$tab.'&id='.$object->id.'&action=delref&cr_id='.$obj->rowid.'">'.img_delete("supprimer").'</a></td>';
        print '</form></tr>';
    }
}

print '</table></div>';

print '</div>';




llxFooter();
$db->close();
