<?php
/* Copyright (C) 2006-2012	Laurent Destailleur	<eldy@users.sourceforge.net>
 * Copyright (C) 2009-2012	Regis Houssin		<regis.houssin@capnetworks.com>
 * Copyright (C) 2012      Christophe Battarel  <christophe.battarel@altairis.fr>
 * Copyright (C) 2012-2016 Juanjo Menent		<jmenent@2byte.es>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 * or see http://www.gnu.org/
 */

/**
 * \file htdocs/core/modules/import/import_csv.modules.php
 * \ingroup import
 * \brief File to load import files with CSV format
 */
require_once DOL_DOCUMENT_ROOT . '/core/modules/import/import_xlsx.modules.php';

/**
 * Class to import Excel files
 */
class ImportXlsxCustom extends ImportXlsx
{

	/**
	 * Return array of next record in input file.
	 *
	 * @return Array Array of field values. Data are UTF8 encoded. [fieldpos] => (['val']=>val, ['type']=>-1=null,0=blank,1=not empty string)
	 */
	/*function import_read_record($only_value=true) {
		global $conf;

		$rowcount = $this->workbook->getActiveSheet()->getHighestDataRow();
		if ($this->record > $rowcount)
			return false;
		$array = array();
		$colcount = PHPExcel_Cell::columnIndexFromString($this->workbook->getActiveSheet()->getHighestDataColumn(0));
		for($col = 0; $col < $colcount; $col ++) {

			$cell = $this->workbook->getActiveSheet()->getCellByColumnAndRow($col, $this->record);
			if (PHPExcel_Shared_Date::isDateTime($cell)) {
				$cellValue = $cell->getValue();
				$dateValue = PHPExcel_Shared_Date::ExcelToPHP($cellValue);
				$cellValue = date('Y-m-d', $dateValue). ' 12:00:00';
			} else {
				$cellValue = trim($cell->getValue());
			}

			if ($only_value)
			{
				$array[$col] = $cellValue;
			}
			else
			{
				$array[$col]['val'] = $cellValue;
				$array[$col]['type'] = (dol_strlen($val) ? 1 : - 1); // If empty we consider it null
			}
		}
		$this->record ++;
		return $array;
	}*/
	
	function import_read_record($only_value=true)
	{
		global $conf;

		$rowcount = $this->workbook->getActiveSheet()->getHighestDataRow();
		if($this->record > $rowcount)
			return false;
		$array = array();
		$colcount = PHPExcel_Cell::columnIndexFromString($this->workbook->getActiveSheet()->getHighestDataColumn(0));
		for($col=0;$col<$colcount;$col++) {
			$val = $this->workbook->getActiveSheet()->getCellByColumnAndRow($col, $this->record)->getValue();
			if ($only_value)
			{
				$array[$col] = $val;
			}
			else
			{
				$array[$col]['val'] = $val;
				$array[$col]['type'] = (dol_strlen($val)?1:-1); // If empty we consider it null
			}
		}
		$this->record++;
		return $array;
	}
}
