<?php

//ini_set('memory_limit','-1');
ini_set('max_file_size','10M');
ini_set('display_errors',true);
ini_set('auto_detect_line_endings', true);
//set_time_limit(0);

require_once DOL_DOCUMENT_ROOT.'/societe/class/societe.class.php';
require_once DOL_DOCUMENT_ROOT.'/contact/class/contact.class.php';
require_once DOL_DOCUMENT_ROOT.'/comm/action/class/actioncomm.class.php';
require_once DOL_DOCUMENT_ROOT.'/core/class/extrafields.class.php';
dol_include_once('/importatm/class/import_xlsx_custom.modules.php');

/**
 * Permet de forcer la définition des méthodes devant être écritent dans chaque enfant
 */
interface TImportatmInterface
{
	function getTField();
	function checkFieldsObject($object, $TParam=array());
}


class TImportatm extends TObjetStd
{	
	public $TSociete = array();
	public $errors;
	
	public $fk_user_author;
	public $entity;
	public $fk_importatm_schema;
	public $nb_lines;
	public $nb_errors;
	public $nb_create;
	public $nb_update;
	public $type_import;
	public $filename;
	public $data_brut;
	
	public $TData;
	
	public static $TFieldIgnored = array('rowid', 'id', 'datec', 'tms', 'entity', 'import_key', 'logo', 'default_lang', 'fk_user_creat', 'fk_user_modif', 'customer_bad', 'customer_rate', 'supplier_rate',
										 'outstanding_limit', 'prefix_comm', 'location_incoterms', 'fk_user_action', 'fk_user_author', 'fk_user_done', 'fk_user_mod', 'photo'
										);
	public static function getTypeObjectToImport()
	{
		global $langs;
		
		// La clé doit être le nom de class de l'objet en question (sera utilisée dans getInstance() )
		return array(
			'Societe' => $langs->trans('ThirdParty')
			,'Contact' => $langs->trans('Contact')
			,'ActionComm' => $langs->trans('Module2400Name')
		);
	}
	
	public function __construct()
	{
		parent::__construct();
		
		parent::set_table(MAIN_DB_PREFIX.'importatm');
		
		parent::add_champs('fk_user_author,entity,fk_importatm_schema', array('type' => 'integer'));
		parent::add_champs('nb_lines,nb_errors,nb_create,nb_update', array('type' => 'integer'));
		parent::add_champs('type_import,filename', array('type' => 'string'));
		// Contient uniquement les lignes importées du fichier (ce qui veut dire que ce n'est pas forcément la totalité du fichier d'origine)
		parent::add_champs('data_brut', array('type' => 'text')); // stockage en serialize + gzdeflate (voir gzinflate pour décompresser)
		
		$this->setChild('TImportatmSchema','fk_importatm_schema');
		
		parent::start();
		parent::_init_vars();
	}
	
	public function getInstance($type_object)
	{
		$class_name = 'TImportatm'.$type_object;
		return new $class_name(); // Génèrera une Fatal si la class n'existe pas et c'est voulu
	}
	
	public function initData($data)
	{
		$this->TData = unserialize(base64_decode($data));
		$this->nb_lines = count($this->TData);
	}
	
	private function doCreate(&$object)
	{
		global $user;
		
		if ($object->create($user) > 0) $this->nb_create++;
		else $this->nb_errors++;
	}
	
	private function doUpdate(&$object)
	{
		global $user;
		
		if($object->element == 'action') $res = $object->update($user);
		else $res = $object->update($object->id, $user); // WARNING Works with Societe and Contact object (check for other)
		
		if ($res > 0) $this->nb_update++;
		else $this->nb_errors++;
	}
	
	private function loadObject(&$object, &$TCol, &$TField, $line_index, $TKey_to_update)
	{
		global $db;
		
		if (empty($TKey_to_update)) return 0;
		
		$str_id = 'rowid';
		if($object->element == 'action') $str_id = 'id';
		
		$sql = 'SELECT '.$str_id.' as id FROM '.MAIN_DB_PREFIX.$object->table_element.' WHERE 1';
		foreach($TKey_to_update as $key)
		{
			// Ne doit y avoir dans la requete que les champs de la table cible (les champs "externe" sont utilisés pour faire de la recherche dans des tables 
			if (!empty($key) && !$this->isExternalField($key) && ($key_index = array_search($key, $TCol)) !== false)
			{
				$value = $this->TData[$line_index][$key_index];
				if (!empty($TField[$key]['eval'])) 
				{
					$value = eval('return '.$TField[$key]['eval'].';');
				}
				$sql .= ' AND '.$key.' = \''.$db->escape($value).'\'';
			}
		}

		$sql.= ' LIMIT 1';
//echo $sql;exit;
		
		$resql = $db->query($sql);
		if ($resql)
		{
			$result = $db->fetch_object($resql);
			if ($result)
			{
				$object->fetch($result->id);
			}
		}
		else
		{
			$this->errors[] = $db->lasterror();
			return -1;
		}
		
		return $object->id;
	}
	
	public function importData(&$PDOdb, $TLineToImport, $TCol, $filename, $type_object, $TKey_to_update=array(), $fk_importatm_schema=0, $TUserId=array(), $simulate=true)
	{
		global $db,$user,$conf;

		$this->fk_user_author = $user->id;
		$this->entity = $conf->entity;
		$this->fk_importatm_schema = $fk_importatm_schema;
		$this->filename = $filename;
		$this->type_import = $type_object;
		
		$class_name = ucfirst($type_object);
		
		$TField = $this->getTField();

		$db->begin();
		$this->TDataSelected = array();
		foreach ($TLineToImport as $line_index)
		{
			$this->TDataSelected[] = $this->TData[$line_index];
			$object = new $class_name($db); // Societe, Contact, ActionComm, ...

			// Try to fetch object or do nothing
			$this->loadObject($object, $TCol, $TField, $line_index, $TKey_to_update);

			$TVal = array(); // Passage pas un tableau intermédiaire pour palier ua problème des champs à concaténer lors d'un update d'objet
			foreach ($TCol as $data_index => $attr)
			{
				if (empty($attr) || $attr == -1) continue;
				
				$attr_obj = !empty($TField[$attr]['substitution_name']) ? $TField[$attr]['substitution_name'] : $attr;
				$value = $this->TData[$line_index][$data_index];
				
				if (!empty($TField[$attr]['eval'])) 
				{
					$value = eval('return '.$TField[$attr]['eval'].';');
				}
					
				if (!empty($this->TFieldConcatChar[$attr_obj]) && !empty($TVal[$attr_obj])) $TVal[$attr_obj] .= $this->TFieldConcatChar[$attr_obj].$value;
				else $TVal[$attr_obj] = $value;
			}
			
			foreach ($TVal as $attr => $val)
			{
				$object->{$attr} = $val;
			}


			// Check or set default values
			if ($this->checkFieldsObject($object, array('TUserId' => $TUserId)))
			{
				// TODO ligne en erreur à logger pour plus de détail
				// TODO 2 refactore and move into method to test the object and use correctly the create() or update()
				if (empty($object->id))
				{
					$this->doCreate($object);
				}
				else
				{
					$this->doUpdate($object);
				}
			}
			else
			{
				$this->nb_errors++;
			}
			
//			unset($this->TData[$line_index]); // Free memory // problème de référence
		}
		
		$this->TData = $this->TDataSelected;
		$this->nb_lines = count($this->TData);

		if ($simulate)
		{
			$db->rollback();
		}
		else
		{
			$db->commit();
			$this->save($PDOdb);
		}
		
	}
	
	protected function camelize($input, $separator = '_')
	{
		return str_replace($separator, '', ucwords($input, $separator));
	}
	
	protected function formatField($input)
	{
		return $this->camelize(str_replace('fk_', '', $input));
	}
	
	protected function addFields($TTable)
	{
		global $db,$langs;
		
		$Tab = array();
		$Tab[-1] = array('label' => '');
		
		foreach($TTable as $table)
		{
			$resql = $db->query('SHOW COLUMNS FROM '.MAIN_DB_PREFIX.$table);
			while ($col = $db->fetch_object($resql))
			{
				if (in_array($col->Field, TImportatm::$TFieldIgnored)) continue;
				// if (!empty($TField[$attr]['substitution_name'])) $object->{$TField[$attr]['substitution_name']} = $this->TData[$line_index][$data_index];
				$Tab[$col->Field] = array('label' => $langs->transnoentities($this->formatField($col->Field)), 'info' => '('.$table.'::'.$col->Type.' - '.$col->Field.')' );
			}
		}
		
		return $Tab;
	}
	
	private function open($file)
	{
		global $db;
		
		$info = pathinfo($file['name']);
		$this->type_import = $info['extension'];
		
		if ($this->type_import == 'xlsx')
		{
			dol_include_once('/importatm/class/import_xlsx_custom.modules.php');
			$handle = new ImportXlsxCustom($db, 'importatm');

			$handle->import_open_file($file['tmp_name']);
//			$importfile->record = 2; // to ignore any lines
		}
		else // csv
		{
			$handle = fopen($file['tmp_name'], 'r');
		}
		
		return $handle;
	}
	
	private function close(&$handle)
	{
		if ($this->type_import == 'xlsx') $handle->import_close_file();
		else fclose($handle);
	}
	
	private function getNextRecord(&$handle)
	{
		if ($this->type_import == 'xlsx') $data = $handle->import_read_record();
		else $data = fgetcsv($handle);
		
		if (is_array($data))
		{
			$data = array_map(array($this, 'force_utf8'), $data);
			$data = array_map('trim', $data);
		}
		
		return $data;
	}
	
	/**
	 * Ouvre le fichier et transpose le contenu dans un tableau
	 * 
	 * @global type $langs
	 * @param type $file
	 * @return type
	 */
	public function readFile($file)
	{
		global $langs;
		
		$this->TData = array();
		
		if (!empty($file['error']))
		{
			$this->errors[] = $langs->trans('error_uploadfile_return_error', $file['name'], $file['error']);
			return -1;
		}
		
		$handle = $this->open($file);
		if (!$handle)
		{
			$this->errors[] = $langs->trans('error_cant_open_file', $file['name']);
			return -2;
		}
		
		while ($data = $this->getNextRecord($handle))
		{
			$this->TData[] = $data;
		}
		
		$this->close($handle);
		
		$this->nb_lines = count($this->TData);
		return $this->nb_lines;
	}
	
	protected function sortByLabel($a, $b)
	{
		$cmp = strcmp($a['label'], $b['label']);
		if ($cmp < 0) return -1;
		elseif ($cmp > 0) return 1;
		return 0;
	}
	
	public function getTUsableKeyToUpdate()
	{
		$TUsableKeys = array('' => '');
		
		foreach($this->TField as $key => &$Tab)
		{
			if (!empty($Tab['is_key_to_update']) && $Tab['is_key_to_update'] === true)
			{
				$TUsableKeys[$key] = $Tab['label'].' '.$Tab['info'];
			}
		}

		return $TUsableKeys;
	}
	
	public function isExternalField($attr)
	{
		return isset($this->TField[$attr]['is_external']) ? $this->TField[$attr]['is_external'] : false;
	}
	
	/**
	 * Check for UTF-8 compatibility
	 *
	 * Regex from Martin Dürst
	 * @source http://www.w3.org/International/questions/qa-forms-utf-8.en.php
	 * @param string $str String to check
	 * @return boolean
	 */
	protected function is_utf8($str)
	{
		return preg_match("/^(
			 [\x09\x0A\x0D\x20-\x7E]            # ASCII
		   | [\xC2-\xDF][\x80-\xBF]             # non-overlong 2-byte
		   |  \xE0[\xA0-\xBF][\x80-\xBF]        # excluding overlongs
		   | [\xE1-\xEC\xEE\xEF][\x80-\xBF]{2}  # straight 3-byte
		   |  \xED[\x80-\x9F][\x80-\xBF]        # excluding surrogates
		   |  \xF0[\x90-\xBF][\x80-\xBF]{2}     # planes 1-3
		   | [\xF1-\xF3][\x80-\xBF]{3}          # planes 4-15
		   |  \xF4[\x80-\x8F][\x80-\xBF]{2}     # plane 16
		  )*$/x", $str
		);
	}
	
	/**
	 * Try to convert a string to UTF-8.
	 *
	 * @author Thomas Scholz <http://toscho.de>
	 * @param string $str String to encode
	 * @param string $inputEnc Maybe the source encoding. 
	 *               Set to NULL if you are not sure. iconv() will fail then.
	 * @return string
	 */
	protected function force_utf8($str, $inputEnc = 'WINDOWS-1252')
	{
		if ($this->is_utf8($str)) // Nothing to do.
			return $str;
		if (strtoupper($inputEnc) === 'ISO-8859-1')
			return utf8_encode($str);
		if (function_exists('mb_convert_encoding'))
			return mb_convert_encoding($str, 'UTF-8', $inputEnc);
		if (function_exists('iconv'))
			return iconv($inputEnc, 'UTF-8', $str);
		// You could also just return the original string.
		trigger_error(
			'Cannot convert string to UTF-8 in file '
			.__FILE__.', line '.__LINE__.'!', E_USER_WARNING
		);
	}
	
	
	protected function getSocieteId($key, $line_index, $TCol, $name)
	{
		// Si la colonne contient déjà le fk_soc alors je le retourne immédiatement
		if (is_numeric($name)) return $name;
		
		if (empty($this->TSociete)) $this->loadTSociete();
		
		$array_search_values = array('nom' => strtolower($name));
		
		$data = $this->TData[$line_index];
		
		$TExternalKey = $this->getExternalKey();
		
		foreach ($TExternalKey as $subKey => $TInfo)
		{
			if (!empty($TInfo['linked_to']) && $TInfo['linked_to'] === $key && ($key_index = array_search($subKey, $TCol)) !== false)
			{
				if (substr($subKey, 0, 3) == 'ex.') $subKey = substr($subKey, 3);
				$array_search_values[$subKey] = $data[$key_index];
			}
		}
		
		$result = array_filter($this->TSociete, function($obj) use ($array_search_values) {
			$res = true;
			foreach ($array_search_values as $attr => $val)
			{
				if ($obj->{$attr} != $val)
				{
					
					$res = false;
					break;
				}
			}
			
			return $res;
		});
		
		if (!empty($result))
		{
			$obj = current($result);
			return $obj->rowid;
		}
		else return 0;
	}
	
	private function loadTSociete()
	{
		global $db;
		
		$TField = array();
		
		$sql = 'DESC '.MAIN_DB_PREFIX.'societe';
		$resql = $db->query($sql);
		
		if ($resql)
		{
			while ($obj = $db->fetch_object($resql))
			{
				$TField[] = $obj->Field;
			}
		}
		else
		{
			dol_print_error($db);
		}
		
		$sql = 'SELECT '.implode(',', $TField).' FROM '.MAIN_DB_PREFIX.'societe';
		$resql = $db->query($sql);
		if ($resql)
		{
			while ($obj = $db->fetch_object($resql))
			{
//				$this->TSociete[strtolower($obj->nom)] = $obj->rowid;
				$obj->nom = strtolower($obj->nom);
				$this->TSociete[$obj->rowid] = $obj;
			}
		}
		else
		{
			dol_print_error($db);
		}
	}
	
	/**
	 * 
	 * @param type $value format d'exemple d/m/Y
	 */
	protected function getTimestamp($value)
	{
		// Check if already timestamp (xlsx)
		if (is_numeric($value) && (int)$value == $value) return $value;
		
//		$format_from = 'd/m/Y';
		$value = str_replace('/', '-', $value); // @see PHP doc : http://php.net/manual/fr/function.strtotime.php => Les dates aux formats m/d/y ou d-m-y sont analysées en regardant le séparateur entre les différentes parties : si le séparateur est un slash (/), alors le format américain m/d/y est supposé ; si le séparateur est un tiret (-) ou un point (.), alors le format Européen d-m-y sera supposé. Si toutefois l'année est fournie sur deux digits, et que le séparateur est un tiret (-), la date sera analysée comme étant au format y-m-d. 
		
		return strtotime($value);
	}
}

//TODO implémenter
class TImportatmSchema extends TObjetStd
{
	public $entity;
	public $name;
	public $type_object;
	public $schema_import;
	
	public function __construct()
	{
		parent::__construct();
		
		parent::set_table(MAIN_DB_PREFIX.'importatm_schema');
		
		parent::add_champs('entity', array('type' => 'integer'));
		parent::add_champs('name,type_object', array('type' => 'string'));
		parent::add_champs('schema_import', array('type' => 'text')); // stockage en json_encode
		
		parent::start();
		parent::_init_vars();
	}
}


class TImportatmSociete extends TImportatm implements TImportatmInterface
{
	public $TFieldConcatChar = array('address' => "\n");
	
	public $TField;
	
	function __construct()
	{
		parent::__construct();
		$this->getTField();
	}
	
	public function getTField()
	{
		global $db,$langs;
		
		$TTable = array('societe');
		$Tab = $this->addFields($TTable);
		
		// Required
		$Tab['nom']['fieldrequired'] = true;
		
		// Key available to update row in database
		// TODO: Ajouter des clés pour la mise à jour ici !
		$Tab['nom']['is_key_to_update'] = true;
		$Tab['zip']['is_key_to_update'] = true;
		$Tab['tva_intra']['is_key_to_update'] = true;
		$Tab['code_client']['is_key_to_update'] = true;
		$Tab['code_fournisseur']['is_key_to_update'] = true;
		
		// Substitution des noms d'attribut - à utiliser si le nom de l'attribut de l'objet n'est pas le même qu'en base de données (WARNING pas touche à la clé)
		// TODO: Ajouter les substitutions manquantes ici !
		$Tab['nom']['substitution_name'] = 'name';
		
		// Traductions
		$Tab['barcode']['label'] = $langs->trans('BarCode');
		$Tab['fk_multicurrency']['label'] = $langs->trans('MultiCurrency');
		$Tab['name_alias']['label'] = $langs->trans('AliasNames');
		$Tab['idprof4']['label'] = $langs->trans('ProfId4');
		$Tab['idprof5']['label'] = $langs->trans('ProfId5');
		$Tab['idprof6']['label'] = $langs->trans('ProfId6');
		$Tab['fk_prospectlevel']['label'] = $langs->trans('ProspectLevel');
		$Tab['tva_assuj']['label'] = $langs->trans('VATIsUsed');
		$Tab['tva_intra']['label'] = $langs->trans('VATIntra');
		$Tab['code_client']['label'] = $langs->trans('CustomerCode');
		$Tab['code_fournisseur']['label'] = $langs->trans('SupplierCode');
		$Tab['fk_forme_juridique']['label'] = $langs->trans('JuridicalStatus');
		$Tab['mode_reglement']['label'] = $langs->trans('PaymentMode');
		
		uasort($Tab, array($this, 'sortByLabel'));
		
		// 'conf'
		
		// 'eval'

		$societe = new Societe($db);
		$extrafields = new ExtraFields($db);
		$extralabels=$extrafields->fetch_name_optionals_label($societe->table_element);
		foreach ($extralabels as $key => $label)
		{
			$Tab['options_'.$key] = array('label' => $label.' (extrafields)', 'fieldrequired' => $extrafields->attribute_required[$key], 'cond' => '', 'eval' => '');
		}
	
		$this->TField = $Tab;
		return $Tab;
	}
	
	public function checkFieldsObject($object, $TParam=array())
	{
		if (empty($object->country_id)) $object->country_id = 1; // France par défaut
		if (!empty($TParam['TUserId']))
		{
			// Sur un create, la method 'add_commercial' est déclanché mais pas sur update (donc non modificable pour le moment)
			$object->commercial_id = $TParam['TUserId'][0];
			// TODO voir si on test si l'object a un id pour faire manuellement appel à la method
		}
		
		return true;
	}
}

class TImportatmContact extends TImportatm implements TImportatmInterface
{
	public $TFieldConcatChar = array('address' => "\n");
	
	public $TField;
	
	function __construct()
	{
		parent::__construct();
		$this->getTField();
	}
	
	public function getTField()
	{
		global $db, $langs;
		
		$TTable = array('socpeople');
		$Tab = $this->addFields($TTable);
	
		// Required
		$Tab['lastname']['fieldrequired'] = true;
		
		// Key available to update row in database
		// TODO: Ajouter des clés pour la mise à jour ici !
		$Tab['lastname']['is_key_to_update'] = true;
		$Tab['firstname']['is_key_to_update'] = true;
		$Tab['fk_soc']['is_key_to_update'] = true;
		
		// Substitution des noms d'attribut - à utiliser si le nom de l'attribut de l'objet n'est pas le même qu'en base de données (WARNING pas touche à la clé)
		// TODO: Ajouter les substitutions manquantes ici !
		$Tab['fk_soc']['substitution_name'] = 'socid';
		$Tab['civility']['substitution_name'] = 'civility_id';
		$Tab['phone']['substitution_name'] = 'phone_pro';
		
		uasort($Tab, array($this, 'sortByLabel'));
		
		// Traductions
		$Tab['fk_soc']['label'] = $langs->trans('Company');

		// 'conf'
		
		// 'eval'
		$Tab['fk_soc']['eval'] = '$this->getSocieteId($key, $line_index, $TCol, $value)';
		
		$contact = new Contact($db);
		$extrafields = new ExtraFields($db);
		$extralabels=$extrafields->fetch_name_optionals_label($contact->table_element);
		foreach ($extralabels as $key => $label)
		{
			$Tab['options_'.$key] = array('label' => $label.' (extrafields)', 'fieldrequired' => $extrafields->attribute_required[$key], 'cond' => '', 'eval' => '');
		}
	
		$Tab += $this->getExternalKey();
		
		$this->TField = $Tab;
		return $Tab;
	}
	
	/**
	 * Contenu qui pourrait être intégré dans getTField(), mais ceci permet de bien sépararer intellecuellement les champs natif qui seront
	 * utilisés pour importer les données et ceux qui ne sont là que pour les clés de mise à jour
	 * 
	 * @return array
	 */
	public function getExternalKey()
	{
		$Tab = array();
		
		$Tab['ex.zip']['label'] = '[EX] Societe - code postal';
		$Tab['ex.code_client']['label'] = '[EX] Societe - code_client';
		$Tab['ex.code_fournisseur']['label'] = '[EX] Societe - code_fournisseur';

		$Tab['ex.zip']['is_key_to_update'] = true;
		$Tab['ex.code_client']['is_key_to_update'] = true;
		$Tab['ex.code_fournisseur']['is_key_to_update'] = true;

		$Tab['ex.zip']['is_external'] = true;
		$Tab['ex.code_client']['is_external'] = true;
		$Tab['ex.code_fournisseur']['is_external'] = true;

		$Tab['ex.zip']['linked_to'] = 'fk_soc';
		$Tab['ex.code_client']['linked_to'] = 'fk_soc';
		$Tab['ex.code_fournisseur']['linked_to'] = 'fk_soc';
		
		return $Tab;
	}
	
	public function checkFieldsObject($object, $TParam=array())
	{
		if (empty($object->country_id)) $object->country_id = 1; // France par défaut
		
		return true;
	}
}

class TImportatmActionComm extends TImportatm implements TImportatmInterface
{
	public $TFieldConcatChar = array('note' => "\n");
	
	public $TField;
	
	function __construct()
	{
		parent::__construct();
		$this->getTField();
	}
	
	public function getTField()
	{
		global $db,$langs;
		
		$TTable = array('actioncomm');
		$Tab = $this->addFields($TTable);
		
		// Required
		$Tab['code']['fieldrequired'] = true;
		
		// Key available to update row in database
		// TODO: Ajouter des clés pour la mise à jour ici !
		$Tab['label']['is_key_to_update'] = true;
		
		// Substitution des noms d'attribut - à utiliser si le nom de l'attribut de l'objet n'est pas le même qu'en base de données (WARNING pas touche à la clé)
		// TODO: Ajouter les substitutions manquantes ici !
		$Tab['code']['substitution_name'] = 'type_code';
		$Tab['datep2']['substitution_name'] = 'datef';
		$Tab['fk_action']['substitution_name'] = 'type_id';
		$Tab['fk_soc']['substitution_name'] = 'socid';
		$Tab['fk_contact']['substitution_name'] = 'contactid';
		$Tab['percent']['substitution_name'] = 'percentage';
		
		uasort($Tab, array($this, 'sortByLabel'));
		
		// Traductions
		$Tab['fk_soc']['label'] = $langs->trans('Company');
		$Tab['datep']['label'] = $langs->trans('DateStart');
		$Tab['datep2']['label'] = $langs->trans('DateEnd');
		
		// 'conf'
		
		// 'eval'
		$Tab['fk_soc']['eval'] = '$this->getSocieteId($key, $line_index, $TCol, $value)';
		$Tab['datep']['eval'] = '$this->getTimestamp($value)';
		$Tab['datep2']['eval'] = '$this->getTimestamp($value)';
		
		$actionComm = new ActionComm($db);
		$extrafields = new ExtraFields($db);
		$extralabels=$extrafields->fetch_name_optionals_label($actionComm->table_element);
		foreach ($extralabels as $key => $label)
		{
			$Tab['options_'.$key] = array('label' => $label.' (extrafields)', 'fieldrequired' => $extrafields->attribute_required[$key], 'cond' => '', 'eval' => '');
		}
		
		$this->TField = $Tab;
		return $Tab;
	}

	public function checkFieldsObject($object, $TParam=array())
	{
		global $user;
		
		if (empty($object->datep)) return false; // Date début obligatoire
		elseif (empty($object->type_code)) return false; // Type event obligatoire
		elseif (empty($object->label)) return false; // Libellé obligatoire
		
		if (empty($object->percentage) && $object->percentage !== 0) $object->percentage = -1;
		if (empty($object->userownerid)) 
		{
			// TODO à faire évoluer car il s'agit d'un tableau donc plusieurs participants
			if (!empty($TParam['TUserId']) && !empty($TParam['TUserId'][0])) $object->userownerid = $TParam['TUserId'][0];
			else $object->userownerid = $user->id;
		}
		
		return true;
	}
}