<?php
set_time_limit(0);
ini_set("memory_limit","1024M");

require('config.php');
require_once DOL_DOCUMENT_ROOT.'/core/lib/product.lib.php';
dol_include_once('/importatm/class/importatm.class.php');
dol_include_once('/importatm/class/import_xlsx_custom.module.php');
dol_include_once('/product/stock/class/entrepot.class.php');
dol_include_once('/product/class/product.class.php');
dol_include_once('/compta/facture/class/facture.class.php');
dol_include_once('/societe/class/societe.class.php');
dol_include_once('/importatm/lib/importatm.lib.php');

$action = GETPOST('action', 'alpha');
$step = GETPOST('step', 'int');
$file = !empty($_FILES['file']['tmp_name']) ? $_FILES['file']['tmp_name'] : GETPOST('file');
$filename = $_FILES['file']['name'];

$Tunits = array('U' => 1, 'ML' => 9, 'KG' => 6);

// Etape 0 : envoi du fichier
if(empty($step))
{
    llxHeader('', 'import de facturation');
    
    $head = importatm_prepare_head($object);
    $picto = 'generic';
    dol_fiche_head($head, 'facturation', $langs->trans("Importatm"), 0, $picto);
    
    $form = new TFormCore('auto', 'formImport', 'post', true);
    echo $form->hidden('action','import');
    echo $form->hidden('step', '1');
    
    print_titre('Envoi du fichier d\'import');
    
    echo $form->fichier('Fichier à importer', 'file', '', 50);
    echo $form->btsubmit('importer', 'bt_preview');
}

// Etape 1 : Vérification des produits à créer (clé "ref")
if($step == "1")
{
    $file = DOL_DATA_ROOT.'/diff.csv';
    if(!empty($file))
    {
        global $db;
        
        llxHeader('', 'modif facture');
        
        $head = importatm_prepare_head($object);
        $picto = 'generic';
        dol_fiche_head($head, 'facturation', $langs->trans("Importatm"), 0, $picto);
        //$db->begin();
        // chargement des fichiers
        // fichier de diff
        $diff = fopen($file,'r') or die('Fichier illisible');
        
        // csv2
//         $csv2 = fopen(DOL_DATA_ROOT.'/csv2.csv', "r") or die('Fichier pas créé');
        
        // csv3
//         $csv3 = fopen(DOL_DATA_ROOT.'/csv3.csv', "r") or die('Fichier pas créé');
        
        // fichier des lignes trouvées
        //$output = fopen(DOL_DATA_ROOT.'/output.csv', "w") or die('Fichier pas créé');
        $NOKCegid = fopen(DOL_DATA_ROOT.'/nok_cegid.csv', "w") or die('Fichier pas créé');
        $NOKDoli = fopen(DOL_DATA_ROOT.'/nok_doli.csv', "w") or die('Fichier pas créé');
        $NOK = fopen(DOL_DATA_ROOT.'/nok.csv', "w") or die('Fichier pas créé');
        
        $errors = array();
        $TFactures = array();
        $TLignesFact = array();
        $TLignesFactErr = array();
        $lineMAJ = $lineErr = $factMAJ = $factAdd = $factErr = $i = 0;
        $lastfact = '';
        
        $i = 0;
        while($ligne = fgetcsv($diff,4096,';', '"') ) {
            if ($i <= 1) {
                print_outputdiff($NOKCegid, $ligne);
                print_outputdiff($NOKDoli, $ligne);
                print_outputdiff($NOK, $ligne);
            }
            if ($i > 1)
            {
                $ref_ext = $ligne[1];
                if(substr($ref_ext, 0, 1) == "0") $ref_ext = substr($ref_ext, 1);
                
                $CADoli = str_replace(",", "", trim($ligne[2]));
                $CACegid = str_replace(",", "", trim($ligne[3]));
                $diffCA = str_replace(",", "", trim($ligne[4]));
                
                if($diffCA !== '0.00' && !empty($ref_ext)) {
                    $output = $NOK;
                    if (empty($CADoli)) $output = $NOKDoli;
                    elseif (empty($CACegid)) $output = $NOKCegid;
                    
                    print_outputdiff($output, array());
                    print_outputdiff($output, $ligne);
                    

                    //var_dump($ref_ext);
                    // recherche de la ref_externe en bdd
		            $sql = 'SELECT rowid, facnumber, total FROM '.MAIN_DB_PREFIX.'facture WHERE ref_ext LIKE \'%'.$ref_ext.'%\'';
		            $res = $db->query($sql);

        		    if ($res)
        		    {
            			$num = $db->num_rows($res);
            			if ($num > 1)
            			{
            			    $facArray = array();
            			    while ($obj = $db->fetch_object($res)) { $facArray[$obj->rowid]['ref'] = $obj->facnumber; $facArray[$obj->rowid]['total'] = $obj->total;}
            			    $tmpligne = array("factures multiples en base de données");
            			    print_outputdiff($output, $tmpligne);
            
            			    foreach ($facArray as $id => $val)
            			    {
            				    $tmpligne = array($val['ref'], $val['total']);
                                print_outputdiff($output, $tmpligne);
            			    }
            			}
            			elseif (empty($num))
            			{
            			    $tmpligne = array("Pas de facture en bdd pour la ref $ref_ext");
            			    print_outputdiff($output, $tmpligne);
            			}
            			elseif ($num == 1)
            			{
            			    $obj = $db->fetch_object($res);
            
            			    // TODO Vérifier si le total HT correspond à l'attendu côté dolibarr
            			    // Récupérer les lignes de facture
            			    // vérifier si la somme des ligne est différente du total HT fac et si la diff correspond au diff attendu (en absolu)
            			    
            			    $fac = new Facture($db);
            			    $ret = $fac->fetch($obj->rowid);
            
                            $tmpligne = array("Facture", $obj->facnumber, price2num($obj->total));
                            print_outputdiff($output, $tmpligne);
                            
			    if (price2num($obj->total) == $CACegid)
			    {
				print_outputdiff($output, array('erreur arrondi corrigée'));
				continue;
			    }
                            $totalLines = 0;
            			    foreach ($fac->lines as $line)
            			    {
            				    $tmpligne = array("", $line->ref, price2num($line->total_ht));
            				    if (price2num($line->total_ht) == abs($diffCA)){
            				        $tmpligne[] = "";
            				        $tmpligne[] = "ligne probablement pas prise en compte";
            				    }
            				    $totalLines += price2num($line->total_ht);
                                print_outputdiff($output, $tmpligne);
            			    }
            			    
            			    if (price2num($totalLines) !== price2num($obj->total)) // problème de totaux différents
            			    {
            			        $tmpligne = array("différence entre le total facture est le total des lignes dans dolibarr");
            			        print_outputdiff($output, $tmpligne);
            			    }
            			    
            			    $found = search_in_file('csv1', $output, $ref_ext, $fac, $diffCA, $CADoli, $CACegid);
            			    $found1 = search_in_file('csv2', $output, $ref_ext, $fac, $diffCA, $CADoli, $CACegid);
            			    $found2 = search_in_file('csv3', $output, $ref_ext, $fac, $diffCA, $CADoli, $CACegid);
            			    if (!$found && !$found1 && !$found2){
            			        $l = array('ref facture non-trouvée');
            			        print_outputdiff($output, $l);
            			    }
            			}
        		    }
                }
            }
            $i++;
        }
        
//         print $lineMAJ . " lignes mises à jour<br>";
//         print $lineErr . " lignes en erreur<br>";
        print $i." lignes traitées";
        //$db->rollback();
    }
}

function print_outputdiff($ressource, $ligne)
{
    fputcsv( $ressource, $ligne, ";");
}

function search_in_file($file, $output, $ref_ext, &$facture, $diffCA, $CADoli, $CACegid)
{
    $f = fopen(DOL_DATA_ROOT.'/'.$file.'.csv', "r") or die('Fichier pas créé');

    if ($file == "csv1") $date = "du 27 juillet";
    if ($file == "csv2") $date = "du 3 septembre";
    if ($file == "csv3") $date = "du 12 septembre";
    $found = false;
    $totalLines = 0;
    $Tlines = array();
    while ($lcsv = fgetcsv($f,4096,';', '"'))
    {
        if ($lcsv[32] == $ref_ext) {
            if (!$found){
                print_outputdiff($output, array($file, $date));
            }
            print_outputdiff($output, array("", trim($lcsv[21]), $lcsv[18]));
            $Tlines[] = $lcsv;
            $totalLines += price2num($lcsv[18]);
            $found = true;
        }
    }
//     if ($totalLines == $CACegid)
//     {
//         print_outputdiff($output, array("erreur d'arrondis"));
        
        foreach ($facture->lines as $l)
        {
            
            foreach ($Tlines as $csvline)
            {
                if ($l->ref == trim($csvline[21]) && $l->total_ht == floatval($csvline[18])) // on est sur une erreur d'arrondi
                {
                    $facture->brouillon = 1;
                    $lineTotalHT = (float) utf8_encode(str_replace(',', '.', trim($csvline[18])));
                    $lineQte = (float) utf8_encode(str_replace(',', '.', trim($csvline[20])));
                    $linePUHT = (!empty($lineQte)) ? (float) round(($lineTotalHT / $lineQte), 5) : 0;
                    $linePR = (!empty($lineQte)) ? round(((float) utf8_encode(str_replace(',', '.', trim($csvline[19])))) / $lineQte, 5) : 0;
                    
                    // var_dump($l); exit;
                    $ret = $facture->updateline($l->id, $l->description, $linePUHT, $lineQte, $l->remise_percent, $l->date_start, $l->date_end, $l->tva_tx, $l->localtax1_tx, $l->localtax2_tx, 'HT', 0, $l->product_type, $l->fk_parent_line, 0, null, $linePR);
//                     if ($ret > 0) print_outputdiff($output, array("erreurs corrigée"));
                }
            }
        }
        
//     }
    fclose($f);
    
    return $found;
}
