<?php
set_time_limit(0);
ini_set("memory_limit","1024M");

require('config.php');
require_once DOL_DOCUMENT_ROOT.'/core/lib/product.lib.php';
dol_include_once('/importatm/class/importatm.class.php');
dol_include_once('/importatm/class/import_xlsx_custom.module.php');
dol_include_once('/product/stock/class/entrepot.class.php');
dol_include_once('/product/class/product.class.php');
dol_include_once('/compta/facture/class/facture.class.php');
dol_include_once('/societe/class/societe.class.php');
dol_include_once('/importatm/lib/importatm.lib.php');

$action = GETPOST('action', 'alpha');
$step = GETPOST('step', 'int');
$file = !empty($_FILES['file']['tmp_name']) ? $_FILES['file']['tmp_name'] : GETPOST('file');
$filename = $_FILES['file']['name'];

$Tunits = array('U' => 1, 'ML' => 9, 'KG' => 6);

// Etape 0 : envoi du fichier
if(empty($step))
{
    llxHeader('', 'import de facturation');
    
    $head = importatm_prepare_head($object);
    $picto = 'generic';
    dol_fiche_head($head, 'facturation', $langs->trans("Importatm"), 0, $picto);
    
    $form = new TFormCore('auto', 'formImport', 'post', true);
    echo $form->hidden('action','import');
    echo $form->hidden('step', '1');
    
    print_titre('Envoi du fichier d\'import');
    
    echo $form->fichier('Fichier à importer', 'file', '', 50);
    echo $form->btsubmit('importer', 'bt_preview');
}

if($step == "1")
{
    if(!empty($file))
    {
        global $db;
        
        llxHeader('', 'modif facture');
        
        $head = importatm_prepare_head($object);
        $picto = 'generic';
        dol_fiche_head($head, 'facturation', $langs->trans("Importatm"), 0, $picto);
        //$db->begin();
        // chargement du fichier
        $f1 = fopen($file,'r') or die('Fichier illisible');
        
        $errors = array();
        $TFactures = array();
        $TLignesFact = array();
        $TLignesFactErr = array();
        $lineMAJ = $lineErr = $factMAJ = $factAdd = $factErr = $i = 0;
        $lastfact = '';
        $dets = array();
//         $db->begin();
        while($ligne = fgetcsv($f1,4096,';', '"') ) {
            
            if($i > 0)
            {
                
                $fac = new Facture($db);
                $prod = new Product($db);
                // mapping fichier (factures et lignes de facture)
                //                 var_dump($ligne); exit;
                $factnum = utf8_encode(trim($ligne[32]));
                
                $lineTotalHT = (float) utf8_encode(trim($ligne[18]));
                $lineQte = (float) utf8_encode(trim($ligne[20]));
                $linePR = (!empty($lineQte)) ? ((float) utf8_encode(trim($ligne[19]))) / $lineQte : 0;
                $lineRef = utf8_encode(trim($ligne[21]));
                $lineDesc = utf8_encode(trim($ligne[22]));
                $linePUHT = (!empty($lineQte)) ? round((float) $lineTotalHT / $lineQte, 5) : 0;
                $assujetti = utf8_encode(trim($ligne[17]));
                $lineVat = (empty($assujetti)) ? 0 : 20;
                $lineTotalTva = ($lineTotalHT * $lineVat)/100;
                $lineTotalTTC = $lineTotalHT + $lineTotalTva;
                $linePUTTC = (!empty($lineQte)) ? $lineTotalTTC / $lineQte : 0;
                $prod->fetch(0, $lineRef);
                if (!in_array($prod->id . '-'.$lineQte.'-'.$linePUHT, $dets))
                {
                    $dets[] = $prod->id . '-'.$lineQte.'-'.$linePUHT;
                    
                    //$db->begin(); // phase test;
                    $sql = "SELECT * FROM llx_facturedet";
                    $sql.= " WHERE fk_product = " . $prod->id;
                    $sql.= " AND qty = " . $lineQte;
                    $sql.= " AND subprice = " . $linePUHT;
                    
                    $resql = $db->query($sql);
                    if ($resql && $db->num_rows($resql))
                    {
                        while ($obj = $db->fetch_object($resql))
                        {
                            $res = $fac->fetch($obj->fk_facture);
                            if ($res)
                            {
                                $fac->brouillon = 1;
                                $lineTotalHT = (float) utf8_encode(str_replace(',', '.', trim($ligne[18])));
                                $lineQte = (float) utf8_encode(str_replace(',', '.', trim($ligne[20])));
                                $linePUHT = (!empty($lineQte)) ? (float) round(($lineTotalHT / $lineQte), 5) : 0;
                                $assujetti = utf8_encode(trim($ligne[17]));
                                $lineVat = (empty($assujetti)) ? 0 : 20;
                                $linePR = (!empty($lineQte)) ? round(((float) utf8_encode(str_replace(',', '.', trim($ligne[19])))) / $lineQte, 5) : 0;
                                
                                if (
                                    $lineQte !== (float) $obj->qty
                                    || $lineTotalHT !== (float) $obj->total_ht
                                    || $linePUHT !== round((float) $obj->subprice, 5)
                                    )
                                {
                                
                                    $ret = $fac->updateline($obj->rowid, $obj->description, $linePUHT, $lineQte, $obj->remise_percent, $obj->date_start, $obj->date_end, $lineVat, $obj->localtax1_tx, $obj->localtax2_tx, 'HT', 0, $obj->product_type, $obj->fk_parent_line, 0, null, $linePR);
                                    
                                    if ($ret > 0) $lineMAJ++;
                                    else {
                                        $lineErr++;
                                        $TLignesFactErr[] = $obj->rowid . " - " . $fac->db->lasterror;
                                    }
                                }
                            }
                        }
                        
                    }
                    //$db->rollback();
                }
                
            }
            
            $i++;
        }
//         var_dump(count($dets), in_array('807-8000-0.17', $dets), $dets); exit;
//         $db->rollback();
        print $lineMAJ . " lignes mises à jour<br>";
        print $lineErr . " lignes en erreur<br>";
        print "sur ".$i." lignes";
        
        if (count($TLignesFactErr))
        {
            echo '<pre>';
            print_r( $TLignesFactErr);
        }
    }
}