<?php
set_time_limit(0);
ini_set("memory_limit","1024M");

require('config.php');
require_once DOL_DOCUMENT_ROOT.'/core/lib/product.lib.php';
dol_include_once('/importatm/class/importatm.class.php');
dol_include_once('/importatm/class/import_xlsx_custom.module.php');
dol_include_once('/product/stock/class/entrepot.class.php');
dol_include_once('/product/class/product.class.php');
dol_include_once('/compta/facture/class/facture.class.php');
dol_include_once('/societe/class/societe.class.php');
dol_include_once('/importatm/lib/importatm.lib.php');

$action = GETPOST('action', 'alpha');
$step = GETPOST('step', 'int');
$file = !empty($_FILES['file']['tmp_name']) ? $_FILES['file']['tmp_name'] : GETPOST('file');
$filename = $_FILES['file']['name'];

$Tunits = array('U' => 1, 'ML' => 9, 'KG' => 6);

// Etape 0 : envoi du fichier
if(empty($step))
{
    llxHeader('', 'import de facturation');
    
    $head = importatm_prepare_head($object);
    $picto = 'generic';
    dol_fiche_head($head, 'facturation', $langs->trans("Importatm"), 0, $picto);
    
    $form = new TFormCore('auto', 'formImport', 'post', true);
    echo $form->hidden('action','import');
    echo $form->hidden('step', '1');
    
    print_titre('Envoi du fichier d\'import');
    
    echo $form->fichier('Fichier à importer', 'file', '', 50);
    echo $form->btsubmit('importer', 'bt_preview');
}

// Etape 1 : Vérification des produits à créer (clé "ref")
if($step == "1")
{
    if(!empty($file))
    {
        $f1 = fopen($file,'r') or die('Fichier illisible');
        $ext = substr($filename, strrpos($filename, '.')+1);
        
        //var_dump($_FILES['f1']);
        if ($ext == "xls" || $ext == "xlsx")
        {
            require_once PHPEXCEL_PATH.'/PHPExcel/IOFactory.php';
            $excel = PHPExcel_IOFactory::load($file);
            $writer = PHPExcel_IOFactory::createWriter($excel, 'CSV');
            $writer->setDelimiter(";");
            $writer->setEnclosure("");
            $writer->save(DOL_DATA_ROOT.'/import.csv');
        }
        else move_uploaded_file($file, DOL_DATA_ROOT.'/import.csv');
        
        if(is_file(DOL_DATA_ROOT.'/import.csv')) {
            $file = DOL_DATA_ROOT.'/import.csv';
            $f1 = fopen($file,'r');
        }
        
        llxHeader('', 'import de produits');
        
        $head = importatm_prepare_head($object);
        $picto = 'generic';
        dol_fiche_head($head, 'facturation', $langs->trans("Importatm"), 0, $picto);
        
        // vérifier l'existance des extrafields
        require_once DOL_DOCUMENT_ROOT.'/core/class/extrafields.class.php';
        $extrafields = new ExtraFields($db);
        $target_extrafields=$extrafields->fetch_name_optionals_label('product');
        
        if(!in_array('Perimetre', $target_extrafields)) $res = $extrafields->addExtraField('perimetre', 'Perimetre', 'double', 0, '24,8', 'product',0,0,0,'', 1, '', 1);
        //if(!in_array('Laize', $target_extrafields)) $res = $extrafields->addExtraField('laize', 'Laize', 'double', 0, '24,8', 'product',0,0,0,'', 1, '', 1);
        if(!in_array('Epaisseur', $target_extrafields)) $res = $extrafields->addExtraField('epaisseur', 'Epaisseur', 'double', 0, '24,8', 'product',0,0,0,'', 1, '', 1);
        if(!in_array('Densité', $target_extrafields)) $res = $extrafields->addExtraField('densite', 'Densité', 'double', 0, '24,8', 'product',0,0,0,'', 1, '', 1);
        
        $target_extrafields=$extrafields->fetch_name_optionals_label('product');

        // chargement du fichier d'import
        
        $TArticles = array();
        $errors = array();
        $prodMAJ = $prodAdd = $prodErr = 0;
        $db->begin();
        $i = 0;
        while($ligne = fgetcsv($f1,4096,';', '"') ) {
            if($i > 0)
            {
                // Mapping du fichier (lignes produit)
                $ref = utf8_encode(trim($ligne[21]));
                $desc = utf8_encode(trim($ligne[22]));
                $cat = utf8_encode(trim($ligne[23]));
                $perimetre = utf8_encode(trim($ligne[24]));
                $laize = utf8_encode(trim($ligne[25]));
                $largeur = utf8_encode(trim($ligne[26]));
                $epaisseur = utf8_encode(trim($ligne[27]));
                $densite = str_replace(",",".", utf8_encode(trim($ligne[28])));
                $hauteur = utf8_encode(trim($ligne[29]));
                $poids = utf8_encode(trim($ligne[30])); // poids unitaire du produit
                
                if (empty($desc)) $desc = $ref;
                
                if (!in_array($ref, $TArticles)) // si pas déjà fait
                {
                    // cache des produits déjà fait
                    $TArticles[] = $ref;
                    
                    // fetch de chaque ref
                    $prod = new Product($db);
                    $ret = $prod->fetch(0, $ref);
                    
                    if($ret == 0){  // créer les produits manquants (avec gestion des lots)
                        $prod->ref = $ref;
                        $prod->label = $desc;
                        //$prod->fk_unit = $Tunits[$row['unit']];
                        $prod->status = 1;
                        $prod->status_buy = 1;
                        $prod->status_batch = 1;
                        $prod->type = 0;
                        $prod->import_key = 'imp_'.date("Ymd");
                        $prod->length = (float) $laize;
                        $prod->length_units = -3;
                        $prod->width = (float) $largeur;
                        $prod->width_units = -3;
                        $prod->height = (float) $hauteur;
                        $prod->height_units = -3;
                        $prod->weight = $poids;
                        $prod->weight_units = -3;
                        $prod->array_options['options_perimetre'] = (float) $perimetre;
                        //$prod->array_options['options_laize'] = (float) $laize;
                        $prod->array_options['options_epaisseur'] = (float) $epaisseur;
                        $prod->array_options['options_densite'] = (float) $densite;
                        
                        $res = $prod->create($user);
                        if($res < 0) {
                            $prodErr ++;
                            $errors[] = 'Produit '.$ref.' en erreur de création : ' . $db->lastqueryerror . ' - ' . $prod->error;
                        } else $prod->setCategories($cat);
                        //print ' créé<br>';
                        $prodAdd++;
                        } elseif($ret > 0) { // MAJ produits existant pour gestion des lots à 1
                            if(empty($prod->status_batch)) $prod->status_batch = 1;
                            // MAJ extrafields
                            $prod->array_options['options_perimetre'] = (float) $perimetre;
                            $prod->length = (float) $laize;
                            $prod->length_units = -3;
                            $prod->width = (float) $largeur;
                            $prod->width_units = -3;
                            $prod->height = (float) $hauteur;
                            $prod->height_units = -3;
                            $prod->weight = $poids;
                            $prod->weight_units = -3;
                            $prod->array_options['options_epaisseur'] = (float) $epaisseur;
                            $prod->array_options['options_densite'] = $densite;
                            $prod->update($prod->id, $user);
                            //print ' trouvé<br>';
                            $prodMAJ++;
                        } else {
                            $prodErr ++;
                            $errors[] = 'Produit '.$ref.' en erreur : ' . $db->lastqueryerror;
                        }
                }
//                                  var_dump($ligne); exit;
            }
//             if ($i == 3) exit;
            $i++;
        }
        // message utilisateur ( nb produits créés, nb produits MAJ, nb errors)
        print "<div>";
        print "import produit terminé :<br>";
        print $prodAdd." produits créés<br>";
        if (!empty($prodMAJ)) print $prodMAJ." produits mis à jour<br>";
        if (!empty($prodErr)) {
            print $prodErr." produits en erreur <br>";
            foreach ($errors as $msg) print $msg.'<br>';
        }
        print "</div>";
        
        $form = new TFormCore('auto', 'formImport', 'post', true);
        echo $form->hidden('action','import');
        echo $form->hidden('step', '2');
        echo $form->hidden('file', $file);
        
        print_titre('Etapes suivante : Import des tiers');
        if ($prodErr) $db->rollback();
        else $db->commit();
        echo $form->btsubmit('Etape suivante', 'bt_preview');
        $db->close();
        exit;
        
    }
    
}
elseif($step == "2") // Etape 2 : tiers à créer
{
    if(!empty($file))
    {
        $db->begin();
        // vérifier l'existance des extrafields
        require_once DOL_DOCUMENT_ROOT.'/core/class/extrafields.class.php';
        $extrafields = new ExtraFields($db);
        $target_extrafields=$extrafields->fetch_name_optionals_label('thirdparty');
        if(!in_array('NumFactor', $target_extrafields)) $res = $extrafields->addExtraField('numfactor', 'NumFactor', 'varchar', 0, 20, 'thirdparty',0,0,'','', 1, '', 1);
        
        $TCountry = array();
        $sql = "SELECT rowid, label FROM ".MAIN_DB_PREFIX."c_country WHERE 1=1";
        $res = $db->query($sql);
        
        if($res)
        {
            while ($obj = $db->fetch_object($res)) $TCountry[$obj->label] = $obj->rowid;
        }
        
        llxHeader('', 'import de tiers');
        
        $head = importatm_prepare_head($object);
        $picto = 'generic';
        dol_fiche_head($head, 'facturation', $langs->trans("Importatm"), 0, $picto);
        
        // chargement du fichier
        $f1 = fopen($file,'r') or die('Fichier illisible');
        
        $i = 0;
        $errors = array();
        $TTiers = array();
        $TCegid = array();
        $tiersMAJ = $tiersAdd = $tiersErr = 0;
        
        while($ligne = fgetcsv($f1,4096,';', '"') ) {
            if($i > 0)
            {
                if(!in_array(utf8_encode(trim($ligne[6])), $TTiers)) { // c'est le code cegid qui est la référence
                    // mapping du fichier (tiers)
                    $TTiers[] = utf8_encode(trim($ligne[6]));
                    $name = utf8_encode(trim($ligne[0]));
                    $client = 1; // client/Prospect = client
                    $code_compta = utf8_encode(trim($ligne[16]));
                    $status = 1; // ouvert ou clos
                    $address = utf8_encode(trim($ligne[2]));
                    $zip = utf8_encode(trim($ligne[3]));
                    $town = utf8_encode(trim($ligne[4]));
                    $cat = utf8_encode(trim($ligne[1]));
                    $dpt = utf8_encode(trim($ligne[7]));
                    $siret = utf8_encode(trim($ligne[11]));
                    $tva = utf8_encode(trim($ligne[12]));
                    $assujetti = utf8_encode(trim($ligne[17]));
                    $ape = utf8_encode(trim($ligne[13]));
                    $comm = utf8_encode(trim($ligne[8]));
                    $comm2 = utf8_encode(trim($ligne[9]));
                    $numfactor = utf8_encode(trim($ligne[14]));
                    $cegid = utf8_encode(trim($ligne[6]));
                    if (!in_array($cegid, $TCegid)) $TCegid[] = $cegid;
                    
                    $pays = ucfirst(strtolower(utf8_encode(trim($ligne[5]))));
                    $TTrad = array(
                        "Belgique" => "Belgium",
                        "The netherlands" => "Nederland",
                        "La reunion" =>"France",
                        "Guadeloupe" =>"France",
                        "Suisse" =>"Switzerland",
                        "Tunisie" =>"Tunisia",
                        "South africa" =>"Afrique du Sud",
                        "Emirats arabes unis" =>"United Arab Emirates",
                        "Poland" =>"Pologne",
                        "Czech republic" =>"République Tchèque",
                        "United kingdom" =>"United Kingdom",
                        "Principaute d'andorr" =>"Andorre",
                        "Espagne" =>"Spain",
                        "Usa" =>"United States",
                        "Norway" =>"Norvège",
                        "Norvege" =>"Norvège",
                        "Slovenie" =>"Slovénie",
                        "Hungary" =>"Hongrie",
                        "Guyane francaise" =>"Guyane française",
                        "Finland" =>"Finlande",
                        "Singapore" =>"Singapour",
                        "France" => "France"
                    );
                    
                    if ($pays == "La reunion" || $pays == "Guadeloupe") {
                        $dpt = substr($dpt, 0, 3);
                    }
                    elseif($name == 'ICM INDUSTRIE'
                        || $name == 'OMPR'
                        || $name == 'JOUSSEAU MECANO SOUDURE'
                        || $name == 'RSA'
                        || $name == 'SITES SAS'
                        || $name == 'Ventana Arudy') $pays = 'France';
                        
                    $fk_pays = $TCountry[$TTrad[$pays]];
                    
                    // fetch de chaque ref (pour une société, sa ref c'est s.nom)
                    $sql = "SELECT fk_object from llx_societe_extrafields WHERE cegid = '".$cegid."'";
                    $resql = $db->query($sql);
                    
                    if($resql) {
                        if($db->num_rows($resql)){
                            $obj = $db->fetch_object($resql);
                            $id = $obj->fk_object;
                            $ref = '';
                        } else {
                            $id = 20000000;
                            $ref = '';
                        }
                    } else {
                        $id = 0;
                        $ref = $name;
                    }
                    
                    $soc = new Societe($db);
                    $ret = $soc->fetch($id, $ref);
                    if(empty($ret)) // tiers non-trouvé
                    {
                        // créer les tiers manquants (sauvegarde les id des tiers créés)
                        $soc->nom = $name;
                        $soc->name = $name;
                        $soc->client = $client;
                        
                        //masque de numerotation
                        // Load object modCodeTiers
                        $module=(! empty($conf->global->SOCIETE_CODECLIENT_ADDON)?$conf->global->SOCIETE_CODECLIENT_ADDON:'mod_codeclient_leopard');
                        if (substr($module, 0, 15) == 'mod_codeclient_' && substr($module, -3) == 'php')
                        {
                            $module = substr($module, 0, dol_strlen($module)-4);
                        }
                        $dirsociete=array_merge(array('/core/modules/societe/'),$conf->modules_parts['societe']);
                        foreach ($dirsociete as $dirroot)
                        {
                            $res=dol_include_once($dirroot.$module.'.php');
                            if ($res) break;
                        }
                        $modCodeClient = new $module;
                        // Load object modCodeFournisseur
                        $module=(! empty($conf->global->SOCIETE_CODECLIENT_ADDON)?$conf->global->SOCIETE_CODECLIENT_ADDON:'mod_codeclient_leopard');
                        if (substr($module, 0, 15) == 'mod_codeclient_' && substr($module, -3) == 'php')
                        {
                            $module = substr($module, 0, dol_strlen($module)-4);
                        }
                        $dirsociete=array_merge(array('/core/modules/societe/'),$conf->modules_parts['societe']);
                        foreach ($dirsociete as $dirroot)
                        {
                            $res=dol_include_once($dirroot.$module.'.php');
                            if ($res) break;
                        }
                        $modCodeFournisseur = new $module;
                        $tmpcode = $soc->code_client;
                        if (empty($tmpcode) && ! empty($modCodeClient->code_auto)) $tmpcode=$modCodeClient->getNextValue($soc,0);
                        
                        $soc->code_client = dol_escape_htmltag($tmpcode);
                        $soc->code_compta = $code_compta;
                        
                        if (! empty($conf->fournisseur->enabled) && ! empty($user->rights->fournisseur->lire))
                        {
                            $tmpcode=$object->code_fournisseur;
                            if (empty($tmpcode) && ! empty($modCodeFournisseur->code_auto)) $tmpcode=$modCodeFournisseur->getNextValue($soc,1);
                            $soc->code_fournisseur = dol_escape_htmltag($tmpcode);
                        }
                        
                        $soc->status = $status; // ouvert ou clos
                        $soc->address = $address;
                        $soc->zip = $zip;
                        $soc->town = $town;
                        $soc->fk_pays = $fk_pays; // ATTENTION c'est un fk à rechercher dans le dico
                        $soc->state_id = (int) $dpt;
                        $soc->idprof2 = $siret;
                        $soc->idprof3 = $ape;
                        $soc->tva_intra = $tva;
                        $soc->tva_assuj = $assujetti;
                        $soc->commercial_id = $comm;
                        $soc->array_options['options_numfactor'] = $numfactor;
                        $soc->array_options['options_cegid'] = $cegid;
                        $soc->import_key = 'imp_'.date("Ymd"); // pour marquer les tiers créés à désactiver
                        $result = $soc->create($user);
                        if ($result < 0) {
                            $errors[] = 'tiers '.$name.' en erreur de création : ' . $soc->error.'<br><br>';
                            $tiersErr++;
                        } else $tiersAdd++;
                        if (!empty($comm2)) $soc->add_commercial($user, $comm2);
                        
                    }
                    elseif ($ret > 0) // passer le tiers en client
                    {
                        $soc->fetch_optionals();
                        $soc->client = 1;
                        $soc->update($soc->id, $user);
                        $tiersMAJ++;
                    }
                    else // erreur fetch
                    {
                        $errors[] = 'tiers '.$name.' en erreur : '.$ret.' - '.$soc->error.'<br>' . $cegid.'<br><br>';
                        $tiersErr++;
                    }
                }
                
            }
            $i++;
        }
        // message utilisateur ( nb tiers créés)
        print "<div>";
        print "import tiers terminé :<br>";
        print $tiersAdd." tiers créés sur ".count($TCegid)."<br>";
        if (!empty($tiersMAJ)) print $tiersMAJ." tiers mis à jour<br>";
        if (!empty($tiersErr)) {
            print $tiersErr." tiers en erreur <br>";
            foreach ($errors as $msg) print $msg.'<br>';
        }
        print "</div>";
        
        $form = new TFormCore('auto', 'formImport', 'post', true);
        echo $form->hidden('action','import');
        echo $form->hidden('step', '3');
        echo $form->hidden('file', $file);
        
        print_titre('Etapes suivante : Import des factures');
        
        echo $form->btsubmit('Etape suivante', 'bt_preview');
        
        if($tiersErr) $db->rollback();
        else $db->commit();
        $db->close();
        //var_dump($i);
        exit;
    }



}
elseif ($step == "3") // Etape 3 : création des factures
{
    if(!empty($file))
    {
        llxHeader('', 'import de tiers');
        
        $head = importatm_prepare_head($object);
        $picto = 'generic';
        dol_fiche_head($head, 'facturation', $langs->trans("Importatm"), 0, $picto);
        //$db->begin();
        // chargement du fichier
        $f1 = fopen($file,'r') or die('Fichier illisible');
        
        $errors = array();
        $TFactures = array();
        $TLignesFact = array();
        $lineAdded = $lineErr = $factMAJ = $factAdd = $factErr = $i = 0;
        $lastfact = '';
        /*
        while($ligne = fgetcsv($f1,4096,';', '"') ) {
            if($i > 0)
            {
                // mapping fichier (factures et lignes de facture)
                //                 var_dump($ligne); exit;
                $factnum = utf8_encode(trim($ligne[31]));
                if(!in_array($factnum, array_keys($TFactures))){
                    $factdate = utf8_encode(trim($ligne[30]));
                    $factstatus = 2;
                    $facttype = 0;
                    $factpaye = 1;
                    $assujetti = utf8_encode(trim($ligne[17]));
                    
                    $cegid = utf8_encode(trim($ligne[6]));
                    $factSocid = 0;
                    $sql = "SELECT fk_object from ".MAIN_DB_PREFIX."societe_extrafields WHERE cegid = '".$cegid."'";
                    $resql = $db->query($sql);
                    if($resql) {
                        if($db->num_rows($resql)){
                            $obj = $db->fetch_object($resql);
                            $factSocid = (int) $obj->fk_object;
                        }
                    }
                    
                    $fac = new Facture($db);
//                     $res = $fac->fetch(0,'', $factnum);
                    $sql2 = "SELECT rowid FROM ".MAIN_DB_PREFIX."facture WHERE ref_ext='".$factnum."'";
                    $resql2 = $db->query($sql2);
                    if($resql2 && !($db->num_rows($resql2))){
                        $fac->ref_ext = $factnum;
                        $fac->date = strtotime(str_replace('/', '-', $factdate));
                        $fac->socid = $factSocid;
                        $fac->statut = $factstatus;
                        $fac->type = $facttype;
                        $fac->paye = $factpaye;
                        $fac->import_key = 'imp_'.date("Ymd");
                        
                        $ret = $fac->create($user);
                        if($ret < 0)
                        {
                            $errors[] = 'facture '.$factnum.' en erreur de création : ' . $fac->error.'<br><br>';
                            $factErr++;
                        } else {
                            $TFactures[$factnum] = $ret;
                            $factAdd++;
                        }
                    } elseif ($db->num_rows($resql2)) {
                        $obj = $db->fetch_object($resql2);
                        $TFactures[$factnum] = $obj->rowid;
                        $fac->fetch($obj->rowid);
                    }
                    if($i > 100) exit('la');
//                     if(empty($res))
//                     {
//                         $fac->ref_ext = $factnum;
//                         $fac->date = strtotime(str_replace('/', '-', $factdate));
//                         $fac->socid = $factSocid;
//                         $fac->statut = $factstatus;
//                         $fac->type = $facttype;
//                         $fac->paye = $factpaye;
//                         $fac->import_key = 'imp_'.date("Ymd");
                        
//                         $ret = $fac->create($user);
//                         if($ret < 0)
//                         {
//                             $errors[] = 'facture '.$factnum.' en erreur de création : ' . $fac->error.'<br><br>';
//                             $factErr++;
//                         } else {
//                             $TFactures[$factnum] = $ret;
//                             $factAdd++;
//                         }
//                         //var_dump($ret, $factSocid, $cegid, $factdate, $fac->date); exit;
//                     } elseif ($res > 0) {
//                         $TFactures[$factnum] = $res;
//                         $factMAJ++;
//                         //var_dump($fac->id); exit;
//                     } else {
//                         $errors[] = 'facture '.$factnum.' en erreur : '.$res.' - '.$fac->error.'<br><br>';
//                         $factErr++;
//                     }
                }
            }
            $i++;
        }
        var_dump($TFactures);exit;*/
        
        while($ligne = fgetcsv($f1,4096,';', '"') ) {
            if($i > 0)
            {
                $fac = new Facture($db);
                // mapping fichier (factures et lignes de facture)
//                 var_dump($ligne); exit;
                $factnum = utf8_encode(trim($ligne[32]));
                $factdate = utf8_encode(trim($ligne[31]));
                $factstatus = 2;
                $facttype = 0;
                $factpaye = 1;
                $assujetti = utf8_encode(trim($ligne[17]));
                
                $cegid = utf8_encode(trim($ligne[6]));
                $factSocid = 0;
                $sql = "SELECT fk_object from llx_societe_extrafields WHERE cegid = '".$cegid."'";
                $resql = $db->query($sql);
                if($resql) {
                    if($db->num_rows($resql)){
                        $obj = $db->fetch_object($resql);
                        $factSocid = (int) $obj->fk_object;
                    }
                }
                
                if(!in_array($factnum, array_keys($TFactures))){
                    $res = $fac->fetch(0,'', $factnum);
                    if(empty($res))
                    {
                        $fac->ref_ext = $factnum;
                        $fac->date = strtotime(str_replace('/', '-', $factdate));
                        $fac->date_lim_reglement = strtotime(str_replace('/', '-', $factdate));
                        $fac->socid = $factSocid;
                        $fac->statut = $factstatus;
                        $fac->type = $facttype;
                        $fac->paye = $factpaye;
                        $fac->import_key = 'imp_'.date("Ymd");
                        
                        $ret = $fac->create($user);
                        if($ret < 0) 
                        {
                            $errors[] = 'facture '.$factnum.' en erreur de création : ' . $fac->error.' '.$cegid.'<br><br>';
                            $factErr++;
                        } else {
                            $TFactures[$factnum] = $ret;
                            $factAdd++;
                        }
                    } elseif ($res > 0) {
                        $factMAJ++;
                        $TFactures[$factnum] = $res;
                    } else {
                        $errors[] = 'facture '.$factnum.' en erreur : '.$res.' - '.$fac->error.'<br><br>';
                        $factErr++;
                    }
                } else $res = $fac->fetch($TFactures[$factnum]);
                
//             il nous faut récupérer toutes les infos de la facture pour la création
//                 - ref facture ($f->factnumber) S
//                 - date facture ($f->date) R
//                 - tiers ($f->socid) par le cegid G
//                 - statut ?
//                 - ref_client
//                 - type facture
//                 - notes privée et publique
//                 - condition de réglement et mode
//                 - remise_absolue
//                 - remise_percent
//                 - paye
//                 - model_pdf (crabe par défaut)
//                 - $fac->import_key = 'imp_'.date("Ymd");

                if ($fac->id)
                {
                    $lineTotalHT = (float) utf8_encode(str_replace(',', '.', trim($ligne[18])));
                    $lineQte = (float) utf8_encode(str_replace(',', '.', trim($ligne[20])));
                    $linePR = (!empty($lineQte)) ? round(((float) utf8_encode(str_replace(',', '.', trim($ligne[19])))) / $lineQte, 5) : 0;
                    $lineRef = utf8_encode(trim($ligne[21]));
                    $lineDesc = utf8_encode(trim($ligne[22]));
                    $linePUHT = (!empty($lineQte)) ? (float) $lineTotalHT / $lineQte : 0;
                    $assujetti = utf8_encode(trim($ligne[17]));
                    $lineVat = (empty($assujetti)) ? 0 : 20;
                    $lineTotalTva = ($lineTotalHT * $lineVat)/100;
                    $lineTotalTTC = $lineTotalHT + $lineTotalTva;
                    $linePUTTC = (!empty($lineQte)) ? $lineTotalTTC / $lineQte : 0;
                    
                    $sql = "SELECT rowid FROM ".MAIN_DB_PREFIX."product WHERE ref = '".$lineRef."'";
                    $resql = $db->query($sql);
                    $lineProduct=0;
                    if($resql && $db->num_rows($resql)) {
                        $obj = $db->fetch_object($resql);
                        $lineProduct = $obj->rowid;
                    }
//                     $prod = new Product($db);
//                     $prod->fetch(0, $lineRef);
//                     $lineProduct = $prod->id; // fetch le produit
                    $lineProductType = 0;
                    if(!empty($fac->id))
                    {
                        $fac->brouillon = 1;
                        $r = $fac->addline($lineDesc, $linePUHT, $lineQte, $lineVat, 0, 0, $lineProduct, 0, '', '', 0, 0, '', 'HT', $linePUTTC, $facttype, -1, 0, '', 0, 0, null, $linePR);
                        if ($r > 0) $lineAdded++;
                        else { 
                            $lineErr++;
                            $TlineErr[] = $r.' - ligne '.$i;
                        }
                    }
                } else {
                    $lineErr++;
                    $TlineErr[] = $db->error();
                }
                
//             il nous faut créer un tableau des lignes pour les réaffecter aux bonnes Factures et les infos lignes
//                 - fk_facture
//                 - fk_product
//                 - description
//                 - tva_tx 20 ou 0 suivant assujetti
//                 - qty
//                 - remise_persent
//                 - remise
//                 - subprice (PU HT)
//                 - total_ht
//                 - total_tva
//                 - total_ttc
//                 - product_type (0 produit / 1 service)
//                 - $line->import_key = 'imp_'.date("Ymd");

                if($i>1 && $lastfact !== $factnum)
                {
                    $fac->validate($user);
                    $fac->set_paid($user);
                    $fac->update($user);
                }
                
                $lastfact = $factnum;
                
            }
            $i++;
//             if($i > 100) break;
        }
        
    }
    
//     foreach ($TFactures as $k => $id)
//     {
//         $fac = new Facture($db);
//         $fac->fetch($id);
//         $fac->validate($user);
//         $fac->paye = 1;
//         $fac->update($user);
//     }

//     if($lineErr || $factErr) $db->rollback();
//     else $db->commit();
    
    // message utilisateur (nb factures créées, nb factures error)
    print "<div>";
    print "import factures terminé :<br>";
    print $factAdd." factures créées<br>";
    if (!empty($factMAJ)) print $factMAJ." factures mise à jour<br>";
    print $lineAdded . " lignes ajoutées aux factures<br>";
    
    if (!empty($factErr)) {
        print $factErr." factures en erreur <br>";
        foreach ($errors as $msg) print $msg.'<br><br>';
    }
    
    if (!empty($lineErr)) {
        print $lineErr." lignes en erreur <br>";
        foreach ($TlineErr as $msg) print $msg.'<br><br>';
    }
    print "</div>";
    
    $form = new TFormCore('auto', 'formImport', 'post', true);
    echo $form->hidden('action','import');
    echo $form->hidden('step', '4');
    echo $form->hidden('file', $file);
    
    print_titre('Etapes suivante : Désactiver les tiers créés pour l\'import');
    
    echo $form->btsubmit('Etape suivante', 'bt_preview');
    $db->close();
    exit;
}
elseif ($step == "4")// Etape 4 : désactiver les tiers créés
{
    $sql = 'UPDATE '.MAIN_DB_PREFIX.'societe SET status=0 WHERE import_key="imp_'.date("Ymd").'"';
    $res = $db->query($sql);
    // message utilisateur (nb tiers désactivé)
    if($res)
    {
        print "Import terminé.<BR>les tiers créés pour l'import ont été désactivés.";
    }
    
}
opcache_reset();
dol_fiche_end();
$db->close();
exit;
