<?php
/* <one line to give the program's name and a brief idea of what it does.>
 * Copyright (C) 2013 ATM Consulting <support@atm-consulting.fr>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/**
 *	\file		lib/importatm.lib.php
 *	\ingroup	importatm
 *	\brief		This file is an example module library
 *				Put some comments here
 */

function importatmAdminPrepareHead()
{
    global $langs, $conf;

    $langs->load("importatm@importatm");

    $h = 0;
    $head = array();

    $head[$h][0] = dol_buildpath("/importatm/admin/importatm_setup.php", 1);
    $head[$h][1] = $langs->trans("Settings");
    $head[$h][2] = 'settings';
    $h++;
    $head[$h][0] = dol_buildpath("/importatm/admin/about.php", 1);
    $head[$h][1] = $langs->trans("About");
    $head[$h][2] = 'about';
    $h++;

    // Show more tabs from modules
    // Entries must be declared in modules descriptor with line
    //$this->tabs = array(
    //	'entity:+tabname:Title:@importatm:/importatm/mypage.php?id=__ID__'
    //); // to add new tab
    //$this->tabs = array(
    //	'entity:-tabname:Title:@importatm:/importatm/mypage.php?id=__ID__'
    //); // to remove a tab
    complete_head_from_modules($conf, $langs, $object, $head, $h, 'importatm');

    return $head;
}

/**
 * Return array of tabs to used on pages for third parties cards.
 *
 * @param 	TImportPayment	$object		Object company shown
 * @return 	array				Array of tabs
 */
function importatm_prepare_head($object)
{
    global $db, $langs, $conf, $user;
    $h = 0;
    $head = array();
    $head[$h][0] = dol_buildpath('/importatm/card.php', 1);
    $head[$h][1] = $langs->trans("ImportatmCard");
    $head[$h][2] = 'card';
    $h++;
    
    $head[$h][0] = dol_buildpath('/importatm/script/import_stock.php', 1);
    $head[$h][1] = $langs->trans("Import stock initial");
    $head[$h][2] = 'stock';
    $h++;
    
    $head[$h][0] = dol_buildpath('/importatm/import_factures.php', 1);
    $head[$h][1] = $langs->trans("Import facturation");
    $head[$h][2] = 'facturation';
    $h++;
    
    
	
	// Show more tabs from modules
    // Entries must be declared in modules descriptor with line
    // $this->tabs = array('entity:+tabname:Title:@importpayment:/importpayment/mypage.php?id=__ID__');   to add new tab
    // $this->tabs = array('entity:-tabname:Title:@importpayment:/importpayment/mypage.php?id=__ID__');   to remove a tab
    complete_head_from_modules($conf,$langs,$object,$head,$h,'importatm');
	
	return $head;
}