<?php
require('../config.php');
dol_include_once('/importatm/class/importatm.class.php');
dol_include_once('/importatm/class/import_xlsx_custom.module.php');
dol_include_once('/product/stock/class/entrepot.class.php');
dol_include_once('/product/class/product.class.php');
dol_include_once('/importatm/lib/importatm.lib.php');

// Access control
if (! $user->admin) {
    accessforbidden();
}

// Parameters
$action = GETPOST('action', 'alpha');
$file = $_FILES['f1']['tmp_name'];

$etape = 1;

if($action === 'import' && !empty($file)) {
    $ic = new ImportXlsxCustom($db, 'importatm');
    $ic->import_open_file($file);
    
    $start = 5;
    $sheet = $ic->workbook->getSheet(0);
    $limit = $sheet->getHighestRow('A');
    
    $Tunits = array('U' => 1, 'ML' => 9, 'KG' => 6);
    
    $TImport = array();
    $TEntrepots = array();
    $TArticles = array();
    for ($i = $start; $i<$limit;$i++)
    {
        $TImport[$i]['entrepot'] = $sheet->getCell("A".$i)->getValue();
        if(!in_array($TImport[$i]['entrepot'], $TEntrepots)) $TEntrepots[] = $TImport[$i]['entrepot'];
        $TImport[$i]['lot'] = $sheet->getCell("C".$i)->getValue();
        $TImport[$i]['ref'] = $sheet->getCell("D".$i)->getValue();
        $TImport[$i]['desc'] = $sheet->getCell("E".$i)->getValue();
        $TImport[$i]['stock'] = $sheet->getCell("G".$i)->getValue();
        $TImport[$i]['unit'] = $sheet->getCell("H".$i)->getValue();
        $TImport[$i]['valeur'] = round($sheet->getCell("K".$i)->getValue()/$TImport[$i]['stock'], 3);
	$TImport[$i]['poids'] = round($sheet->getCell("L".$i)->getValue()*1000/$TImport[$i]['stock'], 2);
    }
    
    
    foreach ($TEntrepots as $e)
    {
        $ent = new Entrepot($db);
        $ret = $ent->fetch(0, $e);
        if($ret == 0){
            $ent->libelle = $e;
            $ent->lieu = $e;
            $ent->statut = 1;
            $res = $ent->create($user);
            print $e.'<br>';
        }
    }
    
    foreach ($TImport as $row)
    {
        print 'Produit '.$row['ref'];
        $prod = new Product($db);
        $ret = $prod->fetch(0, $row['ref']);
        if($ret == 0){
            $prod->ref = $row['ref'];
            $prod->label = $row['desc'];
            $prod->fk_unit = $Tunits[$row['unit']];
            $prod->status = 1;
            $prod->status_buy = 1;
            $prod->status_batch = 1;
            $prod->type = 0;
            $prod->array_options['options_type_remise'] = 'qte';
            $prod->array_options['options_unite_vente'] = 'unite';
            $prod->weight = $row['poids'];
            $prod->create($user);
            print ' créé<br>';
        } elseif($ret > 0) {
            if(empty($prod->status_batch)) $prod->status_batch = 1;
            $prod->fk_unit = $Tunits[$row['unit']];
            $prod->array_options['options_type_remise'] = 'qte';
            $prod->array_options['options_unite_vente'] = 'unite';
	    $prod->weight = $row['poids'];
            $prod->update($prod->id, $user);
            print ' trouvé<br>';
        }
/*        
        $ent = new Entrepot($db);
        $ret = $ent->fetch(0, $row['entrepot']);
        
        if($ret > 0){
            $prod->correct_stock_batch($user, $ent->id, $row['stock'], 0, "import stock", $row['valeur'], '', '', $row['lot']);
        } else {
            dol_syslog("erreur correction de stock produit ".$prod->id);
        }*/
    }
}

llxHeader('', 'import de stock');

$head = importatm_prepare_head($object);
$picto = 'generic';
dol_fiche_head($head, 'stock', $langs->trans("Importatm"), 0, $picto);

$form = new TFormCore('auto', 'formImport', 'post', true);
echo $form->hidden('action','import');

print_titre('Etape 1');

echo $form->fichier('Fichier à importer', 'f1', '', 50);
echo $form->btsubmit('importer', 'bt_preview');

dol_fiche_end();
