<?php

/**
 * Copyright © 2015 Marcos García de La Fuente <hola@marcosgdf.com>
 *
 * This file is part of Multismtp.
 *
 * Multismtp is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Multismtp is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Multismtp.  If not, see <http://www.gnu.org/licenses/>.
 */

//Handling custom/not custom directory
if (file_exists('../../main.inc.php')) {
	require '../../main.inc.php';
} else {
	require '../../../main.inc.php';
}

require_once DOL_DOCUMENT_ROOT.'/core/lib/admin.lib.php';

if (! $user->admin) accessforbidden();

$action = GETPOST('action');

if ($action == 'enable') {
	dolibarr_set_const($db, 'MULTISMTP_ALLOW_CHANGESERVER', '1', 'int', 0, '', $conf->entity);
} elseif ($action == 'disable') {
	dolibarr_set_const($db, 'MULTISMTP_ALLOW_CHANGESERVER', '0', 'int', 0, '', $conf->entity);
}

$langs->load('multismtp@multismtp');

llxHeader('',$langs->trans("Setup"));

print_fiche_titre('Multi SMTP','','setup');

if (!isset($conf->global->MAIN_ACTIVATE_UPDATESESSIONTRIGGER)) {
	print info_admin($langs->trans('TriggerNotActive'));
}

// Test if Dolibarr version ok
if (versiondolibarrarray() == array(3,7,0)) {
	print info_admin($langs->trans('NotWorking370'));
}


print '<p>'.$langs->trans('PreParameterAdvice').'</p>';

print '<table class="noborder" width="100%">';
print '<tr class="liste_titre"><td>'.$langs->trans("Parameter").'</td><td>'.$langs->trans("Value").'</td></tr>';

// Disable
print '<tr><td>'.$langs->trans("MULTISMTP_ALLOW_CHANGESERVER").'</td><td>';
if ($conf->global->MULTISMTP_ALLOW_CHANGESERVER == 1) {
	print '<a href="index.php?action=disable">'.img_picto($langs->trans("Enabled"),'switch_on').'</a>';
} else {
	print '<a href="index.php?action=enable">'.img_picto($langs->trans("Disabled"),'switch_off').'</a>';
}
print '</td></tr>';

print '</table>';

llxFooter();