<?php

/**
 * Copyright © 2015 Marcos García de La Fuente <hola@marcosgdf.com>
 *
 * This file is part of Multismtp.
 *
 * Multismtp is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Multismtp is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Multismtp.  If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * Replaces Dolibarr email configuration with the provided one
 *
 * @param DoliDB $db Database handler
 * @param User $user Logged user
 * @param Conf $conf Dolibarr configuration
 * @return bool
 * @throws Exception It will be logged to Syslog
 */
function replaceConfiguration(DoliDB &$db, User &$user, Conf &$conf, CMailFile &$object)
{
	dol_include_once('/multismtp/class/Multismtp.class.php');

	$multismtp = new Multismtp($db);

	try {
		if ($multismtp->fetch($user)) {

			if ($conf->global->MULTISMTP_ALLOW_CHANGESERVER == 1) {

				if ($multismtp->smtp_port !== null) {
					$conf->global->MAIN_MAIL_SMTP_PORT = $multismtp->smtp_port;
				}

				if ($multismtp->smtp_tls !== null) {
					$conf->global->MAIN_MAIL_EMAIL_TLS = (int)$multismtp->smtp_tls;
				}

				if ($multismtp->smtp_server) {
					$conf->global->MAIN_MAIL_SMTP_SERVER = $multismtp->smtp_server;
				}
			}

            if(!empty($multismtp->smtp_id)) {
             //   $conf->global->MAIN_MAIL_SENDMODE='smtps';
                if(empty($object->smtps)) {
                    
                 /*   $smtps = new SMTPs();
                    $smtps->setCharSet($conf->file->character_set_client);
        
                    $smtps->setSubject($this->encodetorfc2822($object->subject));
                    $smtps->setTO($this->getValidAddress($object->addr_to,0,1));
                    $smtps->setFrom($this->getValidAddress($object->addr_from,0,1));
        
                    if (! empty($object->html))
                    {
                        if (!empty($css))
                        {
                            $this->css = $css;
                            $this->buildCSS();
                        }
                        $msg = $this->html;
                        $msg = $this->checkIfHTML($msg);
                    }
        
                    if ($this->msgishtml) $smtps->setBodyContent($msg,'html');
                    else $smtps->setBodyContent($msg,'plain');
        
                    if ($this->atleastoneimage)
                    {
                        foreach ($this->images_encoded as $img)
                        {
                            $smtps->setImageInline($img['image_encoded'],$img['name'],$img['content_type'],$img['cid']);
                        }
                    }
        
                    if ($this->atleastonefile)
                    {
                        foreach ($filename_list as $i => $val)
                        {
                            $content=file_get_contents($filename_list[$i]);
                            $smtps->setAttachment($content,$mimefilename_list[$i],$mimetype_list[$i]);
                        }
                    }
        
                    $smtps->setCC($addr_cc);
                    $smtps->setBCC($addr_bcc);
                    $smtps->setErrorsTo($errors_to);
                    $smtps->setDeliveryReceipt($deliveryreceipt);*/
                }
            }

			$conf->global->MAIN_MAIL_SMTPS_ID = $multismtp->smtp_id;
			$conf->global->MAIN_MAIL_SMTPS_PW = $multismtp->smtp_pw;
            
            
            //var_dump($conf);exit;
            
		}
	} catch (Exception $e) {
		dol_syslog('[multismtp] '.$e->getMessage(), LOG_ERR);
		return false;
	}

	return true;
}